#!/usr/bin/python3
# -*- coding: utf-8 -*-
#from __future__ import print_function
_FonctionDuProgramme="Lire des infos exif\n\
https://pixees.fr/informatiquelycee/n_site/snt_photo_exif.html\n\
python3-exif:/usr/lib/python3/dist-packages/exifread/tags/exif.py\n\
php:https://www.php.net/manual/fr/function.exif-read-data.php"


#python3-pil:/usr/lib/python3/dist-packages/PIL/ExifTags.py\
#https://exifinfo.org/
_Version="1.0.0"
__version__="1.0.0"
#print("version:"+_Version)
import re
import os
##################### debug
import sys


import exifread
from exifread import *

# apt-get install python3-exif


dossier="/opt/CLASSES3"
import sys
if dossier not in sys.path:
    sys.path.append(dossier)
    
import re

_debug=True #_debug=False

_debug_Titres=True # 
_debug_Titres=False


_debug_all=True # 
_debug_all=False

if _debug_all==True:
	_debug_Titres=True


_FichierLog='/tmp/'+re.sub(".*/","",sys.argv[0])+'.log'
_Log=open(_FichierLog,'w')

def Tprint(*args, **kwargs):
	if _debug_Titres==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
def Dprint(*args, **kwargs):
	if _debug==True:
		print("==",*args, **kwargs)					
		print(*args,file=_Log)
		print('--------------------------')
		
def Aprint(*args, **kwargs):
	if _debug==True:
		print("==",*args, **kwargs)					
		print(*args,file=_Log)
		print('--------------------------')		
		
# # # # # # # # # # # # # # # # # # # debug
# ajout de doc + Tprint sed -e 's/^\(.*\)\(def\ \)\(.*\)$/\1\2\3\n\1\t"""-*\3"""\n\1\tTprint("\3")/' -i aa.py
class br_CDICO(dict):
	  def __missing__(self, key):
		  return ""


DicoFonctions=br_CDICO()
DicoClasses=br_CDICO()




############# br_BASH
import subprocess
import shlex
from subprocess import Popen,PIPE

def FBash2(chaines):
	#p1 = Popen(['mplayer', '-identify', '-vc', 'null', '-ac', 'null', '-frames', '0',initial], stdout=PIPE)
	p1 = Popen(chaines, stdout=PIPE)
	res=p1.communicate()[0]
	return res

def FBashOrganise(chaine):
	args = shlex.split(chaine)
	return args
	
############### br_BASH




## ## ## ## ## ## ## ## ## ## CFonctions

import csv
def DictToClefs(dico):
	return [clef for clef in dico.keys()]
def TabloDeDictToClefs(tablo):
	dico=dict()
	for tmp in tablo:
		dico.update(tmp)
	return DictToClefs(dico)
def ToCsv(tablo,fichier='/tmp/CXml.csv',*Clefs,ID=True):
	"""ToCsv(tablo,fichier='/tmp/CXml.csv',*Clefs) : nécessite tablo=[dico1,dico2...] avec dico[cle]=valeur\
	par exemple ToCsv(TabloDeDict,"/tmp/a.csv",TabloDeDictToClefs(TabloDeDict)]
	"""
	Champs=[]
	if ID==True:
		Champs=["id"]
	if len(Clefs)!=0:
		Champs=Champs+list(Clefs)[0]
	#print(Champs)
	
	with open(fichier, 'w', newline='') as csvfile:
		fieldnames = Champs
		writer = csv.DictWriter(csvfile, fieldnames=fieldnames,delimiter="#")
		writer.writeheader()
		for no,dico in enumerate(tablo):
			ID=dict()
			ID["id"]=str(no)			
			ID.update(dico)
			writer.writerow(ID)
		"""	
		writer.writerow({'first_name': 'Baked', 'last_name': 'Beans'})
		writer.writerow({'first_name': 'Lovely', 'last_name': 'Spam'})
		writer.writerow({'first_name': 'Wonderful', 'last_name': 'Spam'})
		"""
	#return res	
#1.0.5 def Md5(fname):	''' str Md5('nom fich') '''
def Md5(fname,Impossible="time"):	
	''' Md5('nom fich' , Impossible="time" ) 
	retourn str||time()||\"\" '''
	import hashlib
	hash_md5 = hashlib.md5()
	try:
		with open(fname, "rb") as f:
			for chunk in iter(lambda: f.read(4096), b""):
				hash_md5.update(chunk)
		return hash_md5.hexdigest()
	except:
		if Impossible=="time":
			from time import time
			return str(time())
		else:
			return ""

## ## ## ## ## ## ## ## ## ## CFonctions





class CFichierCanonEOS20D(object):
	""" CLASSE CFichierCanonEOS20D(object)"""
	def __init__(self,fich="/media/mac689Go/E4/PHOTOS/IMG_4842.JPG"):
		""" CFichierCanonEOS20D.__init__(fich) """
		Tprint("CFichierCanonEOS20D.__init__()")
		
		self.init()
		
		self._NomFichier=fich
		
		
		
		
		
		self.infos()
		
		
	
	def init(self):
		""" CFichierCanonEOS20D.init() """
		Tprint("CFichierCanonEOS20D.init()")
		self._NomFichier = None
		
		self._infos= br_CDICO()
		
		self._Python3Exif = br_CDICO()
		#self._infos['Python3Exif']=br_CDICO()
		
		self._Php7Exif = br_CDICO()
		#self._infos['_Php7Exif']=br_CDICO()
		
		self._BashExiv2 = br_CDICO()
		#self._infos['_BashExiv2']=br_CDICO()		
		
		
	def infos(self):
		
		self._infos['NomFichier']=self._NomFichier
		######## par python3.exif		######## 		######## 
		
		f=open(self._NomFichier,"rb")
		tmp=exifread.process_file(f)
		for u,v in tmp.items():
			self._Python3Exif[u]=v
		#self._Python3Exif=exifread.process_file(f)
		#ISO
		self._infos['iso']=str(self._Python3Exif["EXIF ISOSpeedRatings"])
		
		#OUVERTURE
		self._infos['ouverture']=str(eval(str(self._Python3Exif["EXIF FNumber"])))
		
		'''
		self._infos['Python3Exif']['EXIF FNumber']=eval(str(self._Python3Exif["EXIF FNumber"]))
		self._infos['Python3Exif']['EXIF ApertureValue']=eval(str(self._Python3Exif["EXIF ApertureValue"]))
		'''
		
		#VITESSE
		self._infos['vitesse']= str(self._Python3Exif["EXIF ExposureTime"])
		
		#DIMENSIONS
		self._infos['largeur']= str(self._Python3Exif["EXIF ExifImageWidth"])#3504
		self._infos['hauteur']= str(self._Python3Exif["EXIF ExifImageLength"])#2336
		
		
		#DATE TIME
		tmp=str(self._Python3Exif["EXIF DateTimeOriginal"])#2006:05:07 02:01:14
		self._infos['date']=re.sub(':','',tmp.split(" ")[0])#20060507
		self._infos['heure']=re.sub(':','',tmp.split(" ")[1])#020114
		
		'''
		self._infos['Python3Exif']["EXIF DateTimeOriginal"]= str(self._Python3Exif["EXIF DateTimeOriginal"])#2006:05:07 02:01:14
		self._infos['Python3Exif']['Image DateTime']= str(self._Python3Exif["Image DateTime"])#2006:05:07 02:01:14
		self._infos['Python3Exif']['EXIF DateTimeDigitized']= str(self._Python3Exif["EXIF DateTimeDigitized"])#2006:05:07 02:01:14
		'''
		
		#FOCALE
		self._infos['focale']= str(self._Python3Exif["EXIF FocalLength"])#50
		'''
		self._infos['Python3Exif']["EXIF FocalLength"]= str(self._Python3Exif["EXIF FocalLength"])#50
		self._infos['Python3Exif']["MakerNote LongFocalLengthOfLensInFocalUnits"]= str(self._Python3Exif["MakerNote LongFocalLengthOfLensInFocalUnits"])#50
		self._infos['Python3Exif']["MakerNote ShortFocalLengthOfLensInFocalUnits"]= str(self._Python3Exif["MakerNote ShortFocalLengthOfLensInFocalUnits"])#50
		'''

		#orientation
		self._infos['orientation']= str(self._Python3Exif["Image Orientation"])#Horizontal (normal)
		


		f.close()
		
		

		####### par php		####### 		####### 		####### 
								
		#CommandePHP='$exif = exif_read_data("'+self._NomFichier+'", 0, true);foreach ($exif as $key => $section) {foreach ($section as $name => $val) {echo "$key::$name=$val#";}}'
		CommandePHP='$exif = exif_read_data("'+self._NomFichier+'", 0, true);foreach ($exif as $key => $section){foreach ($section as $name => $val){if (is_array($val)){echo "$key::$name=".serialize($val)."#";}else{echo "$key::$name=$val#";}}}'
		#self._Php7Exif = br_CDICO()
		#self._infos['_Php7Exif']=br_CDICO()	
		
		
		PHPtmp=str(FBash2(FBashOrganise("php -r '"+CommandePHP+"'"))).split('#')[0:-1]
		for info in PHPtmp:
			valeur=(str(info).split('='))[1]
			cleTMP=(str(info).split('='))[0].split("::")
			cle=cleTMP[0]+"."+cleTMP[1]
			if 'FILE.FileName' in cle:#pour éviter b'FILE.FileName'
				cle='FILE.FileName'
			self._Php7Exif[cle]=valeur
		
		
		
		######### par exiv2 de bash		
		
		CommandeBash='exiv2 -pt "'+self._NomFichier+'"'
		res=FBash2(FBashOrganise(CommandeBash))

		a=str(res).split('\\n')	
		for u in a[0:-1]:#-1 pour éviter ['']
			tmp=re.split(r'[ ]+',u,3)
			
			self._BashExiv2[tmp[0]]=tmp[3]#Exif.Image.DateTime                          Ascii      20  2005:08:29 13:26:23
			
		
		
		#numero d fichier 'Exif.CanonFi.FileNumber': '113-1351'===01351 300-0008===20008
		tmp=str(self._BashExiv2["Exif.CanonFi.FileNumber"])#300-0008===20008
		if tmp!="":
			self._infos['numero']=str(int(re.sub("^([0-9])[0-9][0-9]-([0-9][0-9][0-9][0-9])","\g<1>\g<2>",tmp))-10000)
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
	def chercheIndex(self,texte):
		Aprint("recherche dans l'index de "+texte)
		Exif=br_CDICO()
		Exif.update(self._Python3Exif)
		Exif.update(self._Php7Exif)
		Exif.update(self._BashExiv2)
		
		res=br_CDICO()
		for u,v in Exif.items():
			try:
				if texte.lower() in u:
					print(u,v)
					print(str(u),str(v))
					res[u]=v
			except:
				pass	
			if texte.lower() in str(u):
				print(u,v)
				print(str(u),str(v))
				res[u]=v
		
		Aprint("le résultat est ",res)
		
		return res
		
		
		
	def chercheValeur(self,texte):
		Aprint("recherche dans la valeur de "+texte)
		Exif=br_CDICO()
		Exif.update(self._Python3Exif)
		Exif.update(self._Php7Exif)
		Exif.update(self._BashExiv2)
		
		res=br_CDICO()
		for u,v in Exif.items():
			try:
				if texte.lower() in v:
					#print(u,v)
					#print(str(u),str(v))
					res[u]=v
			except:
				pass
			if texte.lower() in str(v):
				#print(u,v)
				#print(str(u),str(v))
				res[u]=v
		Aprint("le résultat est ",res)
		return res
		
	def cherche(self,texte):
		
		res=self.chercheIndex(texte)
		
		
		res.update(self.chercheValeur(texte))
	
		#print(res)
	
		return res
			




























import CFichiersRepertoires
from CFichiersRepertoires import *


global main


if __name__ == "__main__":
	Dprint("Le programme lancé est "+sys.argv[0])
	
	#a=CFichierXml('FichiersAnnexes/a.gpx')
	
	
	
		
	
	
	print(_FonctionDuProgramme)




	#ListeFich=CRepertoires('/media/mac689Go/E4/PHOTOS/0000s/0262_0264a0269_0273_0275a0276_0278_mouches_fleurs').Contenu()
	ListeFich=CRepertoires('/media/mac689Go/E4/PHOTOS/0000s/0661_664_668a671_675a676_681_685_688a690').Contenu()
	#print(ListeFich)
	
	TabloDeDict=[]
	for fich in ListeFich:
		if fich._FichExt.lower()=="jpg":
			print(fich._fich)
			a=CFichierCanonEOS20D(fich._fich)
			TabloDeDict.append(dict([('md5',Md5(fich._fich))]).update(a._infos))
	ToCsv(TabloDeDict,"/tmp/a.csv",TabloDeDictToClefs(TabloDeDict))
	
	
	
	
	
	
	
	a=CFichierCanonEOS20D("/tmp/_MG_0008.JPG")
	#print(a._Python3Exif)
	

	"""	

	print(type(a._Php7Exif))
	for u,v in a._Php7Exif.items():
		try:
			print(u,"=",v)
		except:
			pass	
	"""
	
	"""
	CommandeBash='exiv2 -pt /tmp/a.JPG'
	res=FBash2(FBashOrganise(CommandeBash))
	#print(type(str(res)))
	
	a=str(res).split('\\n')

	
	print(res[0:45])
	print(res[0:66])
	for i in res[0:20]:
		print(i)

	
	
	
	print(res[0])
	print(str(res)[65])
	print(re.split(r'[ ]+',a[0],4))
	for u in a:
		print(re.split(r'[ ]+',u,3))
	
	
	
	a=str(res).split('\\n')	
	for u in a:
		print(re.split(r'[ ]+',u,3))
	exit()	
	"""	
	
	res=a.cherche("0008")

	print(a._infos)
	TabloDeDict=[a._infos]
	ToCsv(TabloDeDict,"/tmp/aa.csv",TabloDeDictToClefs(TabloDeDict))






## ## ## ## a._Python3Exif.items() : ## ## ## ## ## ## ## ## ## ## ## 
"""
Image Model = Canon EOS 20D
MakerNote ISO = Unknown
EXIF FocalPlaneYResolution = 233600/59
Thumbnail Compression = JPEG (old-style)
MakerNote FocusMode = Single
MakerNote Tag 0x000F = [38, 0, 256, 512, 768, 1024, 1280, 1536, 1792, 2048, 2304, 2560, 2816, 3072, 3328, 3584, 3840, 4096, 4352]
MakerNote WhiteBalance = Auto
MakerNote FlashMode = Flash Not Fired
Thumbnail JPEGInterchangeFormatLength = 6083
MakerNote FocalType = Unknown
MakerNote WBBracketValueGM = 0
MakerNote ImageType = Canon EOS 20D
EXIF Flash = Flash did not fire, compulsory flash mode
MakerNote FlashBias = 0 EV
EXIF ExifVersion = 0221
MakerNote LensType = 65535
MakerNote RawJpgSize = Unknown
MakerNote ThumbnailImageValidArea = [0, 159, 7, 112]
MakerNote WBBracketMode = Off
MakerNote Tag 0x4003 = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
MakerNote ShortFocalLengthOfLensInFocalUnits = 50
MakerNote ExposureMode = Av-priority
MakerNote DigitalZoom = None
MakerNote SelfTimer = 0
EXIF ComponentsConfiguration = YCbCr
EXIF UserComment = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
EXIF ExposureBiasValue = 0
Image DateTime = 2005:08:09 18:13:53
MakerNote Tag 0x00A0 = [28, 0, 0, 0, 0, 0, 0, 0, 32768, 5200, 0, 0, 0, 0]
MakerNote Tag 0x00E0 = [34, 3596, 2360, 1, 1, 84, 19, 3587, 2354, 0, 0, 0, 0, 0, 0, 0, 0]
MakerNote ImageSize = Large
MakerNote ToningEffect = None
EXIF ExifImageWidth = 3504
JPEGThumbnail = b'\xff\xd8\xff\xc4\x01\xa2\x00\x00\x01\x05\x01\x01\x01\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x01\x00\x03\x01\x01\x01\x01\x01\x01\x01\x01\x01\x00\x00\x00\x00\x00\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x10\x00\x02\x01\x03\x03\x02\x04\x03\x05\x05\x04\x04\x00\x00\x01}\x01\x02\x03\x00\x04\x11\x05\x12!1A\x06\x13Qa\x07"q\x142\x81\x91\xa1\x08#B\xb1\xc1\x15R\xd1\xf0$3br\x82\t\n\x16\x17\x18\x19\x1a%&\'()*456789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\x83\x84\x85\x86\x87\x88\x89\x8a\x92\x93\x94\x95\x96\x97\x98\x99\x9a\xa2\xa3\xa4\xa5\xa6\xa7\xa8\xa9\xaa\xb2\xb3\xb4\xb5\xb6\xb7\xb8\xb9\xba\xc2\xc3\xc4\xc5\xc6\xc7\xc8\xc9\xca\xd2\xd3\xd4\xd5\xd6\xd7\xd8\xd9\xda\xe1\xe2\xe3\xe4\xe5\xe6\xe7\xe8\xe9\xea\xf1\xf2\xf3\xf4\xf5\xf6\xf7\xf8\xf9\xfa\x11\x00\x02\x01\x02\x04\x04\x03\x04\x07\x05\x04\x04\x00\x01\x02w\x00\x01\x02\x03\x11\x04\x05!1\x06\x12AQ\x07aq\x13"2\x81\x08\x14B\x91\xa1\xb1\xc1\t#3R\xf0\x15br\xd1\n\x16$4\xe1%\xf1\x17\x18\x19\x1a&\'()*56789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x92\x93\x94\x95\x96\x97\x98\x99\x9a\xa2\xa3\xa4\xa5\xa6\xa7\xa8\xa9\xaa\xb2\xb3\xb4\xb5\xb6\xb7\xb8\xb9\xba\xc2\xc3\xc4\xc5\xc6\xc7\xc8\xc9\xca\xd2\xd3\xd4\xd5\xd6\xd7\xd8\xd9\xda\xe2\xe3\xe4\xe5\xe6\xe7\xe8\xe9\xea\xf2\xf3\xf4\xf5\xf6\xf7\xf8\xf9\xfa\xff\xdb\x00\x84\x00\x03\x02\x02\x03\x02\x02\x03\x03\x02\x03\x03\x03\x03\x04\x05\x08\x05\x05\x04\x04\x05\t\x07\x07\x06\x08\x0b\n\x0c\x0b\x0b\n\x0b\n\x0c\x0e\x11\x0f\x0c\r\x11\r\r\x0b\x0f\x15\x0f\x11\x12\x13\x14\x14\x14\x0c\x0f\x15\x17\x15\x13\x17\x11\x13\x14\x13\x01\x03\x03\x03\x05\x04\x05\t\x05\x05\t\x13\r\x0b\r\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\xff\xc0\x00\x11\x08\x00x\x00\xa0\x03\x01!\x00\x02\x11\x01\x03\x11\x01\xff\xda\x00\x0c\x03\x01\x00\x02\x11\x03\x11\x00?\x00\xfc\xee?\xb3\xb7\xc4\xd1\xd7\xc0\xde$\xff\x00\xc0F\xa8\xdf\xf6~\xf8\x91\x11\xc4\x9e\n\xf1\x12\xfdm\x1a\xb5Tf\xfa\x11\xedb\xba\x8c\x7f\x80\x9f\x11Pe\xfc\x19\xe2\x10=M\xabUY~\x0b\xf8\xea\x03\x89\xbc)\xad\xa1\xff\x00j\xd9\xaa\xa3\x85\xab-\xa2\xc8x\x8aky\x10\x9f\x84\x9e3\x1d|3\xac\x7f\xe0;Q\xff\x00\n\x97\xc6\x7f\xf4,\xeb\x1f\xf8\x0e\xd5\xa7\xd41\x1f\xc8\xfe\xe2>\xbbG\xf9\xd0\x7f\xc2\xa4\xf1\x9f\xfd\x0b:\xc7\xfd\xf8j\x07\xc2?\x19\x9e\x9e\x19\xd6?\xf0\x1d\xa9\xfdC\x11\xfc\x8f\xee\x17\xd7h\xff\x00:\x15~\x10\xf8\xd1\x8e\x17\xc3\x1a\xc9?\xf5\xee\xd5#\xfc\x1a\xf1\xccC\xf7\x9e\x15\xd6\xd7>\xb6\xedK\xea5\xff\x00\x91\xfd\xc3\xfa\xe5\x1f\xe7B\'\xc1\xcf\x1b\xc8p\x9e\x16\xd6\x8f\xd2\xdd\xa9\xdf\xf0\xa6|r\t\x1f\xf0\x8aky\x1f\xf4\xee\xd4}F\xbf\xf20\xfa\xe5\x1f\xe6CG\xc1\xcf\x1b\x93\x81\xe1mk>\x9fgj\x9e\x1f\x81\xde?\xb9lA\xe1\rzC\xe8\xb6\xcci<\x15u\xbc\x18\xd6.\x93\xdaH\x9eO\xd9\xff\x00\xe2<K\x99|\x15\xe2\x15\x03\xb9\xb5j\xaa\xbf\x05<x\xed\xb5<%\xae\x13\xd3\x02\xd9\xa9,\x1dg\xb4X\xde&\x92\xdeH\xb4\x9f\x00>#\xc8>O\x05x\x88\xfd-\x1a\xa4\xff\x00\x86y\xf8\x96\x06O\x81\xfcI\x8f_\xb25K\xc3U_e\x94\xabA\xf5\x1a\x7fg\xbf\x89@d\xf8#\xc4\x7f\xf8\x08\xd4\x7f\xc3=\xfcJ\xce?\xe1\x08\xf1\x1e\x7f\xeb\xd1\xa8\xfa\xb5O\xe5c\xf6\xd0\xee~\xb1\xea\x104\'<\xe3\xd6\xb1.\xe4\x8aL\xac\xb9\xc8\xef^\xad-O6n\xdb\x99wrf6T\xe4\x0e\x86\xb9\x1f\x10\xc1#/\xef6\x12G\x04W\xa7\x87\xd1\x9e}}Q\xc7\xb2\xe1\x88\xa0%z\xe8\xf2\xdb\x14G\xcd^\xb3\xb7\\~\xf9\x0bg\xd3\xb5\x12\xd8\x16\xe2\x9bm\x93eP\xec\x1d)\xd7.\xee\xa7\xcc\x04\x01\xd0\x1a\x9d\xc7\xb0\xdbY\x0c@\x97\xce\x00\xe2\xa5\x8e\xef/\xcfOZn7\x05+\x12\xc3\xb5\xa4\x07v\x05ni\xba\xa2[\xed\x10\x03\xb8uc\xda\xb2\xa9\x1b\xa3XJ\xc35\xef\x10Kw"\xc7\x1b\xb1\x18\xc1\x02\xb4<5\xa5\x99\x88\x91\x97\x1c\xf1\xba\xb3\x94y k\x06\xe73\xbc\xb6\x80D\x8a\x08\x19\xc5Gy~\xaa\xc2(r\xc4u"\xbc\xeb]\x9e\x8f5\x91ZY\xd5\x17\xcc\x94\x1cv\x1e\xf5]\xae\x99\x81e\x0e\t\xed\xe9U\xca.s\xbe\xbf\xb1gO\xde/\x15\xc8jvb2\xed\x02\x83\xea\ry\xb4Y\xd5Qhs\xb7\xf7\x91[@\xf9;[\x9e\x1b\xb5aZ\\Ez\xb25\xc3#c8\x00\xd7\xabJ.\xd7<\xba\xb2\\\xd68\xeb\x88\xc2\xcc\xe1zd\xe2\xa4\x82\x01"\xb7r\x06k\xd5\xe8y\xbb\xb0\x8a\xdfq!\x87\xe3^\x99\xe1\x1f\x0b\xd9]Y\xa3\xcb\x1e\xf96\xf2\x0f#\xff\x00\xaf\\\xd8\xa9\xb8\xc7C\xa3\r\x05)jG\xe2}\x12\x01"\xf9k\xb28\xc6\n(\xe8=\xab\x88\xd5\x84L\xe1m\xd7\x08\xbe\xbdI\xa9\xc3I\xbb\x15\x88\x8aM\x99\xacI<\xe6\xa5\xb7\\d\x9cq\xeb]\xcfc\x91n<\xa7\x98\xecT\xf5\xa9a\xf3\\\xed\x88t\x1d\xaa_\x99H\xe9\xf4\r*0\xfem\xc8\xdd\x91\xce\xee\x95\xd3\xdb\xbc6H\xcc\xa5}\x86k\x82\xb4\x9c\x99\xdfE(\xab\x8d\xbb\xd7w\xc2\xc2\xd8\xe4\x81\x8c\x8a\xa9aiv\xd2Iq9\xdc\xad\x8c)\xa8QQZ\x9a99\xbd\x0b\x13]\xab)F\x07 \xf4\xa6\xc3\x9e\xe4\xb1>\x9d\xaamdU\xee\xcfW\xb9c*\x91\xda\xb8o\x12\x07\xb3\x91\x9a\x15f\x04r\x05y\x18u\xa9\xdfU\xe9s\xcf\xbcCa{\xa9\xdb}\xa25.9,\x17\xa8\xaeW\xc9\x9a\x00N\x19k\xe80\xf2\x8f/)\xe1WO\x9a\xe4\x0e\xbb\x9b&\xa5\xb6\x91\xa0\x93ru\xe9]v\xd0\xe6\xbe\xa7Y\xe1\xfd:-F@fE\x03?t\x0e\xf5\xdcCr\xbaE\xb8D\x1bv\xf6\x15\xe6Wm\xbeS\xd1\xc3\xa4\x971\xcf\xebZ\x9f\xdbo\t\xb5vB\x06_=\x08\xae>\xe2\x1f>\xe5\xf0\xc0)<\x0cWE\x05\xcaaZ\\\xcc|\xba,p\xc2f\x95\xce1\xdf\x8c\xd6hL\xbbm\xe1GLWL%\xccs\xca6,\xc5dX\x06S\x8c\xf6\xa9\xa5-al\xcb+\x08\x8d\xc0\t\x1c\xbbIP\xc4\xf0\t\xc6\x01\xf4\xcdr\xe3\xb1\x1e\xc6\x94\xa4mF\x17\x925m\xe4\xbb\x16\xd1\xdb\x89KJ\t\x03w\x0cFx\xe9\xf5\x15\xaa\x9e\x1d\xd4.\xa3Au*\xa2u*:\xd7\x0e\x03\x16\xaa\xd2N[\xad\x1f\xf9\x9d2\xa7\'-67\xf4\xcd\x0e+{u\x05FGv\xab\xf7\xae\x96\xf0a\x00\xf4\xad%\'&tB*10\x84-%\xc3\xb4\x83n\xefN\x84U\xd8\xad\x83m;\xb6\xe3\xb8\xab\x93\x14U\xcfQ\x9e%\x8b;k3P\xb4\x86\xe2\x16iUN;W\x87\x03\xd1g\'\xa8Y\xc2bae\xb7\x9e\xab^{\xaf\xd9\x08\xe7b\x88\xc3p#n;\xd7\xaf\x85vz\x9ef-+\x1c\xac\xd1\x08\xdf\x02\x9a\xab\x83^\xc2<\x93\xd1<(\xd0Gc\x1c\x92\x0f\x9cw>\xb5\xa7=\xca\xdcO\xf3(c\xeb\xda\xbc\xc9\xaf}\xb3\xd1\x84\x97"F\x0e\xaa\xf0\xda\xc8\x91Z\x82\xd2;\x12N{zUu\xd3\xe1\xdc\xcf\'.\xa3\xa8\x1d+et\xaeb\xd2n\xc6N\xa7;\xdf\\\x18\xe1\x04G\x1f\x18\xa4M/\xcb#s \x1d\xf9\xeb])\xf2\xa4\x8c_\xbc\xee\\\x9a\xc5\x89U\x80\x1d\xc4t\x15\x8d\xe2M\x165\xbd\x8a\x1dG"TQ4\x0cT\x9eF\t\x19\x07#\x80~\xbfZ\xf1\xf3\x89^\x85\xbc\xce\x8a\t\xa9\\\xd9\xba_\xb6\xc4\x17O\x965\x96\xe26\x81Y\x9b!d#\xbe=\ru\x1e\x05\xf1\x04\xba\xcf\x82\xb4\x8b\xfd^\xd2{[\xfb\x8bdi\xe1\x90a\x83\xe3\x04\x8e\xbc\x1e\xa3\xd8\x8a\xf2\xf2\xb4\xef$w&\xb9n\xcbZ\x8e\xaam\xc9Q\x94\x07\xa0\xf5\xa8\xed/\xcd\xfb\xacyR\x01\xcek\xdfP\xd2\xe6.\xa5\xdd\x8b\xb7\x86\x19\xb0\x90\xaa\x89\x07\xf1\x0e\xd8\xaa\x8c\xed\xbc\xc2\xfb\xb3\xd40\xf4\xa9K\xb9m\xeb\xa1\xe8\xd7\x1a\x8a\xb8\xcb?_Jb\\\t\xc1F\x04\x8ct\xc5x\xea6Gu\xceo\xc40\x8b\x07Yb@\xb9\xe0\x81\xfaW#\xe2In,\xed\xa1y\x966\x12\x13\xc0^\x7f:\xf40\xea\xf68q\x0e\xd7\xb1\xc0\\\r\xf2\x12)\x89\x1e\xe3\x81\xd6\xbd\xb5\xb1\xe3\xbd\xcd\xdd.\xe9\xe2\x8dc \xe0q\x8a\xdc\xf3\xa40\xb6\x06\xd6\xed\x93\\\x95"\xaet\xd3n\xc6\x1cQ\x19\xafw\xb3\xed=\xb2j\xf4\xecJ2\xc4\xc4dcwL\x9a\xb7\xb9\x0bC\x06F\x92\x17*\x0e\x0f\xb5Mi\x14\xb7\x92\x85\x88\xfc\xde\xf5\xbb\xb2W2Wn\xc7S\xa4\xe9\xb7\x11\xca\x1aQ\xb9\xbag\x19\xc5g|R\xd7|;\xa4Ke\x1e\xb5\xa8\xa4\x17\xb1\x95\x91\xa3\x89K\xc8W\x1c\r\xa3$s\x8c7A\x93\xeb^\x0emR*\x9b\xbfS\xd3\xc3\xc1\xda\xc7\x9e\xc9\xf1\x87\xc2\n\x16\x13=\xfa&I<D\xe1r0~T9?\x80\'\x8e\xf5\xeaZ\x07\xc4/\x07j\x96\ty\xa6k\xdai\x85\x15\x8bF\xd3*2\x05\x00\x9c\xa9 \x80\x06;p+\xcb\xca\xf1)7\x07\xd4\xe9\x95&\x91\x85\xe0\x0f\x88\xda\x7f\xc5\x9f\x14x\xafN\xb4\xb4\x11Yh\xd2D \xbd\x8ep\xdfh\x0f\xbc\x02\x14\x0c\x01\xf2\x13\xd7<\xe0\x8c\x8a\xeb\xe7\xb4:|G\xecC\x8c\xf2OZ\xf7p\xf5\xfd\xac|\x8c\xabQP\x95\xfa\x95\xad&\x90\xdcp\x08\xcfS[\x12\xba\xc5\x07\x9c\xe4\x1d\xbd\xeby\xa3:oCwJ&\xe0\x02\xdc\xe4\xf1\xcdm\x12a_\xdd\xaeO\xady2Z\xd8\xee\x8b\xba\xb9V\xefHmB2\xf7\x07\r\x9f\x96\xb9\x8f\x14\xda\xc4t\xf9"\x967gPv\x90:\x1a\xd6\x94\xb5I\x19V^\xeb\xb9\xe4\xd3\xc2\xc9+\t\x01\x0c:\x83LU\xda\xd9\x15\xf4\x0bc\xc2e\xbb{\xb7\x89\xb7\x1eqZQ\xea\xeb0U\x90\x11\xd8\x91\xda\xb2\x9d;\xec\\gc,\xca\xcb1e\xea\x0ej\xd4w\x0f!\x05\xf2@=\x05h\xe2B\x96\xa4R\xdb4\xb2\x93\x1a\xf5\xe6\xb9\x0f\x8a\xf2kz\x17\x84m\xb5/\x0c\xde\xcdgt\xba\x8400\x89\x15\xcc\x8a\xc4\x82\xb8?\x81\x18#8\xc7z\xe7\xc5\xcd\xc6\x8c\xb9^\xb67\xc3EJ\xacS\xd8\xad\xae~\xd2^#\xd1t\xdb\xdb\x9d#G\xd1\xa2\x8a\xcc2J\xd7L\xec\xe5\x9d\xb6\xc4\xc1A\x1bq\xdc\x1c\x82q\xc8\xcdy\x0e\x95g\xab\xf8\x83X:\x8e\xbf\xab\xad\xde\xad$\x88d\xb21\x86\x96M\xe0nl08lg\xe6\xc7\x07\xa601\xf1\xd9\x9e"RiH\xfa<6\x1e-X\xd7\xd7</\xf6\xeb\xab\xa1\xac6\xa14\xd12Eo\x1d\xdcf\xdb0\x12\xb9\x1f2(\x19\xe9\x9e;\xf3\xd4\x1c\xc8>\x15\x99|I\x15\xc7\x86^%\xb7\x8eD\xf3\xa0\xbbwu\xd86\x90\x03D\xaf\xd7\x1e\x84g\x1c\x9a\xf1c\x8bP\x95\xd9\xe9<-\xd5\xa3\xa1\xeb>\x07\x8bT\xf8m\xe2\x88\xee\xe7\xb0\x9e\x1b}nh\xec\x19\x1a\t\x120\xdf3)\x0e\xe5z\r\xf8\xf99\xe9\xc6I\x1e\xf3\xa7M%\xf3fD8\xcfV\xe9_a\x94\xe2\xd6"\x94\xa4\x95\xac\xcf\x0f\x1dE\xd1\xa8\xa3{\xdd\x14\xaeT\x8b\xd7Q\xc0_N\xf5j\xcdU\x88[\x82\\g\x81^\xbb\xd8\xe0[\xeah\xf8{RR\xaaC\x81\x8e\xd9\xae\x99\xafw"\x94\x19\xe7\xady\x95!fvR\x9d\xe2<_J\xc7\xc9R\xad\x81\xde\xb15\xcb\xe4{i\x84\xc7\x18\x1c\xe3\xaf\xd0QN:\x85Ihy\x1d\xe9\xfbE\xcc\x8e\x01\xc1=\xea$\x84\xb1\xf9Fk\xde\x8e\x88\xf0\x9e\xact\x90\x11\xc2\xaeO\xa8\xa9\xact\xd9/%\xda\x9c\x01\xd4\x9a\x1c\x92W\x05\x16\xdd\x8b\x1a\x96\x94,\x95\x08,\xc5\xba\xfa\n\xa4\t\x1c\np\x972\xb8\xa7\x1eWcsD\xb5Y\xd37\x0cJ\x9e\xd5\xca|c\x8e\xc6\x18\xb4\xa8<Kya\xa7\xf8x\xcaL\xb2\\\xc7+\x818Rc8\x8c\xfc\xe7\x1b\xb0\xa4\x11\x91\x9fJ\xf1\xb3\x99Ma\xear;;\x1e\xa6W\x18\xba\xb0\xe6<\xc3T\xf8\x81\xf0\xafE\x87f\xa5\xe2;\xdd]\x00\x1b\x85\xa6\x95\x14n\xe7\xfd\x936\x08\xed\x9fZ\xafe\xfbAx\x16Xd]\x1f\xc3\x9a\xde\xa1gn\xca\xb9\xd4\xb5\x13\x02\xaeA\xc1\x11\xa2\x9e>\\\x11\x909\x1d\xba~u*u*{\xd3m\xfa\x9ff\xa7\x08i\x14f\xeb?\xb4}\xbe\x9e\x92\x0f\rx{\xc2\xd6Em\xdaa$\xf6\xad;\x83\xe5o\x003>\x06[\x0b\x8c\x7f\x85y\xe6\xa1\xfb[\xfcC\x96\x05[=F\xde\xca\x16\'\x10\xd8C\x14;G\xd4&\x7fZ\xd2\x96\x1dKr*Vi\xe8C\xe0o\x8a\xda\xef\x8b<W\xa4\xde\xf8\xabY\xd4\xef\x85\xa5\xf2Jc\xb9\xbb\x96U\x8c\x02\x186\xd6$u\x07\xa0\xe9_\xa2\x16N\x91\xe2 \xbc\xf4\xe4\xe2\xbe\xab!VU \xba[\xf5<L\xc9\xdd\xc6O\xcc\xa9}j\xf1HAP\xa0\x9eORj\xa4`$\x80\x96\xc0\x07\xee\x1fJ\xfaX\xea\x8f"Z3\x8f\xd3\xb5\x89\xad\xe5\\\x1d\xa3\xb8\xae\xd7N\xf1CL\x11\x01\xe4\x8e1QZ\x8az\x99P\xad\xcauz<\xff\x00i\x7f2`~^y\xeek3_\xf0\xf8\xd4/$%\xddb~@\x1d+\x862\xe4\x91\xdd8\xf3\xc4\xca\xd7\xbc\x1d\x1d\x86\x9a\x92\xd9F\xacORMs\x96\xba\x14\xb3\x9c\x01\xb3=\xab\xbe\x95{\xc6\xec\xe0\xabB\xd2\xb2:\x8d\x17\xc1\x0c\xcb\xbat\xc2\x9e\xf5\xbbq\xa0\xdb\xd8@\x89k\x14bF\xe4\xf1\\\xd3\xae\xe5+\x1dT\xe8(\xadNK\xc41El\xad\x98\xd5\x89\x1c\x12;\xf7\xaen;\x06\xb8p\xd1.K\x1e\x83\xb5w\xd0v\x8d\xd9\xc1]{\xd6E\xfbv{d+\xb0\xa1\x1c\x11\\O\xc7-4x\x83\xe1\xae\xac\x88\x0bM\x04b\xe9\t\xfe\x1f,\xee?\xf8\xee\xe1\xf8\xd7>6\x97\xb4\xa35\xdd?\xc8\xd7\rS\x92\xa4_\x9a\xfc\xcf\xcf!d\x89y,NX\xe1\x8a\xa3/99\xe2\xbd\x93\xe1W\xc1\x8dO\xc77FX\xa32D\xe3d\x93HY!\xc6F~\xef,A\x1fN\xa0\x80E~}^\xa7,n\xcf\xb1\xa7\x0eiX\xf6W\xfd\x9a\xf4[;\x1f#P\xd7<>\x97\x0b\xc7\xefl\xa1\xcf\xd3\x97\xc9\xfd>\x95\xe4\x1f\x13\x7fgmK\xc2v\xab\xa8h\xa2=F\xc4\x83\xfe\x95h:q\xdd\x07\x00}3\xee{\xd7%\x1a\xfa\xeb\xb1\xd1R\x82\xb6\x87\x9dx&\t\xac\xf5\xc8\x02\x14\x8d\xd1\xbe\xee9\x93\x9e\xbfA\xcf?Q\xd7\x8a\xfd0\xd2.[R\xd2t}Aw\xe6{Xf9\xeb\xf3 <\xfb\xd7\xd5\xe4R\xfd\xec\xd7\x92<,\xce7\x84_\x99\xd0\xc8\x86\xe6\x01\xbc\x90\xc3#\xe6\xac9\xa2\xf2$v\x90\xe4\x83\x8a\xfaXv<\x99\xf79{M.K\xf2\xa4*)n\x00<q]]\x97\x80\xef \x85g\xf3\x17\xe5\x19\x01j*\xd7PV2\xa5A\xcfS\xa0\xf0\xdc\xae\xb2\xbc\x17\x98/\xd0\x11]\xaczlW\x90\xa8s\x82;\n\xf3k\xbeWtzTU\xd5\x99G\xc4\xfaV\xed=\xe3Q\xb4\x01\x90k\x82\xd1/\xadmoYn\x80\xe3\x81\xbb\xd6\xb6\xc3\xb784\x8ck\xda\x13M\x9dA\xf1\x1d\xbc|\x06]\xa7\x81\x8a\xcb\xbb\xd7|\xcb\xcc[\x1d\xf8\x1f\x95T);\xea\x12\xac\xba\x18z\x94\xabx\xd2E|B\x7f\xbd\\\xd4\x07\xec\xf7`+\xed\x00\xf5\xafB\x8a\xb2\xb1\xe6\xd7ww:\xf9%\xb3\xd4aU\x84bR8u\xeb\x9f\xeb\\^\xa3n\xb7B\xe2\xde\xe1wG"\x98\xd9H\xea\x08\xc1\x14Q\x8e\xe9\x85y-$\x8f\x805\xef\x05\xb5\x87\x8e_OFTX\xe61H\xc3\x8f+a\xc3\xb1\xfa`\xf1\xfc\xeb\xec\x0f\x01\xf8`\xdeh\x16ks$\x96Z1\x8c\x08\xac\xa1\x057\x01\xc7\xce?\x88\x10;\xf1\xd3\xde\xbf0\xc5-y{\x1fu\x86\x95\xf5\xeev\xb0\xf8{E\xb7\x8cE\x1d\x9cj\x8cq\xbaf\x04\x93\xd0v\'\xb5s:\xe7\x83!\x86\xd1\x9f\xc3\x93}\x86\xe8\xa67Br\x8c:\x05e=\xbd\x8f\x15\xc5\xf0\x9d{\x9f \xfcH\xb6\xba\xf0\xb7\x8eL\xd0\xc6\x96fY[r\x05\xe1\x1c`2\x8e\xf8\xc9\'\xdb8\xed\xcf\xe8\x9f\xec\xf8\xd0k\xdf\t\xf4\t\xdbkJ\xb14Ls\x926;(\x1f\x90\x15\xf4\xf9$\xedR\xeb\xb7\xea\x8f\x170\x8f\xbbg\xdc\xec<E\xa6\x8bx\x16Df\x0c\x0e\x00Z\xe5\xae\x08\x0c|\xdeW\x19&\xbe\xbe\x8b\xba<\x1a\xca\xcc\x93C\xf0\xfe\xdb\x95\x1f36k\xb2\xd6\\\xdbX ]\xcb\xb7\xef0\x1e\xd5\xc1V\\\xf2GE(rA\x99\x1all\xfa\x87\x9f\x12\xb6\xc6L\xeea\xde\xbb/\x0f\xdf\x0b\xdb\xdf* N8\xc9\xeej+\xab\xafB\xa93\xb2}\x05\'\x833\xa0s\x8e3\xda\xbc\xc3\xc4\xdf\x0f\xccWoua\x13\x16\xc9%\x13\xbdsa1\x1c\x926\xc4\xd0\xe7\x89\xccA\xe0\x9dN\xfe\xe5\x99\x90\xc6\x83\xa8n1RM\xe1]GOtT\x8c0\xcfE\xe4\xfeu\xeb}b\r\xf2\x9eg\xd5\xa6\xbd\xe2\xec\x9a,W\xca\x83Q@\xa4\x0eH\xebY:\xcf\x87\xc4\x11\x89\xad#\x0f\x1au\x18\x1c\nt\xea\xd9\xdb\xa1Ui&\xaf\xd4\xcc\xd0\xaf\xe2\xb4\xb8u\x912H\xc2\xe3\xadI{\xa5}\xbb\xcc\x9a\x18@a\xd4\xaf\x185\xd4\xef\t\\\xe3\x8f\xbf\x0eT|\x83\xf1[\xc2p\xe9\x1f\xb4\x05\xbd\xbd\xccjm\xb5\x99!\x05\x17\xb1\x94\x84l\x91\xfe\xd0\'\xfe\x05_NX[\xc7m\x04\x11F\xa3l`*\xaf\xa0\x03\x02\xbf9\xcc\xe3\xcb\x88\x9a\xe9v}\xae\x01\xde\x8c_\x92,\x95\x97r\x84R\x00v9_\xc7\x8a\x88\xc7\x1bF\xa6h\x16\'\xf9\x97 t\x1dz\xfe\x15\xe5\xceJ\xf6\xb1\xde\x91\xf3\x87\xc6\xcf\x81\x9e2\xf8\x9b\xe3[)>\x1fh\x83P\xb4EG\x96q4Q"\xb6\xe3\x81\x97a\x93\xb7\x07\x8a\xfa\xe3\xe0\x07\xc3\xcb\xef\x85\xff\x00\rlt\xcf\x10\xb7\xfcL\x892\xcf\x08\x90:\xc4\xc4\x01\xb5H$\x11\xc6x\xeeM}FO\x86\x92\xb5G\xb5\x9f\xe6x\xb8\xfa\xa9\xb7\x0e\xa7k\xac\x91<\x04\x02\x0f\xb1\xaf?\xd5\x9aH$\xfd\xe0`\xb9\xc0\'\xa1\xfck\xebp\xcb\xa1\xe0\xe2_S\xd6tm\x06\xde\xdeL\x85\x03\'<v\xad\rGJ\x8e\xe5\xf6ya\xd6\xbc\x17Q\xf3\\\xf5\x14\x17-\x89 \xf0\xc4+n\x03\x03\xb7\x18\xdazU\xdd\'\xc3Igt\xb7(\x08\xc0\xc0\x00T\xca\xb3i\xa2\x95+4\xce\xa6+\x95\'a\x1f\x85$\xd6QJ\xa7\xe5\x04\x9a\xe5\xd8\xe8\xdc\xc3\xd4,S\x05Qv\xf7\xc8\xaej\xee\x10\x85\xdb%\xb9\xc0\xc9\xae\xda,\xe5\xaa\x88\xedt\xe8\xe5M\xe2<\xb7\xbfz}\xce\x95\x1d\xcc\x0f\x04q(,\xa7\xa7z\xdf\x9d\xa6c\xcb\xa1\xe6\x1e#\xf0\x8b\xe8sG,J\xce\xb9\xf9\x8f\xa1\xfaU\xbd5\xbe\xd1\xa64hv\xbb\x1eI\x1d\xfd\xeb\xd7u=\xa4\x14\x8f*4\xfd\x9dG\x13\x8d\xf1\xef\xc3]\x17\xc5W\x9an\xad\xac\xc1#_h\xc4\xcdo,O\xb7\xe6\x048\r\xfd\xe0\n\x83\x8fs\xebUb\x8aS\x11`\xdb9\\9\xef\x93\x8a\xf8\xde!\xa5\x18\xd5S]V\xa7\xd3e3n\x9b\x8b\xe8N-\x9d\xa3\xdd\xe5H\xca\xaf\x9e\x0fo\xf3\x9a\x03\x06/\x8d\xc9\xb2Lml\x1e\xde\xa3\xeb_1t\xdd\x8fj\xd6\xd4\xea\xfe\x15\xcb\x0bj:\x94N\xd9x\xf6\xb6\xd1\xd0\x1c\xb0?\x9f\x15\xe8\x17\xac\xa57\x0eq_q\x92\xff\x00\xbbAv\xbf\xe6\xcf\x9c\xcc?\x8d\'\xfdlc\xddq\x04\x92I\x9c/=:\xd7\x01\xaa\xdd>\xa19\xdf\x94\x0b\xc0@x\xaf\xa3\xc3\xadnx\xd8\x87\xa5\x8fm\xb7V\x16\xca@%\xcf\x1cU\xdb8\x9e\'\x1fh\xdc\x01\xef_9#\xd9\x89\xbfi$2\xae\x0b\x02G\xadi[F\x85v\xae+\x9aW7M2u\xd3\xd5\x9bp\x1c\xfa\xd4\xadh\x14r*y\x8a\xb1\x8f\xabY\x16\x8d\x9a3\x93\x8cb\xb8;\xd8oK\xec\x8d6*\xe7,k\xbb\x0c\xd7S\x93\x10\x9a\xd8\xb7\xa5\xce\xe8\xab\x1c\x806;\xd4W\xd7\x8foz>\xca\xac\xd9<\xe3\xb7\xbdn\xa0\x9c\x8c\\\xbd\xd3\x9f\xf1\x86\xaf\x11\xfd\xcd\xc7\x0c\xdc\x86\xc7n\xe2\xb1\xb4\xdb{yb\xf2\xac\x86\xf29&\xbb\xe9E\xc6\x9f\x91\xc59)O\xcc\xa1\xe2\x0b9,\xb4\xeb\xdf2\'*\xb0;q\xdf\nzz\x9a\xe3a\x9c*&\xc0\t\x05z\xf4\xfaW\xcb\xf1\x1b\xe6\x9c-\xd8\xf7ruh\xcb\xd4m\xfd\xe5\xea\xb3%\xaf\xc9\x96\x07!W\x03\xa7\xaf\xe3U#\x92\xe5$\x95\xafpRB\x19\x9c(\xea\x00\x1d\x87\xb0\xaf\x98\xb4c\xb2=\xbdY\xb3\xe0\xc9F\x99\xe2\x13"\x15\xfd\xecn\x8c\x01\xe0\xe7\x0c\x0f\xd7\x83\xf9\xd7{\xfd\xae\x8a\x8cd\x93\x1c\xe7\x15\xf79\x07\xbf\x86\xd3\xa3g\xcdf\x8f\x96\xb6\xbd\x8c\xeb\xed~9\xe3h\xe3nH\xc6k\x9a\xb8\xb4f\x93 \x8f\xc7\xbd}\x1d%\xc8x\xd5e\xcf\xb1\xee\xbaQ\xf9rG\xe7[\x08\x89*\x91\'"\xbeZz3\xde\x82\xba(\xdci\xe5&\xf3-\xdc\xae9\xabV\x9a\xbbZ\x05YIf\xf54\xda\xe7D\xfc,\xea,5E\x91\x06\xecU\x97\xbdIN\xda\xe5q\xb3:S\xb9N\xe9\x00\x8d\x889\xae_T\xbb\x8c\x1f\x9dFGa]\x14uf5t9\xc8\xee\x97\xed\xfb!\xca\x03\xda\xb4\x128\xa1\x95\x1er\tf\xdaA\xae\xf9&\x8e%\xa9\x9f\xe2/\x03.\xb9\xb6KV\xdas\x83\xc6p+{\xc3\xbe\x01\xb1\xd2a\\\xa6\xe9\xd8a\x9b\xd4R\x9e1\xaa|\x88p\xc2\'>vC\xf1\x13\xc2\xf0\xc9\xe1\rf\xe4.\xd7\x86\xceW\\q\xd1\r|\xc7l\xdbP\xb1\xf9W\xe4\xc09\xdcy\xeb_5\x9aTr\x94o\xd0\xf6\xb0t\xf9S\xb1f[\x95q.\xee[\xa8\'\xe8?\xad"\xdd\xc6\xaf(e_\x991\xc7\x1e\xbe\x95\xe4\xb5s\xb9\x16|9\n]\xf8\xa7L\x82)H[\x99\xd2\x1c\x9e\xc5\xfeQ\xc5z\xdd\xff\x00\xc2\xb3\x08cqw!_\xe1T\x18\xaf\xa9\xc8q~\xc6\x9c\xa1n\xbf\xa1\xe2f\x98_k5+\xf43t\xcf\x86\xcc\xcd v,\xa7\x80[\xb5iK\xf0\xba\'\x85w\xc8\xfb\xc7]\xbcf\xbd\xea\x99\x85\x9e\x88\xf3!\x81V?&\xe3\xfd\xad>/\xc41\x1f\x8f\xf5\xf5\xfaH\xbf\xfcMH?k\xcf\x8c\x8b\xd3\xe2\x17\x88?\xef\xe2\xff\x00\xf15\xf2\xae\xac\x9fS\xdfT\xe2\xba\x03~\xd7\x9f\x19\x1c|\xdf\x10\xbc@\x7f\xed\xa2\xff\x00\xf15\x11\xfd\xac\xfe/\x97\x0e|\x7f\xafn\x1d\xf7\xaf\xff\x00\x13MV\x9a\xd9\x83\xa5\x17\xba\'\x8f\xf6\xc0\xf8\xcd\x10\xfd\xdf\xc4?\x10\xaf\xd2E\xff\x00\xe2i\xe3\xf6\xc7\xf8\xd4\xbd>#x\x88\x7f\xdbE\xff\x00\xe2j}\xa4\xbb\x8f\x91v\x14\xfe\xd9?\x1a\xd8`\xfcF\xf1\x11\xff\x00\xb6\x8b\xff\x00\xc4\xd5Y?ko\x8c\x12\xb12|@\xd7\xd8\x9e\xe6E\xff\x00\xe2i\xaa\xd3\x8e\xccN\x9c^\xe8\x84~\xd5?\x16\x84\xbe`\xf1\xde\xbb\xbf\xfb\xdb\xd7\xfc*F\xfd\xac~/9\x1b\xbc}\xaf\x1c\x1c\x8c\xba\xff\x00\xf15\x7fY\xaa\xfe\xd1>\xc2\x0b\xa1a?l\x0f\x8c\xd1\x8f\x93\xe2\x1f\x88\x07\xd2E\xff\x00\xe2jA\xfbd|jS\xc7\xc4o\x11\x7f\xdf\xc5\xff\x00\xe2j\x1dY\xbe\xa5*q]\x08\xef\xbfl\x1f\x8c\xda\x95\x94\xf6\x97\xff\x00\x11<C5\xb4\xe8c\x92\'\x91p\xeaF\x08?/\xa5s\xbf\xf0\xbf\xbe!\xed\xdb\xff\x00\tf\xab\x83\xdbx\xff\x00\n\xcaiOY\x17\x17\xcb\xb0\x9f\xf0\xbe\xfe \xe0\x83\xe2\xbdS\x07\xfd\xa5\xff\x00\n_\xf8_\xbf\x10\xbf\xe8l\xd5\x7f\xef\xa5\xff\x00\n\xcd\xd1\x83\xe8_<\xbb\x8bo\xfb@|D\xb4\xb9\x86{_\x16\xea\xf1M\x0b\xac\x91\xba8\x05YNA\x1cv5\xd1\xcb\xfbb|h\x98b_\x88\x9e!a\xee\xe9\xff\x00\xc4\xd6\xb4\xff\x00w\xf0\xe8D\xbd\xed\xc8\xd7\xf6\xbd\xf8\xc8\xa3\xe5\xf8\x85\xaf\x8f\xa3\xaf\xff\x00\x13K\xff\x00\r\x7f\xf1\x94\x8c\x7f\xc2\xc3\xf1\x06?\xeb\xa2\xff\x00\xf15\xaf\xb6\x9fry#\xd8\xff\xd9'
Interoperability InteroperabilityIndex = R98
MakerNote ModelID = EOS 20D
Thumbnail JPEGInterchangeFormat = 9716
MakerNote RawJpgQuality = n/a
EXIF FocalLength = 50
MakerNote OwnerName = unknown
EXIF FNumber = 11/5
MakerNote FirmwareVersion = Firmware 2.0.0
MakerNote Tag 0x0083 = 0
MakerNote Tag 0x00AA = [10, 335, 1024, 1024, 1187]
MakerNote SequenceNumber = 0
EXIF DateTimeDigitized = 2005:08:09 18:13:53
MakerNote SubjectDistance = 0
MakerNote EasyShootingMode = Manual
Image Orientation = Horizontal (normal)
Thumbnail ResolutionUnit = Pixels/Inch
EXIF FocalPlaneXResolution = 233600/59
Image ResolutionUnit = Pixels/Inch
EXIF MakerNote = [24, 0, 1, 0, 3, 0, 46, 0, 0, 0, 154, 3, 0, 0, 2, 0, 3, 0, 4, 0, ... ]
MakerNote Saturation = Normal
MakerNote FlashActivity = Did Not Fire
EXIF ColorSpace = sRGB
MakerNote BracketMode = Off
MakerNote Sharpness = Normal
MakerNote FlashInfo = [100, 0, 0, 0]
MakerNote AFPointUsed = 0
MakerNote WBBracketValueAB = 0
EXIF ExposureTime = 1/4000
MakerNote Contrast = Normal
MakerNote FileNumber = 6400
EXIF ISOSpeedRatings = 100
Image YCbCrPositioning = Co-sited
MakerNote Tag 0x0012 = [9, 9, 3504, 2336, 3504, 2336, 78, 78, 8, 64981, 571, 64605, 8, 947, 64981, 571, 8, 504, 270, 270, 4, 4, 4, 65274, 65274, 65040, 25, 65535]
EXIF WhiteBalance = Auto
EXIF FlashPixVersion = 0100
MakerNote AFPointSelected = Unknown
MakerNote Quality = Fine
MakerNote Macromode = Normal
EXIF DateTimeOriginal = 2005:08:09 18:13:53
EXIF SceneCaptureType = Standard
MakerNote LongExposureNoiseReduction2 = Off
MakerNote RecordMode = JPEG
MakerNote FilterEffect = None
EXIF MeteringMode = Pattern
EXIF ShutterSpeedValue = 392095/32768
Interoperability InteroperabilityVersion = [48, 49, 48, 48]
MakerNote SpotMeteringMode = Unknown
MakerNote Tag 0x0019 = 1
EXIF ExifImageLength = 2336
Thumbnail YResolution = 72
MakerNote FocalLength = 907
MakerNote ManualFlashOutput = n/a
MakerNote MeteringMode = Evaluative
MakerNote LongFocalLengthOfLensInFocalUnits = 50
MakerNote FocusType = Unknown
Image Make = Canon
EXIF FocalPlaneResolutionUnit = 2
EXIF ExposureMode = Auto Exposure
MakerNote BracketValue = 0
MakerNote Unknown = 0
MakerNote FlashDetails = Manual
Image ExifOffset = 196
MakerNote Tag 0x00D0 = 0
EXIF ApertureValue = 149095/65536
MakerNote ContinuousDriveMode = Single Or Timer
MakerNote SerialNumberFormat = Format 2
EXIF ExposureProgram = Aperture Priority
MakerNote SerialNumber = 1330704135
MakerNote Tag 0x4001 = [1164, 839, 1024, 1024, 376, 580, 1024, 1024, 554, 408, 1024, 1024, 806, 277, 323, 323, 111, 198, 336, 335, ... ]
EXIF CustomRendered = Normal
MakerNote BracketShotNumber = 0
Thumbnail XResolution = 72
EXIF InteroperabilityOffset = 9258
Image XResolution = 72
MakerNote FocalUnitsPerMM = 1
MakerNote ImageStabilization = Unknown
Image YResolution = 72
MakerNote AESetting = Unknown
MakerNote SlowShutter = None
MakerNote Tag 0x4002 = []

"""


## ## ## ## a._Php7Exif.items() ## ## ## ## ## ## ## 

"""
IFD0.DateTime = 2005:08:09 18:13:53
EXIF.FocalLength = 50/1
FILE.FileSize = 1990711
EXIF.DateTimeDigitized = 2005:08:09 18:13:53
EXIF.ComponentsConfiguration = \x01\x02\x03\x00
IFD0.YResolution = 72/1
b'FILE.FileName = IMG_0027.JPG
IFD0.Orientation = 1
EXIF.ExposureBiasValue = 0/2
EXIF.Flash = 16
COMPUTED.Width = 3504
IFD0.Model = Canon EOS 20D
EXIF.MeteringMode = 5
EXIF.ExposureTime = 1/4000
FILE.MimeType = image/jpeg
EXIF.ApertureValue = 149095/65536
EXIF.DateTimeOriginal = 2005:08:09 18:13:53
COMPUTED.Height = 2336
COMPUTED.ApertureFNumber = f/2.2
FILE.SectionsFound = ANY_TAG, IFD0, EXIF, MAKERNOTE
IFD0.Make = Canon
EXIF.FNumber = 22/10
COMPUTED.ByteOrderMotorola = 0
EXIF.ExposureProgram = 3
COMPUTED.IsColor = 1
IFD0.YCbCrPositioning = 2
IFD0.XResolution = 72/1
EXIF.ExifVersion = 0221
COMPUTED.html = width
FILE.FileDateTime = 1123607634
EXIF.ShutterSpeedValue = 784190/65536
EXIF.ISOSpeedRatings = 100
IFD0.ResolutionUnit = 2
FILE.FileType = 2
"""

## _BashExiv2

"""
Exif.CanonCf.MirrorLockup = 512
Exif.CanonSi.TargetAperture = F5
Exif.CanonCs.FlashActivity = Did not fire
Exif.CanonCs.ImageSize = Small
Exif.Canon.FocalLength = 55.0 mm
Exif.CanonCs.ZoomSourceWidth = 0
Exif.CanonSi.MeasuredEV = 7.25
Exif.Image.DateTime = 2005:08:29 13:26:23
Exif.Photo.ISOSpeedRatings = 3200
Exif.Photo.FocalPlaneYResolution = 1952.54
Exif.CanonPi.ImageWidthAsShot = 3504
Exif.Image.ResolutionUnit = inch
Exif.Photo.ApertureValue = F5
Exif.CanonCs.Saturation = High
Exif.CanonPi.AFPointsUsed20D = 
Exif.CanonFi.BracketMode = Off
Exif.CanonCf.NoiseReduction = 0
Exif.CanonCs.SpotMeteringMode = (65535)
Exif.CanonCf.FlashSyncSpeedAv = 1280
Exif.Photo.SceneCaptureType = Standard
Exif.Iop.InteroperabilityIndex = R98
Exif.Image.Model = Canon EOS 20D
Exif.CanonCf.AFAssist = 1024
Exif.CanonPr.ColorTemperature = 7300
Exif.Canon.ThumbnailImageValidArea = 0 159 7 112
Exif.Thumbnail.JPEGInterchangeFormatLength = 3336
Exif.CanonSi.TargetShutterSpeed = 1/202 s
Exif.CanonCf.ShutterCurtainSync = 1793
Exif.Photo.MakerNote = (Binary value suppressed)
Exif.CanonCs.Macro = Off
Exif.CanonPr.ToneCurve = Standard
Exif.CanonCf.AEBSequence = 1536
Exif.Photo.ExposureProgram = Aperture priority
Exif.CanonCs.ColorTone = 0
Exif.Thumbnail.Compression = JPEG (old-style)
Exif.CanonCs.Lens = 35.0 - 80.0 mm
Exif.CanonPi.ImageWidth = 1728
Exif.CanonCs.ImageStabilization = (65535)
Exif.Photo.FocalLength = 55.0 mm
Exif.CanonPr.WhiteBalanceBlue = 0
Exif.CanonFi.BracketValue = 0
Exif.CanonFi.NoiseReduction = Off
Exif.Image.YResolution = 72
Exif.CanonCs.FlashDetails = 
Exif.Photo.ExposureMode = Auto
Exif.Photo.ExifVersion = 2.21
Exif.Canon.FirmwareVersion = Firmware 2.0.0
Exif.Photo.DateTimeOriginal = 2005:08:29 13:26:23
Exif.Image.ExifTag = 196
Exif.MakerNote.Offset = 626
Exif.Canon.OwnerName = unknown
Exif.Canon.SerialNumberFormat = Format 2
Exif.CanonPr.SensorRedLevel = 0
Exif.Photo.MeteringMode = Multi-segment
Exif.Photo.ExposureTime = 1/200 s
Exif.Photo.PixelYDimension = 1152
Exif.CanonSi.SubjectDistance = 0
Exif.CanonPi.AFPointsUsed = bottom
Exif.CanonCs.ExposureProgram = Aperture priority (Av)
Exif.CanonCs.MaxAperture = 65535
Exif.CanonFi.ToningEffect = None
Exif.Photo.WhiteBalance = Auto
Exif.Photo.ColorSpace = sRGB
Exif.Canon.CameraInfo = (Binary value suppressed)
Exif.CanonSi.ShutterSpeedValue = 1/6889 s
Exif.CanonCf.FillFlashAutoReduction = 2304
Exif.CanonFi.WBBracketValueGM = 0
Exif.CanonCs.DisplayAperture = 0
Exif.CanonPr.WhiteBalance = (-32768)
Exif.CanonPi.ImageHeight = 1152
Exif.CanonCf.SensorCleaning = 3072
Exif.Canon.MeasuredColor = 10 693 1024 1024 486
Exif.Photo.InteroperabilityTag = 9258
Exif.Canon.ModelID = EOS 20D
Exif.CanonCs.EasyMode = Manual
Exif.Thumbnail.ResolutionUnit = inch
Exif.CanonFi.FileNumber = 113-1351
Exif.CanonCf.SuperimposedDisplay = 3328
Exif.CanonFi.FilterEffect = None
Exif.CanonCs.AESetting = (65535)
Exif.CanonCs.Contrast = High
Exif.Photo.DateTimeDigitized = 2005:08:29 13:26:23
Exif.Photo.ShutterSpeedValue = 1/200 s
Exif.CanonCs.Selftimer = Off
Exif.Image.YCbCrPositioning = Co-sited
Exif.CanonFi.BracketShotNumber = 0
Exif.Image.XResolution = 72
Exif.CanonCs.DriveMode = Continuous
Exif.Photo.FocalPlaneResolutionUnit = inch
Exif.CanonCs.LensType = (65535)
Exif.CanonCs.FocusMode = AI servo AF
Exif.Canon.SensorInfo = 34 3596 2360 1 1 84 19 3587 2354 0 0 0 0 0 0 0 0
Exif.CanonSi.WhiteBalance = Auto
Exif.CanonCs.DigitalZoom = None
Exif.Thumbnail.YResolution = 72
Exif.Canon.VRDOffset = 0
Exif.Photo.FlashpixVersion = 1.00
Exif.CanonCf.SetButtonFunction = 2816
Exif.CanonPr.PictureStyle = None
Exif.CanonPr.SensorBlueLevel = 0
Exif.CanonCf.LensAFStopButton = 2048
Exif.CanonSi.ISOSpeed = 3200
Exif.MakerNote.ByteOrder = II
Exif.Canon.ColorData = 1164 839 1024 1024 376 580 1024 1024 554 408 1024 1024 806 277 323 323 111 198 336 335 166 156 374 372 267 1767 1056 1056 2150 3480 1698 1023 1023 2066 3480 1962 1023 1023 1585 5200 2248 1023 1023 1331 7000 2121 1023 1023 1443 6000 1380 1023 1023 2494 3195 1764 1023 1023 2151 3969 2147 1023 1023 1400 6314 2808 1023 1023 1104 10000 2282 1023 1023 1308 7292 407 956 65207 11661 421 908 65241 9907 444 834 65296 8000 466 787 65337 7000 494 726 65391 6000 515 691 65426 5600 534 661 65456 5200 559 613 65502 4792 592 567 15 4352 623 535 56 4056 671 492 114 3696 748 427 203 3250 791 400 247 3051 842 371 295 2871 1006 305 427 2413 500 2069 2087 2069 2087 2069 2087 2069 2087 2069 2087 2069 2087 2069 2087 2069 2087 2069 2087 2069 2087 2069 2087 2069 2087 2069 2087 2069 2087 2069 2087 128 128 127 127 0 0 0 0 0 0 0 0 0 0 0 31 34 30 31 0 0 0 0 0 0 0 0 0 0 40 38 43 44 47 47 31 0 0 0 0 0 0 0 0 44 41 44 48 48 52 52 0 0 0 0 0 0 0 0 0 36 47 55 59 59 59 57 33 0 0 0 0 0 0 0 0 0 0 0 39 42 38 38 0 0 0 0 0 0 0 0 0 0 56 52 58 60 62 60 36 0 0 0 0 0 0 0 0 63 57 62 67 67 70 69 0 0 0 0 0 0 0 0 0 55 71 82 87 86 85 79 43 0 0 0 0 0 0 0 0 0 0 0 40 43 37 37 0 0 0 0 0 0 0 0 0 0 61 55 60 60 62 59 33 0 0 0 0 0 0 0 0 71 62 65 68 67 70 68 0 0 0 0 0 0 0 0 0 60 76 85 88 86 84 77 40 0 0 0 0 0 0 0 0 0 0 0 20 20 19 18 0 0 0 0 0 0 0 0 0 0 28 25 27 27 27 25 14 0 0 0 0 0 0 0 0 33 28 29 30 29 30 28 0 0 0 0 0 0 0 0 0 27 33 37 37 36 34 30 13 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 4 1 1 0 0 0 0 0 0 0 0 0 0 5 77 298 375 407 360 1 0 0 0 0 0 0 0 0 1 8 130 690 634 649 1019 0 0 0 0 0 0 0 0 0 2 64 1419 6823 5008 4365 6921 16 727 454 512 726 424 920 0 268 380 377 166 1023 1024 1024 0 0 0 0 0 0 0 0 1126 1024 1024 2756 4000 6833
Exif.Photo.CustomRendered = Normal process
Exif.CanonCs.Quality = Normal
Exif.CanonCs.ISOSpeed = (32767)
Exif.CanonSi.FlashBias = 0 EV
Exif.CanonPr.SharpnessFrequency = n/a
Exif.CanonCf.MenuButtonReturn = 2560
Exif.CanonCs.FlashMode = Off
Exif.CanonCs.FocusType = Not known
Exif.CanonFi.WBBracketMode = Off
Exif.CanonPr.WBShiftGM = 0
Exif.CanonCs.FocusContinuous = Continuous
Exif.CanonFi.WBBracketValueAB = 0
Exif.Canon.ImageType = Canon EOS 20D
Exif.CanonSi.MeasuredEV2 = 7.25
Exif.Iop.InteroperabilityVersion = 1.00
Exif.CanonPr.WBShiftAB = 0
Exif.CanonPi.ImageHeightAsShot = 2336
Exif.Canon.SerialNumber = 4f5061191
Exif.CanonFi.RawJpgSize = (-1)
Exif.CanonSi.Sequence = 0
Exif.CanonSi.ApertureValue = F4.8
Exif.CanonPr.Sharpness = 0
Exif.CanonPr.DigitalGain = 0
Exif.Photo.FocalPlaneXResolution = 1952.54
Exif.Photo.ComponentsConfiguration = YCbCr
Exif.CanonCs.Sharpness = High
Exif.CanonCs.MinAperture = 65535
Exif.CanonCs.PhotoEffect = Off
Exif.CanonSi.AFPointUsed = 0 focus points; none used
Exif.Canon.OriginalDecisionDataOffset = 0
Exif.Photo.FNumber = F5
Exif.CanonCf.ExposureLevelIncrements = 768
Exif.Photo.UserComment = (Binary value suppressed)
Exif.Photo.PixelXDimension = 1728
Exif.CanonFi.RawJpgQuality = (-1)
Exif.CanonCf.ShutterReleaseNoCFCard = 3584
Exif.CanonCs.MeteringMode = Evaluative
Exif.CanonCs.ZoomTargetWidth = 0
Exif.Photo.Flash = No, compulsory
Exif.CanonCs.ManualFlashOutput = (32767)
Exif.Thumbnail.XResolution = 72
Exif.CanonCf.ShutterAeLock = 256
Exif.Image.Orientation = top, left
Exif.CanonPr.WhiteBalanceRed = 0
Exif.CanonCs.AFPoint = (0)
b'Exif.Image.Make = Canon
Exif.Photo.ExposureBiasValue = 0 EV
Exif.Thumbnail.JPEGInterchangeFormat = 9716
"""
