#!/usr/bin/python3
# -*- coding: utf-8 -*-
#from __future__ import print_function

import sys
import re
_FonctionDuProgramme=re.sub(".*/","",sys.argv[0])
_FonctionDuProgramme+="\n\
calcul en RK4\
\
"

#print(_FonctionDuProgramme)
_Version="1.0"
__version__="1.0"
#print("version:"+_Version)
_FonctionDuProgramme+="\n\
Version:"+_Version+"\n"

dossier="/opt/CLASSES3"
import sys
if dossier not in sys.path:
    sys.path.append(dossier)
    

import os
##################### debug

_debug=True # _debug=False

_debug_Titres=True # _debug_Titres=False

_debug_all=True # 
_debug_all=False

if _debug_all==True:
	_debug_Titres=True
	_debug=True

_FichierLog='/tmp/'+re.sub(".*/","",sys.argv[0])+'.log'
_Log=open(_FichierLog,'w')

def Tprint(*args, **kwargs):
	if _debug_Titres==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
def Dprint(*args, **kwargs):
	if _debug==True:
		print('==========================Dprint')
		print(sys.argv[0],*args, **kwargs)					
		print(sys.argv[0],*args,file=_Log)
		print('  =  =  =  =  =  =  =  =')
# # # # # # # # # # # # # # # # # # # debug
# ajout de doc + Tprint sed -e 's/^\(.*\)\(def\ \)\(.*\)$/\1\2\3\n\1\t"""-*\3"""\n\1\tTprint("\3")/' -i aa.py
class br_CDict(dict):
	def __init__(self,retour=""):
		self._retour=retour
	def __missing__(self, key):
		return self._retour
		
class br_CDICO(dict):
	def __missing__(self, key):
		return None

DicoFonctions=br_CDICO()
DicoClasses=br_CDICO()

	
class ZZCFichiers(object):
	def __init__(self,fich=''):
		Tprint('fich.__init__()')
		self._SEP='/'	
		self._fich=fich
		pass#self._repertoire=_rep
	def Valide(self):
		Tprint('fich.Valide()')
		resultat=None
		if os.path.isfile(self._fich):
			resultat=True
		if not os.path.isfile(self._fich):
			resultat=False
		return resultat
	def RepNom(self):#'/tmp'
		Tprint('fich.RepNom()')
		self._RepNom=os.path.split(self._rep)[0]
		return self._RepNom
	def FichNom(self):#bb.jpg
		Tprint('fich.FichNom()')
		self._FichNom=os.path.split(self._rep)[1]
		return self._FichNom
		

#self.thumbs=os.listdir(rep)
#(os.path.splitext(i)[1])[1:]
#self.thumbs=[ i for i in self.thumbs if ((os.path.splitext(i)[1])[1:]).lower() in SuffixesImages ]		#AfficheImagesAvecLegendes



from CMaths import *


#import numpy

def coeffNDeSinus(n):
	""" calcule le coeff n de sinus , coeffNDeSinus(n) , a_n de (a_n x**n)"""
	try:
		if paritee(n)=="pair":
			return 0.0
		if paritee(n)=="impair":
			m=(n+1)/2
			if paritee(m)=="impair":
				return 1/factorielle(n)
			else:
				return -1/factorielle(n)
	except:
		return None			
DicoFonctions["coeffNDeSinus"]=coeffNDeSinus.__doc__	

def coeffFractionnelNDeSinus(n):
	""" calcule le coeff fractionnel a/(b>0) n de sinus , coeffFractionnelNDeSinus(n) , a_n de (a_n x**n)"""
	try:
		if paritee(n)=="pair":
			return (0,1)
		if paritee(n)=="impair":
			m=(n+1)/2
			if paritee(m)=="impair":
				return (1,factorielle(n))
			else:
				return (-1,factorielle(n))
	except:
		return None							
DicoFonctions["coeffFractionnelNDeSinus"]=coeffFractionnelNDeSinus.__doc__



	
def coeffNDeCosinus(n):
	""" calcule le coeff n de cosinus, coeffNDeCosinus(n) ,  a_n  de (a_n x**n)"""
	if paritee(n)=="impair":
		return 0.0
	if paritee(n)=="pair":
		m=n/2
		if paritee(m)=="pair":
			return 1/factorielle(n)
		else:
			return -1/factorielle(n)
DicoFonctions["coeffNDeCosinus"]=coeffNDeCosinus.__doc__

def coeffFractionnelNDeCosinus(n):
	""" calcule le coeff fractionnel a/(b>0) n de cosinus , coeffFractionnelNDeCosinus(n) , a_n de (a_n x**n)"""
	try:
		if paritee(n)=="impair":
			return (0,1)
		if paritee(n)=="pair":
			m=n/2
			if paritee(m)=="pair":
				return (1,factorielle(n))
			else:
				return (-1,factorielle(n))
	except:
		return None							
DicoFonctions["coeffFractionnelNDeCosinus"]=coeffFractionnelNDeCosinus.__doc__
	
global main

if __name__ == "__main__":
	Dprint("Le programme lancé est "+sys.argv[0])
	
	print(_FonctionDuProgramme)
	print("version:"+_Version)

	print('import CMaths_DeveloppementLimitee')
	for a in DicoFonctions:
		print('from CMaths_DeveloppementLimitee import '+a)
		print("  "+DicoFonctions[a])
	for a in DicoClasses:
		print('from CMaths_DeveloppementLimitee import '+a)
		print("  "+DicoClasses[a])
	
	print("cosinus")
	
	for i in range(10):
		if coeffNDeCosinus(i)!=0:
			print("  + ",coeffNDeCosinus(i)," x^",i)
			
	print("sinus")
	
	for i in range(10):
		if coeffNDeSinus(i)!=0:
			print("  + ",coeffNDeSinus(i)," x^",i)		
		
	









