#!/usr/bin/python3
# -*- coding: utf-8 -*-
#from __future__ import print_function

import sys
import re
_FonctionDuProgramme=re.sub(".*/","",sys.argv[0])
_FonctionDuProgramme+="\n\
calcul en RK4\
\
"

#print(_FonctionDuProgramme)
_Version="1.0"
__version__="1.0"
#print("version:"+_Version)
_FonctionDuProgramme+="\n\
Version:"+_Version+"\n"

dossier="/opt/CLASSES3"
import sys
if dossier not in sys.path:
    sys.path.append(dossier)
    

import os
##################### debug

_debug=True # _debug=False

_debug_Titres=True # _debug_Titres=False

_debug_all=True # 
_debug_all=False

if _debug_all==True:
	_debug_Titres=True
	_debug=True

_FichierLog='/tmp/'+re.sub(".*/","",sys.argv[0])+'.log'
_Log=open(_FichierLog,'w')

def Tprint(*args, **kwargs):
	if _debug_Titres==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
def Dprint(*args, **kwargs):
	if _debug==True:
		print('==========================Dprint')
		print(sys.argv[0],*args, **kwargs)					
		print(sys.argv[0],*args,file=_Log)
		print('  =  =  =  =  =  =  =  =')
# # # # # # # # # # # # # # # # # # # debug
# ajout de doc + Tprint sed -e 's/^\(.*\)\(def\ \)\(.*\)$/\1\2\3\n\1\t"""-*\3"""\n\1\tTprint("\3")/' -i aa.py
class br_CDict(dict):
	def __init__(self,retour=""):
		self._retour=retour
	def __missing__(self, key):
		return self._retour
		
class br_CDICO(dict):
	def __missing__(self, key):
		return None

DicoFonctions=br_CDICO()
DicoClasses=br_CDICO()

	
class ZZCFichiers(object):
	def __init__(self,fich=''):
		Tprint('fich.__init__()')
		self._SEP='/'	
		self._fich=fich
		pass#self._repertoire=_rep
	def Valide(self):
		Tprint('fich.Valide()')
		resultat=None
		if os.path.isfile(self._fich):
			resultat=True
		if not os.path.isfile(self._fich):
			resultat=False
		return resultat
	def RepNom(self):#'/tmp'
		Tprint('fich.RepNom()')
		self._RepNom=os.path.split(self._rep)[0]
		return self._RepNom
	def FichNom(self):#bb.jpg
		Tprint('fich.FichNom()')
		self._FichNom=os.path.split(self._rep)[1]
		return self._FichNom
		

#self.thumbs=os.listdir(rep)
#(os.path.splitext(i)[1])[1:]
#self.thumbs=[ i for i in self.thumbs if ((os.path.splitext(i)[1])[1:]).lower() in SuffixesImages ]		#AfficheImagesAvecLegendes






import numpy

#wikipedia
def RK4_XY( Xn , Yn , f , dX ):# (dY/dX) (Xn,Yn)=f(Xn,Yn)
	""" YnplusdX = RK4_XY( Xn , Yn , f , dX ) ; (dY/dX) (Xn,Yn)=f(Xn,Yn)
	retourne position 
	Xinit: initial position (number-like object)
	"""
	k1=f(Xn,Yn)
	k2=f(Xn+0.5*dX,Yn+0.5*k1)
	k3=f(Xn+0.5*dX,Yn+0.5*k2)
	k4=f(Xn+dX,Yn+k3)
	YnplusdX = Yn + (k1 + 2*k2 + 2*k3 + k4) * ( dX / 6.0 ) # + O ( dX**5 )
	return YnplusdX
DicoFonctions["RK4_XY"]=RK4_XY.__doc__

#http://doswa.com/2009/01/02/fourth-order-runge-kutta-numerical-integration.html
def RK4_XVdT(Xt, Vt, AccFonction, dt):#a(x,v,dt) AccFonction(x,v,dt)
    """XtplusDt, VtplusDt=RK4_XVdT(Xt, Vt, AccFonction, dt) ; AccFonction(Xt,Vt,dt)
    Returns final (position, velocity) tuple after
    time dt has passed.

    Xt: initial position (number-like object)
    Vt: initial velocity (number-like object)
    AccFonction: acceleration function AccFonction(Xt,Vt,dt) (must be callable)
    dt: timestep (number)"""
    x1 = Xt
    v1 = Vt
    a1 = AccFonction(x1, v1, 0)

    x2 = Xt + 0.5*v1*dt
    v2 = Vt + 0.5*a1*dt
    a2 = AccFonction(x2, v2, dt/2.0)

    x3 = Xt + 0.5*v2*dt
    v3 = Vt + 0.5*a2*dt
    a3 = AccFonction(x3, v3, dt/2.0)

    x4 = Xt + v3*dt
    v4 = Vt + a3*dt
    a4 = AccFonction(x4, v4, dt)
	
    XtplusDt = Xt + (v1 + 2*v2 + 2*v3 + v4) *dt / 6.0
    VtplusDt = Vt + (a1 + 2*a2 + 2*a3 + a4) *dt / 6.0
    #print(Xt,x2,x3,x4,XtplusDt)
    return XtplusDt, VtplusDt
DicoFonctions["RK4_XVdT"]=RK4_XVdT.__doc__





	
global main

if __name__ == "__main__":
	Dprint("Le programme lancé est "+sys.argv[0])
	
	print(_FonctionDuProgramme)
	print("version:"+_Version)

	print('import CMaths_RK4')
	for a in DicoFonctions:
		print('from CMaths_RK4 import '+a)
		print("  "+DicoFonctions[a])
	for a in DicoClasses:
		print('from CMaths_RK4 import '+a)
		print("  "+DicoClasses[a])
		
		
	def AccFonction(Xt, Vt,dt):
		return x
	def AccRessort(Xt, Vt,dt):
		m=5.0
		k=5.0
		L0=1.0
		acc=-k/m * (Xt-L0)
		return acc
			
	
	Xt,Vt=2.0,0.0
	dt=0.001
	f=open('/tmp/a.txt',"w")
	E=0
	for n in range(10000):
		XtplusDt, VtplusDt=RK4_XVdT(Xt, Vt, AccRessort, dt)
		Xt,Vt = XtplusDt, VtplusDt
		print(Xt,file=f)
		print(Xt,E)
		print(E-(0.5*(Xt-1.0)**2+0.5*Vt**2))
		E=0.5*(Xt-1.0)**2+0.5*Vt**2
	f.close()	
		
	exit()










