from __future__ import print_function
# -*- coding: utf-8 -*-

# on prend intervalle points; 
# on calcule l'énergie moyenne avec un seuil 
# on crée un wav sans les points d'énergie trop faible
# on crée deux graphs : init, init-bruit

intervalle=1000
seuil=0.001

import math
import numpy as np
from math import cos,sin,pi
import time

global Calculs

import random

def S16b2Valeur(B16):
	faible,fort = B16
	def num(nb):#-128 a 127
		return ( (nb<=127)*nb+(nb>127)*(nb-256) )
	return (num(fort)*256+faible	)/32768.0
	
	#10,40 =>(  40 * 256 + 10 )/ 32768 = 40 / 128 + 10 / 32768
	#10,250 => ( -6 * 256 + 10 )/32768 = -6 / 128 +10 /32768
def Valeur2S16b(nb):# -1.0 a 1.0 
	if nb>=0:
		fort=int(nb * 128.0) #40
		faible=int( (nb-fort/128.0)*32768.0 )
	else:
		fort=-int(-(nb*128.0+256)) #250
		faible=int( ( nb -(fort-256)/128.0   )*32768.0)
	return [faible,fort]
	

	
import wave
_NomFich='sin100Hz1s.wav'
_NomFich='sin441Hz1s.wav'
_NomFich='riff.wav'
_NomFich='guitare.wav'
f=wave.open(_NomFich,'r')
_params=f.getparams()
print(_params)
N=_params[3]#
s=f.readframes(N)
print(len(s))

# frequence d'echantillonnage en Hz
fe = _params[2]*1.0# 44100.0
# duree en seconde
T = 1.0*N/fe
# Nombre de point :
# N = T*fe
print('T*fe',T*fe)
# Array temporel :
tt = np.arange(1.-N/2,N-N/2+1, dtype=np.float64)/fe
tt = np.arange(0.0,0.0+N, dtype=np.float64)/fe
#print(tt,len(tt))
from scipy import fftpack




t=time.time()
print('temps estimé : intervalle = ',intervalle ,' N = ',N )
X=[S16b2Valeur([ord(s[i]),ord(s[i+1])]) for i in range(0,2*N,2)]
_valeurs=np.array(list(X), dtype=np.float64)
_carres=[ ( X[i] )**2 for i in range(0,N)]
_carres=np.array(list(_carres), dtype=np.float64)
_resultat=np.array(list([0.0 for i in range(N)]), dtype=np.float64)

for k in range(0,N-intervalle,intervalle):
	moy=np.mean(_carres[k:k+intervalle], dtype=np.float64)
	if moy>seuil:
		for m in range(k,k+intervalle):
			_resultat[m]=X[m]

#print(type(sinux),sinux)
print('#################### '+str(N)+' ############################')


temps=time.time()-t
print('temps réel : ' , temps)#print( 'temps**0.5 / N : ',(temps)**(0.5) / N  )


from matplotlib import pyplot as plt

'''
# signal temporel
sinus = np.sin(2*np.pi*f0*t)-np.sin(2*np.pi*f0*t*3)/3+ np.sin(2*np.pi*f0*t*5)/5-np.sin(2*np.pi*f0*t*7)/7 + np.sin(2*np.pi*f0*t*9)/9-np.sin(2*np.pi*f0*t*11)/11
#sinus=(t>2.5)*(7.5>t)   #sinus = np.sin(2*np.pi*f0*t)
# ajout de bruit
bruit = np.random.normal(0,0.5,N-1)
sinus2 = sinus + bruit
# signal frequentiel : on divise par la taille du vecteur pour normaliser la fft
fourier = fftpack.fft(sinus2)/np.size(sinus2)
fourier=np.fft.fftshift(fourier)
print(fourier[0:10],len(fourier))

'''


g=wave.open('moyenne-riff-'+str((intervalle)).zfill(5)+'.wav','w')
_params=[_params[i] for i in range(len(_params))]
_params[3]=N
g.setparams(tuple(_params))#g.setparams((1, 2, 44100, 18, 'NONE', 'not compressed'))

s=''
for valeur in _resultat:
	faible,fort=Valeur2S16b(np.real(valeur))
	s+=chr(faible)+chr(fort)
g.writeframesraw(s)
g.close()
print('nb de valeurs '+str(len(_valeurs)))
print('longueur de s '+str(len(s)))









# On plot
plt.figure()
plt.subplot(121)
plt.plot(tt,_valeurs,'-')


#plt.plot(tt,sinux,'r-')
plt.xlabel('axe temporel, en seconde')
"""
# On plot
plt.figure()
plt.subplot(122)
plt.plot(tt,valeurs,'-')
plt.plot(tt,valeurs,'r-')
plt.xlabel('axe temporedddsl, en seconde')
"""
"""
# axe frequentiel:
axe_f = np.arange(0.-N/2,N-1-N/2+1)*fe/N
plt.subplot(122)
plt.plot(axe_f,np.abs(resultat),'x-')
plt.xlabel('axe frequentiels en Hertz')


"""
# axe frequentiel:
plt.figure()
plt.subplot(122)
plt.plot(tt,_resultat,'-')
plt.xlabel('difference init.tf,en seconde')


plt.show()


