#!/usr/bin/python3
# -*- coding: utf-8 -*-
#from __future__ import print_function

#print(_FonctionDuProgramme)
_Version="3.0.1"
__version__="3.0.1"

"""

"""
import sys
import re
_FonctionDuProgramme=re.sub(".*/","",sys.argv[0])
_FonctionDuProgramme+="\n\
MATHS-polynomes\
CPolynome\
\
"

dossier="/opt/CLASSES3"
import sys
if dossier not in sys.path:
    sys.path.append(dossier)
    
#print("version:"+_Version)
_FonctionDuProgramme+="\n\
Version:"+_Version+"\n"


import os

##################### debug
_debug_all=True # 
_debug_all=False

_debug_Titres=True #
_debug_Titres=False

_debug=True #
_debug=False

if _debug_all==True:
	_debug_Titres=True
	_debug=True

_FichierLog='/tmp/'+re.sub(".*/","",sys.argv[0])+'.log'
_Log=open(_FichierLog,'w')

def Tprint(*args, **kwargs):
	if _debug_Titres==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
def Dprint(*args, **kwargs):
	if _debug==True:
		print('==========================Dprint')
		print(sys.argv[0],*args, **kwargs)					
		print(sys.argv[0],*args,file=_Log)
		print('  =  =  =  =  =  =  =  =')
# # # # # # # # # # # # # # # # # # # debug

class br_CDICO(dict):
	  def __missing__(self, key):
		  return ""

class CProjetDePo(object):
	def __init__(self,_rep=''):
		self._repertoire=_rep





from math import *
from CFonctions3 import *#EstUnArray,EstUnNombre
import os	

def signe(a):
	return sgn(a)
def sgn(a):	
	if EstUnNombre(a):
		if a>0:
			return 1
		elif a==0:
			return 0
		else:
			return -1		
	else:
		return None	
		






class br_CDICO(dict):
	  def __missing__(self, key):
		  return 0.0
class CMonome(object):
	def __init__(self,mantisse,exposant=None,exposant_reel_autorise=False):
		"""__init__(mantisse=chaine="(-2+3)x^(5+1)"|nombres=2),exposant=3|None """
		Dprint("98",type(mantisse),type(exposant))
		Tprint('CMonome.__init__')
		self._variable="x"
		self._AffMult=" "
		
		if EstUneChaine(mantisse):
			Dprint("EstUneChaine")
			Chaine=mantisse					
			mantisse,exposant=self.TexteVersNombres(Chaine)
			self.init(mantisse,exposant)
			
		if SontDesNombres([mantisse,exposant]):
			Dprint("SontDesNombres")
			self.init(mantisse,exposant)
		
	def init(self,mantisse,exposant):
		Tprint("CMonome.init")
		if EstUnEntier(mantisse,strict=False):# or float(int(mantisse))==mantisse:
			mantisse=int(mantisse)
		if EstUnReel(mantisse,strict=False):
			mantisse=float(mantisse)
			
		if EstUnEntier(exposant,strict=False):
			exposant=int(exposant)
		if EstUnReel(exposant,strict=False) and exposant_reel_autorise==True:
			exposant=float(exposant)
		
		
		self._mantisse=mantisse
		self._exposant=exposant
		self._signe=signe(self._mantisse)
		#self._affichage=self.__str__()
		self._coeff=self._mantisse
		self._degre=self._exposant
		return [self._mantisse,self._exposant]
		
	def TexteVersNombres(self,Chaine):#-2x^5 ; (3+5)x^(4+exp(0)*2**3)
		Tprint("CMonome.TexteVersNombres")		
		
		#(-2)x^(-3)		
		a=re.match(r"^(?P<mantisse>\([+\-0-9\.]*\)).*"+self._variable+"\^(?P<exposant>\([0-9\.+\-]*\))$",Chaine)
		if not a:
			#(-2)x^-3
			a=re.match(r"^(?P<mantisse>\([+\-0-9\.]*\)).*"+self._variable+"\^(?P<exposant>[0-9\.+\-]*)$",Chaine)
		if not a:
			#-2x^(-3)
			a=re.match(r"^(?P<mantisse>[+\-0-9\.]*).*"+self._variable+"\^(?P<exposant>\([0-9\.+\-]*\))$",Chaine)
		if not a:
			#-2x^-3
			a=re.match(r"^(?P<mantisse>[+\-0-9\.]*).*"+self._variable+"\^(?P<exposant>[0-9\.+\-]*)$",Chaine)
		#(3*4+5)x^(2*9+6)
		if not a:
			a=re.match(r"^(?P<mantisse>\([*/+\-0-9\.]*\)).*"+self._variable+"\^(?P<exposant>\([0-9\.+\-*/]*\))$",Chaine)
		
		if a:
			mantisse=a.group("mantisse")
			#mantisse=re.sub(r"^\((.*)\)$","\g<1>",mantisse) enleve les parenthèses
			try:
				mantisse=float(mantisse)
			except:
				code = compile(mantisse, "<string>", "eval")
				mantisse=float(eval(code))
				#mantisse=float(eval(mantisse))
			
			exposant=a.group("exposant")
			#exposant=re.sub(r"^\((.*)\)$","\g<1>",exposant)	 enleve les parenthèses		
			try:
				exposant=int(exposant)
			except:
				code = compile(exposant, "<string>", "eval")
				exposant=int(eval(code))
				#exposant=int(eval(exposant))
			
			return [mantisse,exposant]
		else:
			return [Chaine,None]
			
		
	def __mul__(self,mon2):	
		Tprint("CMonome.__mul__")
		return CPolynome([CMonome(self._mantisse)])*CPolynome([CMonome(mon2._mantisse)])
		
	def __add__(self,mon2):
		Tprint("CMonome.__add__")
		if self._degre==mon2._exposant:
			return CPolynome ( CMonome(self._mantisse+mon2._mantisse,self._exposant))
		
		if self._degre!=mon2._degre:
			return CPolynome ( [CMonome(self._mantisse,self._exposant),CMonome(mon2._mantisse,mon2._exposant)])

	def __div__(self,mon2):
		Tprint("CMonome.__div__")
		#if self._degre>=mon2._degre:
		return CPolynome(CMonome(self._mantisse/mon2._mantisse,self._exposant-mon2._exposant))
			
	def __str__(self):
		Tprint("CMonome.__str__")
		return self.affiche()
		
	def affiche(self,affizero=False,EnleveSigneInitial=True):
		Tprint("CMonome.affiche")
		if EnleveSigneInitial==True:
			aff={-1:"-",1:""}
		else:
			aff={-1:"-",1:"+"}
				
			
		variable=self._variable
		mult=self._AffMult
			
						
		if affizero==False and self._mantisse==0:
			self._affichage=""
		else:
			self._affichage=aff[signe(self._mantisse)]
			
			if self._mantisse!=1 or self._degre==0:
				self._affichage+=str(abs(self._mantisse))
				
			if self._exposant!=0:
				self._affichage+=mult+variable
			if self._exposant!=1 and self._exposant!=0:
				self._affichage+="^"+str(self._exposant)
		
		return self._affichage
		
		
		
		self._affichage=aff[signe(self._mantisse)]+mult+variable+self.exposant


	def deriv(self):
		Tprint("CMonome.deriv")
		return CPolynome(self).deriv()
	
	def deriv_n(self,n):
		Tprint("CMonome.deriv_n")
		return CPolynome(self).deriv_n(n)
		

class br_monomes(dict):
	  def __missing__(self, exposant):
		  return CMonome(0,exposant)
		  
class CPolynome(object):
	def __init__(self,coeffs=None):
		"""CPolynome(5)===5x^0 """
		Tprint("__init__",type(coeffs))
		self._monomes=br_monomes()
		self_coeffsNombres=None
		self._variable="x"
		#5 =>degree
		if EstUnNombre(coeffs):#CPolynome(5)===5x^0	=> [CMonome([5,0])]
			coeffs=[CMonome([coeffs,0])]
		
		#[deg0,deg1,deg2] #CPolynome([2,3,4])===2+3x+4x^2 => [CMonome([2,0]),CMonome([3,1]),CMonome([4,2])]
		if isinstance(coeffs,list) and len(coeffs)>0 and SontDesNombres(coeffs):
			self._coeffsNombres=coeffs#[1,2,3]1+x+3x^2
			coeffs=[]
			for i,ai in enumerate(self._coeffsNombres):
				coeffs.append(CMonome([ai,i]))
				#self._monomes[i]=CMonome(ai,i)
			#self._coeffs=coeffs
			
			#self.initCoeffs()
			self._degre=self.degre()
		
		if isinstance(coeffs,list) and len(coeffs)==1 and EstUn(coeffs[0],CMonome):
			coeffs=coeffs[0]
		
		if 	isinstance(coeffs,CMonome):			
			self._monomes[coeffs._exposant]=CMonome(coeffs._mantisse,coeffs._exposant)
			self._coeffs=[[coeffs._mantisse,coeffs._exposant]]
			
			
		if isinstance(coeffs,list) and len(coeffs)>0 and SontDes(coeffs,CMonome):
			self._coeffs=[]
			for m in coeffs:
				self._monomes[m._exposant]+=m				
			self._degre=self.degre()
			for i in range(self._degre+1):
				print(i,type(self._monomes[0]))
				self._coeffs.append([self._monomes[i]._mantisse,i])
			
		
		"""if EstUneChaine(coeff):
			Dprint("EstUneChaine")
			a=re.match(r"(?P<avant>.*)(?P<mantisse>[+\-0-9\.]*).*"+self._variable+"\^(?P<exposant>[0-9\.+\-]*)$",coeff)
			a=re.match(r"^(?P<avant>.*)(?P<mantisse>[0-9+\-\.]+) "+_variable+"\^(?P<exposant>[0-9\.+\-]*)$",coeff)

			
			if a:
				mantisse=float(a.group("mantisse"))
				exposant=int(a.group("exposant"))
				print(mantisse,exposant)
				coeff=mantisse
				degre=exposant
		self._variable
		"""
		
		
		
		
		
		
		
		
		
		
		
		
		
			
	def ZZinitMonomes(self):
		pass
		
	
	def __str__(self):
		return self.affiche()
		
	def affiche(self,EnleveSigneInitial=True,decroissant=True):	
		Tprint("CPolynome.affiche()")
		affich=""
		if decroissant==True:
			for i in range(len(self._monomes)-1,0-1,-1):	
				affich +=self._monomes[i].affiche(EnleveSigneInitial=EnleveSigneInitial*(i==self.degre()))
		if decroissant!=True:
			for i in range(0,len(self._monomes)):
				affich +=self._monomes[i].affiche(EnleveSigneInitial=EnleveSigneInitial*(i==0))
		Dprint("167 : affich : ",affich)
		print(affich)
		return affich
	
	def exposant(self):
		self._exposant=len(self._coeffs)
		return self._exposant
		
	def degre(self):
		"""
		n=len(self._coeffs)
		i=n-1
		while self._coeffs[i]==0:
			i-=1
			if i==-n:
				return -1		
		self._degre=i		
		return self._degre
		"""
		#print(self._monomes)
		#print(self._monomes.keys())
		return max(self._monomes.keys())
		
		

	def __add__(self,mon2):
		#liste des exposants rangés,uniques(par set)
		#print(type(self._monomes),type(mon2._monomes))
		#print(len(self._monomes),len(mon2._monomes))
		#print(self._monomes,mon2._monomes)
		exposants=list(set([m._exposant for m in self._monomes.values()]+[m._exposant for m in mon2._monomes.values()]))
		#print( [CMonome(self._monomes[exposant]._mantisse+mon2._monomes[exposant]._mantisse,exposant)._mantisse for exposant in exposants ])
		
		return CPolynome ( [CMonome(self._monomes[exposant]._mantisse+mon2._monomes[exposant]._mantisse,exposant) for exposant in exposants ])
		
	
	def __mul__(self,B):
		if EstUnNombre(B):
			B=CPolynome(B)
		Dprint("205")	
		dA=self.degre()
		dB=B.degre()
		Dprint("208")	
		monomes=[]
		print(self)
		print(B)
		for d in range(dA+dB+1):
			Dprint("211 : degre ",d)
			c=0
			for k in range(d+1):
				Dprint("k=*d-k",k, end=";")
				c+=self._monomes[k]._coeff*B._monomes[d-k]._coeff
			Dprint("215 c="	,c)
			monomes.append(CMonome(c,d))	
		return CPolynome(monomes)
	
	def __sub__(self,B):
		return self+CPolynome([-1,0])*B
	
	def __div__(self,scalaire):
		try:
			return self.__mul__(1/scalaire)
		except:
			return Nan
	
	
	def Division(self,div=None):
		if div==None:
			div=CPolynome(1)
		A,dA=self,self._degre
		D,dD=div,div._degre
		if dA>dD:
			#t=A._monomes[dA]/D._monomes[dD]
			t=A._monomes[dA].__div__(D._monomes[dD])
			reste=A-self*t
			return t+CPolynome(reste.Division(div))
		elif dA==dD:
			t=A._monomes[dA]/D._monomes[dD]	
			return t,CPolynome[0]
		else:
			return CPolynome[0],A
			
		

	'''
	def __call__(self,x):
		p=0
		for ai in reversed(self._coeffs):
			p=ai+x*p
		return p
	'''
	def deriv(self):
		Tprint("CPolynome.deriv")
		exposants=[m._degre for m in self._monomes.values()]
		print(exposants)
		return CPolynome ( [ CMonome(exposant*self._monomes[exposant]._coeff,exposant-1) \
		for exposant in exposants if exposant!=0 ] )
	
	def deriv_n(self,n):
		p=self
		for i in range(n):			
			p=p.deriv()
		return p	
	
	

	
global main

if __name__ == "__main__":
	print("Le programme lancé est "+sys.argv[0])
	
	print(_FonctionDuProgramme)
	print("version:"+_Version)
	

	"""
	A=CPolynome([1,2,3])
	#A.affiche(decroissant=False)

	B=CPolynome([10,1])
	#B.affiche()
	"""
	#print(A*B)
	B=CMonome("-2x^5")
	print(B)
	A=CPolynome(B)
	print(A._monomes[5]._mantisse)
	print(type(A))
	
	A=A*A
	print(A._monomes[5])
	print(type(A._monomes))
	exit()
	A=CMonome("-0.58x^9")+CMonome("1x^8")
	
	A=CMonome(-0.58,9)+CMonome(-0.58,9)
	A.affiche()
	
	print(A)
	
	
	A=CPolynome(CMonome("-2x^5")).deriv_n(3)
	print(A)
	A.affiche()
	A=CMonome("(-2+3)x^(5+1)")
	print(A)
	
	A=CMonome("(3.0+4.0)x^(2)")
	print(A)
	
	
	A=CPolynome(CMonome("-8x^7")).Division(CPolynome(CMonome("-2x^4")))
	

try:
	_Log.close()
except:
	pass	



