#!/usr/bin/python3
# -*- coding: iso-8859-15 -*-
from __future__ import print_function
_FonctionDuProgramme="Classe Cdictionnaire traduisant les fichiers"
#print(_FonctionDuProgramme)
_Version="3.1.0.0"
_import="re,os,sys,string,CFichierContenu V1.3.0,CBaseDeDonnees V1.5.3"
#voir dictionnaireV16.dia

'''
3.1.0.0 rangement dans classes3

 rajouter : 
	LexiqueGenre-UTF8.txt : genre des mots machin#m : {mot}#{m|f|rien=m+f} fait V17
	LexiqueAdverbe-UTF8.txt : a capella : {mot} fait V17
	Lexique380-UTF8.txt : 
tt	ota	ter	VER			16.81	42.03	0.00	0.14	sub:imp:3s;	1	2	0	4	3	VCVC	VCV	0	18	0	0	o-ta	2	V-CV	tt	ato	-tt	VER	89	28	2	1	ter	1
t	ote	ter	VER	m	s	16.81	42.03	3.18	5.47	par:pas;	2	11	0	3	3	VCV	VCV	3	19	3	3	o-te	2	V-CV	t	eto	-t	VER,ADJ	89	28	1.65	1	t	1
	
'''

""" UTILISATION :
V17 rcriture totale

V16	deplacement des dicohpysique et dicosblender dans sous-repertoire
	ajout de groupes de phrases
V15 tentative d utilisation des propositions
V14.2  TraduitFormules MTW
V14.1 : abandonn
V14 utilisation de plusieurs dictionnaires : self.DicoAdditionnels()
V13.1 self._FichierTraduit=self.TraduitUnFichier(fichier) 
V13 : ajout de PrepareLigne et propositions dans =>Traduit
import dictionnaire
dico=br_Cdictionnaire()
LigneTraduite=dico.Traduit(LigneATraduire)
"""


dossier="/opt/CLASSES3"
import sys
if dossier not in sys.path:
    sys.path.append(dossier)
#print("version:"+_Version)
_FonctionDuProgramme+="\n\
Version:"+_Version+"\n"
from CFonctions3 import *
"""
Tprint() : affiche titres
Dprint() : affiche debug

Cdictionnaire._BD_MotsGenre : peu utilisable, voir _InfosSurMotFr
Cdictionnaire._BD_AnglaisFrancais : tous les couples de mots/expressions
Cdictionnaire._InfosSurMotFr : self._InfosSurMotFr[mot]=[Id, mot_principal, id_mot_principal, typeuh, genre, pluriel, sonpluriel, sonsingulier, sonfeminin, sonmasculin ]
self._TraductionAnglFran=None

Cdictionnaire.CreeDictionnaire #rempli self.trans=[[motEng,motFr] ]
Cdictionnaire.Range # ordonn par longueur en anglais puis alphabtiquement
Cdictionnaire.Uniq #s'assure de l'unicit


zzCdictionnaire.CreePlurielsEnS4 #AJOUT DE MOTS AVEC UN s FINAL [mo,po] -> [mos,pos]
zzCdictionnaire.CreeDictionnairePhysique #AJOUT DE MOTS [mo,po]
zzCdictionnaire.CreeDictionnaireBlender #AJOUT DE MOTS [mo,po]

zzCdictionnaire.PremieresTraductions #specialites anglaises a pr traduire

zzCdictionnaire.DernieresTraductions #specialites francaises a post traduire

zzCdictionnaire.ChercheUnMot #chercher un mot
zzCdictionnaire.Traduit # Traduit une ligne
zzCdictionnaire.Traduit43 # COEUR DE LA TRADUCTION
"""
import re,os,sys
from string import capwords
##################### debug
_debug=False # _debug=True
_Affiche_Titres=False # _Affiche_Titres=True 
def Tprint(*args, **kwargs):
	if _Affiche_Titres==True:
		print(*args, **kwargs)	
"""
if _debug==True:
	_FichierLOG=open('traducteur.log','w')
"""
_FichierLOG=open('/tmp/CDictionnaire.log','w')

def Dprint(*args, **kwargs):
	if _debug==True:
		print("debug:",*args, **kwargs)

E_debug=False
def Eprint(*args, **kwargs):
	if E_debug==True:
		print("E_debug:",*args, **kwargs)

F_debug=False
def Fprint(*args, **kwargs):
	if F_debug==True:
		print("F_debug:",*args, **kwargs)
		
def YYLenPrint(*args):
	if _debug==True:
		print("LenPrint:",*args,len(*args),file=_FichierLOG)

def YYTradPrint(*args, **kwargs):
	if _debug==True:
		print("TRAD:",*args, **kwargs)		
		
def ErrPrint(*args, **kwargs):
	print("ErrPrint:",*args, **kwargs)
	
def YYTraduitUnFichierPrint(*args, **kwargs):
	print("TRAD:",*args, **kwargs)	


import CFichierContenu #1.3.0
from CFichierContenu import *
		
		
##################### CLASSE PRINCIPALE : Cdictionnaire
class Cdictionnaire(object):
	def __init__(self,auto=False):
		""" Cdictionnaire.__init__() """
		Tprint('\n-* Cdictionnaire.__init__()')
		
		self._BD_MotsGenre=None
		self._BD_AnglaisFrancais=None
		self._InfosSurMotFr=None
		self._TraductionAnglFran=None
		
		self._trans=[]
		if auto==True:
			self.CreeDictionnaire()
			self.AjoutePluriels()
			self.Range()
			
	def ZZAjoutePluriels(self):
		Tprint('-** Cdictionnaire.AjoutePluriels')
		
	
	def CreeDictionnaire(self):#rempli self.trans=[[motEng,motFr] ]
		Tprint('-** Cdictionnaire.CreeDictionnaire')
		self._trans+=self.DicoPrincipal()		
		return self._trans

	def DicoPrincipal(self):
		Tprint('-** Cdictionnaire.DicoPrincipal()')
		rep='/opt/CLASSES3/dictionnaires_additionnels/'
		print(sys.argv)
		#dico=rep+"TousLesDicosSingulier.dic"
		dico=rep+"TousLesDicosSingulier.dic"
		trans=self.RemplisDico(dico) # ["en#fr","en#fr" ...]
		return trans

	
	def RemplisDico(self,fich='dictionnaires_additionnels/TousLesDicos.dic'): #AJOUT DE MOTS [mo,po] dans un dico non prpar
		Tprint('-** Cdictionnaire.RemplisDico("'+fich+'")')
		#anciennement DicoAdditionnel(fich)
		#'nom eng, nom fran' V8
		# ne pas commencer par a ou an ou the
		trans=[]

		FF=CFichierContenu(fich)
		if FF._ouvert:
			for ligne in FF.Lignes(False):
				if '#' in ligne:
					tmp=ligne.split('#')
					trans+=[(tmp[0],tmp[1])]
					Dprint('** '+tmp[0]+'=>'+tmp[1])
		else:
			ErrPrint('le fichier "'+fich+'" n\'est pas utilisable.')#1.3.1

		return trans
	
	def Range(self,croissant=True):# ordonn par longueur en anglais puis alphabtiquement
		Tprint('-*** Cdictionnaire.Range()')
		self._trans=sorted ( self._trans , key=lambda tabl: tabl[0] , reverse=croissant )
		self._trans=sorted ( self._trans , key=lambda tabl: len(tabl[0] ) ,reverse=croissant)
		#self._trans=sorted ( self._trans )
		self.Uniq()
		#self.Uniq()
		return self._trans
		
	def Uniq(self): #s'assure de l'unicit		
		Tprint('-**** Cdictionnaire.Uniq()')
		#print(len(self._trans))		
		for no in range(len(self._trans)-1,0-1,-1):
			if self._trans[no][0]==self._trans[no-1][0] and self._trans[no][1]==self._trans[no-1][1]:
				print('----',self._trans[no],' est en double')
				del self._trans[no]		
		return self._trans		
	
	def EnregistreDictionnaire(self):
		Tprint('-** Cdictionnaire.EnregistreDictionnaire()')
		f=open('/tmp/DicoEnCours',"w")
		for en,fr in self._trans:
			print(en+'#'+fr,file=f)
		f.close()



		
		

	def LitBaseDeDonnees(self,BD_MotsGenre=True,BD_AnglaisFrancais=True):
		Tprint('-** Cdictionnaire.LitBaseDeDonnees()')
		BD=CBaseDeDonnees()
		config = {
		'host': 'localhost',
		'database': 'dictionnaire',
		'user': 'dictionnaire',
		'password': 'dictionnaire',
		}		
		BD.Mysql_Connection(config)
		
		
		if BD_MotsGenre==True:
			print("remplissage de LitBaseDeDonnees::_BD_MotsGenreID")
			self._BD_MotsGenre=None
			self._BD_MotsGenreID=br_CDICO()
			# [True,[self._NomsColonnes,self._resultats]]
			#tmp=BD.Mysql_Select("SELECT `id`, `mot`, `mot_principal`, `id_mot_principal`, `typeuh`, `genre`, `pluriel`, `sonpluriel`, `sonsingulier`, `sonfeminin`, `sonmasculin` FROM `MotsGenre`;")
			dico=dict()
			dico["quoi"]=['id', 'mot', 'mot_principal', 'id_mot_principal', 'typeuh', 'genre', 'pluriel', 'sonpluriel', 'sonsingulier', 'sonfeminin', 'sonmasculin']
			dico["table"]="MotsGenre"
			dico["where"]=None
			tmp=BD.Select(dico)
			if tmp==None:
				print('erreur dans la lecture de `MotsGenre`')
			else:
				self._BD_MotsGenre_Champs=tmp[0]
				self._BD_MotsGenre=tmp[1]
				#print(tmp[1][1])
				#self._TraductionAnglFran[]=[]
			for Id, mot, mot_principal, id_mot_principal, typeuh, genre, pluriel, sonpluriel, sonsingulier, sonfeminin, sonmasculin in self._BD_MotsGenre:
				#self._BD_MotsGenreID[Id]=[mot, mot_principal, id_mot_principal, typeuh, genre, pluriel, sonpluriel, sonsingulier, sonfeminin, sonmasculin]
				self._BD_MotsGenreID[Id]=dict()
				if True==True:
					self._BD_MotsGenreID[Id].update({"mot":mot})
					self._BD_MotsGenreID[Id].update({"mot_principal":mot_principal})
					self._BD_MotsGenreID[Id].update({"id_mot_principal":id_mot_principal})
					self._BD_MotsGenreID[Id].update({"typeuh":typeuh})
					self._BD_MotsGenreID[Id].update({"genre":genre})
					self._BD_MotsGenreID[Id].update({"pluriel":pluriel})
					self._BD_MotsGenreID[Id].update({"sonpluriel":sonpluriel})
					self._BD_MotsGenreID[Id].update({"sonsingulier":sonsingulier})
					self._BD_MotsGenreID[Id].update({"sonfeminin":sonfeminin})
					self._BD_MotsGenreID[Id].update({"sonmasculin":sonmasculin})
					
			print(" "*7,len(self._BD_MotsGenreID),"mots")
			print(" "*7,"fin de remplissage de LitBaseDeDonnees::_BD_MotsGenreID")
			
			
		if BD_AnglaisFrancais==True:
			print("remplissage de LitBaseDeDonnees::_BD_AnglaisFrancais")
			self.InfosSurMot()
			print(self._InfosSurMotFr["plateforme"])
			self._BD_AnglaisFrancais=None
			self._TraductionAnglFran=br_CDICO()
			# [True,[self._NomsColonnes,self._resultats]]
			#tmp=BD.Mysql_Select("SELECT `id`, `anglais`, `francais` FROM `AnglaisFrancais`;")
			dico=dict()
			dico["quoi"]=['id', 'anglais', 'francais']
			dico["table"]="AnglaisFrancais"
			dico["where"]=None
			tmp=BD.Select(dico)
			
			if tmp==None:
				print('erreur dans la lecture de `AnglaisFrancais`')
			else:
				self._BD_AnglaisFrancais_Champs=tmp[0]
				self._BD_AnglaisFrancais=tmp[1]
			
			for Id,en,fr in self._BD_AnglaisFrancais:

					
				try:
					#EstUnNom=(self._InfosSurMotFr[fr][3]=='NOM')
					EstUnNom=(self._InfosSurMotFr[fr]["typeuh"]=='NOM')
				except:
					EstUnNom=False
				
				
				self._TraductionAnglFran[en]=fr
				if EstUnNom:					
					if en[0] in 'aeiouy':
						en2='an '+en
					else:
						en2='a '+en
					
					#if self._InfosSurMotFr[mot][4]=='f':
					try:
						if self._InfosSurMotFr[fr]["genre"]=='f':						
							fr2='une '
							fr3='la '
						else:
							fr2='un '
							fr3='le '						
					except:
						fr2='un '
						fr3='le '
						
					fr2+=fr						
					self._TraductionAnglFran[en2]=fr2
						
					en3='the '+en
					fr3+=fr
					self._TraductionAnglFran[en3]=fr3
					
					
					
					
					
					
					
				#ajout des pluriels et fminins ########
				
				
				plen,plfr=self.Pluriel(en,"en"),self.Pluriel(fr,"fr")
				if plen!=en or plfr!=fr:
					self._TraductionAnglFran[plen]=plfr
					
				femen,femfr=self.Feminin(en,"en"),self.Feminin(fr,"fr")	
				if femen!=en or femfr!=fr:
					self._TraductionAnglFran[femen]=femfr
				
					plfemen,plfemfr=self.Pluriel(femen,"en"),self.Pluriel(femfr,"fr")
					if plfemen!=en or plfemfr!=fr:
						self._TraductionAnglFran[plfemen]=plfemfr
			
			print(" "*7,len(self._BD_AnglaisFrancais),"mots")
			print(" "*7,"fin de remplissage de _BD_AnglaisFrancais")
			
			print("LitBaseDeDonnees::ordonne")
			self._trans=sorted ( self._TraductionAnglFran.items() , key=lambda tabl: len(tabl[0]))
			self.Range()
			print(" "*7,"fin de LitBaseDeDonnees::ordonne")
		
		#delete self._BD_MotsGenreID				
				
	def Feminin(self,mot,langue):
		if langue=="fr":
			try:
				#Idsonfeminin=self._InfosSurMotFr[mot][8]
				Idsonfeminin=self._InfosSurMotFr[mot]["sonfeminin"]
				#sonfeminin=self._BD_MotsGenreID[Idsonfeminin][0]
				sonfeminin=self._BD_MotsGenreID[Idsonfeminin]["mot"]
				return sonfeminin
			except:
				return mot
		else:	
			return mot
	
	def Pluriel(self,mot,langue):
		if langue=="fr":
			try:
				#Idsonpluriel=self._InfosSurMotFr[mot][6]
				Idsonpluriel=self._InfosSurMotFr[mot]["sonpluriel"]
				#sonpluriel=self._BD_MotsGenreID[Idsonpluriel][0]
				sonpluriel=self._BD_MotsGenreID[Idsonpluriel]["mot"]
				return sonpluriel
			except:
				return mot+"s"
		else:	
			return mot+"s"
		

	def Remplis(self):
		Tprint('-** Cdictionnaire.Remplis()')
		if self._BD_MotsGenre==None:
			self.LitBaseDeDonnees(BD_MotsGenre=True,BD_AnglaisFrancais=False)
		if self._BD_AnglaisFrancais==None:
			self.LitBaseDeDonnees(BD_MotsGenre=False,BD_AnglaisFrancais=True)
		if self._InfosSurMotFr==None:
			self.InfosSurMot()
		

	def InfosSurMot(self):
		Tprint('-** Cdictionnaire.InfosSurMot()')
		if self._BD_MotsGenre==None:
			self.LitBaseDeDonnees(BD_MotsGenre=True,BD_AnglaisFrancais=False)
		
		self._InfosSurMotFr=None
		if self._BD_MotsGenre!=None:
			self._InfosSurMotFr=br_CDICO()
			for Id, mot, mot_principal, id_mot_principal, typeuh, genre, pluriel, sonpluriel, sonsingulier, sonfeminin, sonmasculin in self._BD_MotsGenre:
				if self._InfosSurMotFr[mot] == "":
					#self._InfosSurMotFr[mot]=[Id, mot_principal, id_mot_principal, typeuh, genre, pluriel, sonpluriel, sonsingulier, sonfeminin, sonmasculin ]
					#self._InfosSurMotFr[mot]=[Id, mot_principal, id_mot_principal, typeuh, genre, pluriel, sonpluriel, sonsingulier, sonfeminin, sonmasculin ]
					if True==True:
						self._InfosSurMotFr[mot]=dict()
						self._InfosSurMotFr[mot].update({"Id":Id})
						self._InfosSurMotFr[mot].update({"mot_principal":mot_principal})
		
						self._InfosSurMotFr[mot].update({"id_mot_principal":id_mot_principal})
						self._InfosSurMotFr[mot].update({"typeuh":typeuh})
		
						self._InfosSurMotFr[mot].update({"genre":genre})
						self._InfosSurMotFr[mot].update({"pluriel":pluriel})
		
						self._InfosSurMotFr[mot].update({"sonpluriel":sonpluriel})
						self._InfosSurMotFr[mot].update({"sonsingulier":sonsingulier})
		
						self._InfosSurMotFr[mot].update({"sonfeminin":sonfeminin})
						self._InfosSurMotFr[mot].update({"sonmasculin":sonmasculin})
					
				else:
					self._InfosSurMotFr[mot]=None
				#print(mot+" dupliqu")
		return self._InfosSurMotFr		


	def ChercheUnMot(self,mot='gravitation',MotExacte=False):#chercher un mot V17
		Tprint('-** Cdictionnaire.ChercheUnMot(mot="gravitation",MotExacte=False)')
		
		Traduction_Exacte=[]
		mot=mot.lower()
		print('\nrecherche du mot '+mot)
		self.Remplis()
		print("mots en francais : ",self._InfosSurMotFr[mot])
		print('traduction du mot anglais vers fr : ',self._TraductionAnglFran[mot])
		'''
		for mots in self.:
			if mot==mots[0].lower() or mot==mots[1].lower():
				Traduction_Exacte.append(mots)
			
			if mot in mots[0].lower() or mot in mots[1].lower():
				print(' rsultat de la recherche :'+'"'+mots[0]+'"'+"=>"+'"'+mots[1]+'"')
			else:
				if MotExacte==False:
					if mot in mots[0].lower()[0:-1] or mot in mots[1].lower()[0:-1] or mot[0:-1] in mots[0].lower() or mot[0:-1] in mots[1].lower():
						print(" rsultat approximatif : "+mots[0]+" => "+mots[1])
		'''
						
		print('fin de recherche du mot '+mot)	
















			
					
	def XXYYDicoAdditionnels(self):
		Tprint('-** Cdictionnaire.DicoAdditionnels()')
		rep='dictionnaires_additionnels/'
		dicos=[rep+'MTW04.txt',rep+'MTW07.txt',rep+'dico_additionnel.txt',rep+'dico_additionnel-zola-jaccuse.txt','LIVRES/lepetit prince/dico_additionnel-lepetitprinceChap01.txt']
		dicos=[rep+'MTW_sommaire-fr.txt',rep+'MTW_21-40.txt',rep+'MTW_01-20.txt',rep+'dico_additionnel.txt',rep+'dico_additionnel-zola-jaccuse.txt',rep+'dico_additionnel-lepetitprinceChap01.txt']
		dicos+=[rep+'MTW.txt',rep+'dico_additionnel-physique.txt']
		dicos+=[rep+'MTW.txt',rep+'dico_additionnel-physique.txt']
		dicos+=[rep+'dico_additionnelV16.txt',rep+'dico-linux.txt']
		dicos+=[rep+'DictionnairePhysique',rep+'DictionnaireBlender']
		Dicoadd=[]
		for dico in dicos:
			Dicoadd+=self.DicoAdditionnel(dico)
		return Dicoadd
			
		
		
	def XXYYDicoAdditionnel(self,fich='dico_additionnel.txt'): #AJOUT DE MOTS [mo,po] dans un dico non prpar
		Tprint('-** Cdictionnaire.DicoAdditionnel("'+fich+'")')
		#'nom eng, nom fran' V8
		# ne pas commencer par a ou an ou the
		Tprint('-*** init Cdictionnaire.DicoAdditionnel:',fich)		
		DicoAdd=[]
		if os.path.isfile(fich):
			f= open(fich,'r')
			for ligne in f.readlines():			
				if '#' in ligne:
					tmp=ligne.split('\n')[0].split('#')
					DicoAdd+=[(tmp[0],tmp[1])]
					Dprint('** '+tmp[0]+'=>'+tmp[1])
			f.close()
		else:
			ErrPrint('le fichier "'+fich+'" n\'existe pas.')			
			
		fich='dictionnaires_additionnels/dico_additionel-formules.txt'
		DicoFormules=[]
		if os.path.isfile(fich):
			f= open(fich,'r')
			for ligne in f.readlines():
				if '#' in ligne:
					tmp=ligne.split('\n')[0].split('#')
					DicoFormules+=[(tmp[0],tmp[1])]
					#DicoFormules+=[(tmp[0].replace('\\','\\\\'),tmp[1])]
					#DicoFormules+=[(tmp[0].replace(')','\)'),tmp[1])]
					#DicoFormules+=[(tmp[0].replace('(','\('),tmp[1])]
					Dprint('** '+tmp[0]+'=>'+tmp[1])
			f.close()
		else:
			ErrPrint('le fichier "'+fich+'" n\'existe pas.')
		self._DicoFormules=DicoFormules
		return DicoAdd
	
	
	
	

		
	
	def YYCreePlurielsEnS4(self):#AJOUT DE MOTS AVEC UN s FINAL [mo,po] -> [mos,pos]
		Tprint('-*** Cdictionnaire.CreePlurielsEnS4')
		Pluriels=[]
		for l in self.trans:
			try:
				if l[0][-1]!='s':			
					Pluriels+=[(l[0]+'s',l[1]+'s')]
			except:
				print(l)		
		#self.trans+=Pluriels
		
		return Pluriels
		
			
	def YYCreeDictionnairePhysique(self):#AJOUT DE MOTS [mo,po]
		Tprint('-*** Cdictionnaire.CreeDictionnairePhysique : obsolete')
		physique=[]
					

		#self.trans+=physique
		return physique

	
	def YYCreeDictionnaireBlender(self):#AJOUT DE MOTS [mo,po]
		Tprint('-*** Cdictionnaire.CreeDictionnaireBlender : obsolete')
		blender=[]		
		#self.trans+=blender
		return blender


import time
class CTraductionDUneLigne(object):
	def __init__(self,dico,ligne):
		
		self._ligne=ligne
		self._dico=dico
		
	def TraduitUneLigne(self):
		Tprint('-*** CTraductionDUneLigne.TraduitUneLigne()')
		
		if self._ligne!="\n":
			self._ligne=self.PrepareLigne(self._ligne)
			self._blocs=self.BlocsATraduire(self._ligne)
			Fprint(self._ligne)
			Fprint(self._blocs)
			ligne=""
			for no,(bloc,ATraduire) in enumerate(self._blocs):
				if ATraduire==True:
					bloc=self.PremieresTraductions(bloc)
					
					"""
					for en in self._dico._TraductionAnglFran:
						fr=self._dico._TraductionAnglFran[en]
					"""	
					#for en,fr in self._dico._trans:
					for en,fr in [(a,b) for (a,b) in self._dico._trans if a.lower() in bloc.lower()]:
						bloc=re.sub("([^a-zA-Z])("+en+")([^a-zA-Z])",'\g<1>'+fr+'\g<3>',bloc)
					self._blocs[no][0]=bloc
					
					
					"""
					BlocLower=bloc.lower()
					for en,fr in [(a,b) for (a,b) in self._dico._trans if a.lower() in BlocLower:#bloc.lower()]:
						s=re.search('(.*)([^a-zA-Z])('+en.lower()+')([^a-zA-Z])(.*)',BlocLower)#bloc.lower())
						if s==None:
							exit(546)#BlocsTemp+=[[bloc,ATraduire]]
						aa,a,b,c,cc=s.groups()
						s=re.search('('+aa+a+')'+'(.*)'+'('+c+cc+')',bloc)
						a,b,c=s.groups()
					"""	

			
			
				#self._blocs[no][0]=self.DernieresTraductions(self._blocs[no][0])
				
			Fprint(self._blocs)
		else:
			self._blocs=[["",False]]	
				
		print(time.time())		
				
			
	def PrepareLigne(self,ligne):
		Tprint('-*** CTraductionDUneLigne.PrepareLigne()')
		ligne=' '+ligne.strip()+' '
		'''
		ponctuations=[',','\?','.',';','/',':','\!']
		for ponctuation in ponctuations:
			print('-------------------',ponctuation)
			ligne=re.sub(ponctuation,' '+ponctuation+' ',ligne)
		'''	
		self._ligne=ligne
		return ligne	
	
	def BlocsATraduire(self,ligne):
		ExpressionsInterdites=[r'\\begin{[a-zA-Z]*}'\
		,r'\\end{[a-zA-Z]*}'\
		,r'\\section'\
		,r'\\subsection'\
		,r'\\usepackage{[a-zA-Z,]*}'\
		,r'\\cite{[a-zA-Z0-9 ,]*}'\
		,r'\\usepackage\[[a-zA-Z ,]*\]{[a-zA-Z ,]*}'\
		,r'\\newcommand.*'\
		,r'\\renewcommand.*'\
		,r'\\[a-zA-Z]*']
		blocs=[[ligne,True]]
		Eprint("blocs")
		Eprint(blocs)
		for EI in ExpressionsInterdites:
			Eprint('EI=',EI)
			BlocsTemp=[]
			for no,(bloc,ATraduire) in enumerate(blocs):
				Eprint(bloc,ATraduire)
				if ATraduire==True:
					Eprint('====','(.*)('+EI+')(.*)',bloc)
					s=re.search('(.*)('+EI+')(.*)',bloc)
					if s==None:
						BlocsTemp+=[[bloc,ATraduire]]
					else:
						Eprint("sgroups",s.groups())
						a,b,c=s.groups()
						if a!="":
							BlocsTemp+=[[a,True]]
						BlocsTemp+=[[b,False]]
						if c!="":
							BlocsTemp+=[[c,True]]
				else:
					BlocsTemp+=[[bloc,ATraduire]]
				Eprint(BlocsTemp)
			blocs=BlocsTemp
		return blocs#[[ligne,True]]
		
	def PremieresTraductions(self,ligne):#specialites anglaises a pr traduire
		Tprint('-** CTraductionDUneLigne.PremieresTraductions V<=15')
				
		#ligne=self.TraduitFormules(ligne)
		
		self._PTdivers=[]				
		self._PTdivers+=[("([^a-zA-Z])([a-zA-Z]*)'s ([a-zA-Z]*)([^a-zA-Z])","\g<1>\g<3> de \g<2>\g<4>")]
		#self._PTdivers+=[("([^a-zA-Z])a([^a-zA-Z])","\g<1>un\g<2>")]
		#self._PTdivers+=[("([^a-zA-Z])an([^a-zA-Z])","\g<1>un\g<2>")]		
		self._PTdivers+=[("([^a-zA-Z])'ll([^a-zA-Z])","\g<1> will\g<2>")]
		
		self._PTdivers+=[(chr(8212),'"')]
		self._PTdivers+=[(chr(8216),"'")]

		#self._PTdivers+=[('\x8094','-')]
		for t in self._PTdivers:
			ligne=re.sub(t[0],t[1],ligne)
		return ligne

	def ZZDernieresTraductions(self,BLOC):#specialites francaises a post traduire
		Tprint('-** Cdictionnaire.DernieresTraductions V>=16')
		self._DTPremieresContractions=[]
		self._DTPremieresContractions+=[("([^a-zA-Z])le ([aeiouyAEIOUY])","\g<1>l'\g<2>")]
		self._DTPremieresContractions+=[("([^a-zA-Z])la ([aeiouyAEIOUY])","\g<1>l'\g<2>")]
		
		for t in self._DTPremieresContractions:
			#print((t[0],t[1],ligne))
			BLOC=re.sub(t[0],t[1],BLOC)
		
		self._AnglaisNOnTraduit=[]
		#self._AnglaisNOnTraduit+=[('','')]
		#self._AnglaisNOnTraduit+=[("i ont","j'ai")]
		
		for t in self._AnglaisNOnTraduit:
			BLOC=re.sub('([^a-zA-Z])'+t[0]+'([^a-zA-Z])','\g<1>'+t[1]+'\g<2>',BLOC)
			
			
		self._DTContractions=[]
		self._DTContractions+=[('de le','du')]
		self._DTContractions+=[('de les','des')]
		self._DTContractions+=[(' le','au')]
		self._DTContractions+=[(' les','aux')]
		self._DTContractions+=[("de o","d'o")]
		self._DTContractions+=[("de un","d'un")]
		self._DTContractions+=[("de une","d'une")]
		self._DTContractions+=[("ce est","c'est")]
		self._DTContractions+=[("Ce est","C'est")]
		self._DTContractions+=[("son la","sa")]
		
		for t in self._DTContractions:
			BLOC=re.sub('([^a-zA-Z])'+t[0]+'([^a-zA-Z])','\g<1>'+t[1]+'\g<2>',BLOC)
			
			
		
		self._erreurs=[]
		self._erreurs+=[("le ce","ce")]
		self._erreurs+=[("ce spare","cette sparation")]
					
		for t in self._erreurs:
			BLOC=re.sub('([^a-zA-Z])'+t[0]+'([^a-zA-Z])','\g<1>'+t[1]+'\g<2>',BLOC)
			

		
		
		

		"""
		self._Tex=[]
		self._Tex+=[(chr(92)+'commencer',chr(92)+'begin{')]
		self._Tex+=[('\tiqueter{','\label{')]
		self._Tex+=[('\fin{','\end{')]
		for t in self._Tex:
			ligne=re.sub('([^a-zA-Z])'+t[0]+'([^a-zA-Z])','\g<1>'+t[1]+'\g<2>',ligne)
		"""	
			
		'''			V16
		Erreurs=[('faSur','faon')]
		for t in Erreurs:
			ligne=re.sub(t[0],t[1],ligne)
		'''
		return BLOC	
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		

	def YYTraduitFormules(self,ligne):
		for t in self._DicoFormules:
			#print("=============",ligne,"===========")
			#print("=============",t[0],"===========")
			ligne=ligne.replace(t[0],t[1])
			#print(ligne)
		return ligne
		
		


	

	def YYTraduitTex(self,LigneATraduire):# Traduit une ligne
		Tprint('-** init Cdictionnaire.Traduit des lignes tex')
		_TraduitDesLeDebut=False
		
		
		
		
		
		propositions=[LigneATraduire]
		_LigneTraduite=''
		
		for proposition in propositions:
			LigneTraduite=proposition
			LigneTraduite=self.PrepareLigne(LigneTraduite)			
			LigneTraduite=self.PremieresTraductions(LigneTraduite)
			
			LigneTraduite=self.Traduit43(LigneTraduite)
			
			if LigneTraduite!=False:
				LigneTraduite=self.DernieresTraductions(LigneTraduite)
				LigneTraduite=LigneTraduite+','
			else:
				LigneTraduite=proposition
			_LigneTraduite+=LigneTraduite
		return _LigneTraduite[0:-1]
	
	def YYZZTraduit(self,LigneATraduire):# Traduit une ligne
		Tprint('-** Cdictionnaire.Traduit une ligne V<=15')
		#LigneATraduire=' '+LigneATraduire.lower()+' ' # on rajoute 2 espaces
		#LigneATraduire=self.ApostropheS(LigneATraduire)
		LigneATraduire=self.TraduitFormules(LigneATraduire)
		#propositions=LigneATraduire.split(',')
		propositions=[LigneATraduire]
		_LigneTraduite=''
		
		for proposition in propositions:
			LigneTraduite=proposition
			LigneTraduite=self.PrepareLigne(LigneTraduite)			
			LigneTraduite=self.PremieresTraductions(LigneTraduite)
			
			LigneTraduite=self.Traduit43(LigneTraduite)
			#LigneTraduite,BlocEnCoursDeTraduction,BlocEnCoursDeTraductionMinuscules,BlocsTraduits = self.Traduit16(LigneTraduite)#V16
			
			if LigneTraduite!=False:
				#print('--a',LigneTraduite)
				LigneTraduite=self.DernieresTraductions(LigneTraduite)
				LigneTraduite=LigneTraduite+','
				#print('--r',LigneTraduite)
			else:
				LigneTraduite=proposition
			_LigneTraduite+=LigneTraduite
		#print('--t',_LigneTraduite)	
		return _LigneTraduite[0:-1]

	def YYTraduit(self,LigneATraduire):# Traduit une ligne
		Tprint('-** Cdictionnaire.Traduit une ligne V>=16')		
		LigneATraduire=self.TraduitFormules(LigneATraduire)
		
		_LigneTraduite=''
		
		LigneATraduire=self.PrepareLigne(LigneATraduire)		
		LigneATraduire=self.PremieresTraductions(LigneATraduire)
		LigneTraduite,BlocEnCoursDeTraduction,BlocEnCoursDeTraductionMinuscules,BlocsTraduits = self.Traduit16(LigneATraduire)#V16
			
		#pas de majuscules/minuscules
		#_LigneTraduite=""
		for No in range(len(BlocEnCoursDeTraduction)):
			bloc=BlocEnCoursDeTraduction[No]
			if BlocsTraduits[No]==True:#on a du francais
				BlocEnCoursDeTraduction[No]=self.DernieresTraductions(bloc)
		
		_LigneTraduite=""
		for l in BlocEnCoursDeTraduction:
			_LigneTraduite+=l.lstrip()
		return _LigneTraduite
		
		
		
		
		
				
	
	def YYTraduitUnFichier(self,fichier):
		self._FichierTraduit=''
		if os.path.isfile(fichier):
			f=open(fichier,'r')
			for line in f:
				'''
				if self._tesseract==True:
					self._FichierTraduit+=self.Traduit(line)
				#TraduitUnFichierPrint(line)
				if self._tesseract==False:
					self._FichierTraduit+=self.Traduit(self.Tesseract(line))
				'''
				self._FichierTraduit+=self.Traduit(line)
			f.close()	
		return self._FichierTraduit
		

		
	

######################### COEUR DE LA TRADUCTION ########################	

	def YYTraduit16(self,LigneATraduire): #V16 #COEUR DE LA TRADUCTION
		Tprint('-** Cdictionnaire.Traduit16 V16')		
		#_TraductionFaite=False # au cas ou tous les mots traduits sont identiques en fr et us 
		#V<=16.0.0 BlocEnCoursDeTraduction=[' '+LigneATraduire[0:-2].strip()+' ']# on rajoute 2 espaces V4.1
		BlocEnCoursDeTraduction=[' '+LigneATraduire.strip()+' ']# #V16.0.1
		BlocEnCoursDeTraductionMinuscules=[BlocEnCoursDeTraduction[0].lower()]# on rajoute 2 espaces V4.1
		BlocsTraduits=[False]
		
		LenPrint("LigneATraduire="+LigneATraduire)
		
		for mots in self.trans:
			NoBloc = len(BlocEnCoursDeTraduction) - 1
			while NoBloc!=-1:							
				#for NoBloc in range(len(BlocEnCoursDeTraduction)-1,0-1,-1):
				Bloc     = BlocEnCoursDeTraduction[NoBloc]
				BlocMinus= BlocEnCoursDeTraductionMinuscules[NoBloc]
				#if BlocsTraduits[NoBloc]==False and mots[0] in BlocMinus:
				if BlocsTraduits[NoBloc]==False and mots[0]==re.sub("(.*)([^a-zA-Z])("+mots[0]+")([^a-zA-Z])(.*)",'\g<3>',BlocMinus):#V16.0.1
					
					LenPrint(BlocEnCoursDeTraduction)
					LenPrint(BlocEnCoursDeTraductionMinuscules)
					LenPrint(BlocsTraduits)
					LenPrint("NoBloc="+str(NoBloc))
					LenPrint("mots[0]="+mots[0])
					LenPrint("mots[1]="+mots[1])
					#LenPrint('BlocMinus='+BlocMinus,file=_FichierLOG)
					#BlocsTraduits=BlocsTraduits[0:NoBloc-1] +[False,True,False] + BlocsTraduits[NoBloc+1:len(BlocsTraduits)]
					
					##LenPrint(Bloc,file=_FichierLOG)
					##LenPrint(BlocMinus,file=_FichierLOG)
					#LenPrint(NoBloc,file=_FichierLOG)
					
					
					# optimiser en une Bloc , autre re.
					AvantMin=re.sub("(.*)([^a-zA-Z])("+mots[0]+")([^a-zA-Z])(.*)",'\g<1>\g<2>',BlocMinus)
					LenPrint("AvantMin="+AvantMin)
					ApresMin=re.sub("(.*)([^a-zA-Z])("+mots[0]+")([^a-zA-Z])(.*)",'\g<4>\g<5>',BlocMinus)
					#re.sub("(.*)([^a-zA-Z])("+mots[0]+")([^a-zA-Z])(.*)",'\g<3>',BlocMinus)
					MilieuMaj=self.MajMin(Bloc[len(AvantMin):len(BlocMinus)-len(ApresMin)] , mots[0] ,mots[1] )
					##LenPrint('$',MilieuMaj,'$',file=_FichierLOG)
					AvantMaj=" "+Bloc[:len(AvantMin)].strip()+" "
					ApresMaj=" "+Bloc[len(BlocMinus)-len(ApresMin):].strip()+" "
					MilieuMaj=" "+MilieuMaj.strip()+" "
					
					DeltaNoBloc=2
					Ajout=[]
					AjoutBool=[]
					if AvantMaj=="  ":
						DeltaNoBloc-=1
					else:
						Ajout=[AvantMaj]
						AjoutBool=[False]
					Ajout+=[MilieuMaj]
					AjoutBool+=[True]
					if ApresMaj=="  ":
						DeltaNoBloc-=1
					else:
						Ajout+=[ApresMaj]	
						AjoutBool+=[False]
					AjoutMin=[i.lower() for i in Ajout]
					
					LenPrint(	str(len(AjoutMin)))

					BlocsTraduits=BlocsTraduits[0:NoBloc] *(NoBloc>=1) + AjoutBool+ BlocsTraduits[NoBloc+1:len(BlocsTraduits)]
						
					#BlocEnCoursDeTraduction=BlocEnCoursDeTraduction[0:NoBloc-1] + [AvantMaj,MilieuMaj,ApresMaj] + BlocEnCoursDeTraduction[NoBloc+1:len(BlocEnCoursDeTraduction)]	
										
					BlocEnCoursDeTraduction=BlocEnCoursDeTraduction[0:NoBloc] *(NoBloc>=1) + \
					Ajout + \
					BlocEnCoursDeTraduction[NoBloc+1:len(BlocEnCoursDeTraduction)]	
					##LenPrint("="+AvantMin+"="+ApresMin+"=",file=_FichierLOG)
					
					BlocEnCoursDeTraductionMinuscules=BlocEnCoursDeTraductionMinuscules[0:NoBloc] *(NoBloc>=1)+ \
					AjoutMin + \
					BlocEnCoursDeTraductionMinuscules[NoBloc+1:len(BlocEnCoursDeTraductionMinuscules)]
					
					#LenPrint(BlocEnCoursDeTraduction,file=_FichierLOG)
					##LenPrint(BlocEnCoursDeTraductionMinuscules,file=_FichierLOG)
					
					
					# MotTraduit)+'\g<3>',BlocMinus)
					
					NoBloc=min(NoBloc+DeltaNoBloc,len(BlocEnCoursDeTraduction)-1)#2
					LenPrint(BlocEnCoursDeTraduction)
					LenPrint(BlocEnCoursDeTraductionMinuscules)
					LenPrint(BlocsTraduits)
					LenPrint("NoBloc="+str(NoBloc))
					LenPrint("-----------------------------------")
				else:
					NoBloc-=1


		#print('fini')
		LigneTraduite=''
		for l in BlocEnCoursDeTraduction:
			LigneTraduite+=l.lstrip()
		#LigneTraduite=self.DernieresTraductions(LigneTraduite)
		LigneTraduite=LigneTraduite.strip()#[1:-1]
		return LigneTraduite,BlocEnCoursDeTraduction,BlocEnCoursDeTraductionMinuscules,BlocsTraduits
	
	
					
	def YYMajMin(self,EngMaj,EngMin,FrMin):#travaille sur la place des majuscules				
		
		if EngMaj.upper()==EngMaj:
			retour=FrMin.upper()
		else:
			initiales=self.Initiales(EngMaj)
			if initiales.upper()==initiales:
				retour=capwords(FrMin)#re.sub(' (\S)',' \g<1>',FrMin).upper()
			else:
				retour=FrMin		
				
		return retour
		
	def YYInitiales(self,mots): #  T C i k 
		Tprint('-** Cdictionnaire.Initiale') 
		return re.sub('([\S])[\S]*','\g<1>',mots)#return re.sub('([a-zA-Z])[a-zA-Z]*','\g<1>',mots)
		
	def YYZZTraduit43(self,LigneATraduire): #V4.3COEUR DE LA TRADUCTION
		Tprint('-** Cdictionnaire.Traduit43 V4.3') 
		def YYeprint(phrase):
			return TradPrint(phrase)
			"""
			if True==False:
				print(phrase)
			"""	
		_TraductionFaite=False # au cas ou tous les mots traduits sont identiques en fr et us 
		LigneTraduite=' '+LigneATraduire.lower()+' ' # on rajoute 2 espaces V4.1
		
		for mots in self.trans:
			if mots[0] in LigneTraduite:	
							
				#TradPrint(LigneTraduite,mots[0])
				Initiales=[]	
				if mots[0]==mots[1]:
					_TraductionFaite=True 
				
				if mots[0] in LigneATraduire: #minuscules
					MotTraduit=mots[1]
				else:
					MotTraduit=mots[1][0].upper()+mots[1][1:]	
				
				####################################### !!!!!!!!!!
				#sur ces deux lignes il faudrait mettre les lettres accentues	
				#print('1LigneTraduite',LigneTraduite,mots,'==')	
				LigneTraduite=re.sub("([^a-zA-Z])("+mots[0]+")([^a-zA-Z])",'\g<1>'+MotTraduit+'\g<3>',LigneTraduite)
				#print('2LigneTraduite',LigneTraduite,mots,'==')	
				LigneTraduite=re.sub("([^a-zA-Z])("+mots[0]+"s)([^a-zA-Z])",'\g<1>'+MotTraduit+'s\g<3>',LigneTraduite)
				#print('3LigneTraduite',LigneTraduite,mots,'==')	
				
				#TradPrint(LigneTraduite)
		LigneTraduite=self.DernieresTraductions(LigneTraduite)
		LigneTraduite=LigneTraduite[1:-1] # on enleve les 2 espaces
		#print('4LigneTraduite',LigneTraduite,mots,'==')	
		if _TraductionFaite==True or LigneTraduite!=LigneATraduire.lower():
			if LigneATraduire[0].isupper():
				LigneTraduite=LigneTraduite[0].upper()+LigneTraduite[1:]
			Initiales=re.sub("([^a-zA-Z])([a-zA-Z])[a-zA-Z]*([^a-zA-Z])","\g<1>\g<2>\g<3>",		re.sub("([a-zA-Z]) ","\g<1>  "," "+LigneATraduire+" "))#rajout d'un espace
			return LigneTraduite
		else:
			return False

class br_CDICO(dict):
	  def __missing__(self, key):
		  return ""

import CBaseDeDonnees
from CBaseDeDonnees import *

def main():
	Tprint('-* main()') 
	print("Le programme lanc est "+sys.argv[0])
	print(_FonctionDuProgramme)
	print("version : "+_Version)

	#dico=Cdictionnaire(False)
	#dico.CreeDictionnaire()
	
	dico=Cdictionnaire()
	
	
	#dico.Range()
	#print(dico._trans[0:10])
	#dico.EnregistreDictionnaire()
	dico.LitBaseDeDonnees()
	#dico.InfosSurMot()
	
	#dico.ChercheUnMot("weights")
	#dico.ChercheUnMot("gravitation")
	#dico.ChercheUnMot("gravitations")
	print("ggg",dico._InfosSurMotFr["platform"])
	for u,v in dico._trans:
		if "plat" in u:
			print(u,v)

	
	f=CFichierContenu('/tmp/a.txt')
	
	lignes=f.Lignes()
	
	#g=CFichierContenu('/tmp/aa/ee.tex')
	g=CFichierContenu('/tmp/b.txt')
	for ligne in lignes:
		ligne=ligne.lower()
		#print("= "*20+"\n")
		Fprint(ligne)
		T=CTraductionDUneLigne(dico,ligne)
		T.TraduitUneLigne()
		Fprint(T._blocs)
		texte=""
		for u in T._blocs:
			texte+=u[0]
		#g.EcritFichier('/tmp/aa/ee.tex',texte.strip(),'a')
		g.EcritFichier('/tmp/b.txt',texte.strip(),'a')
	
	"""
	T=CTraductionDUneLigne(dico,"gravitation's aspect, beam's weights")
	T.TraduitUneLigne()
	print(T._blocs)
	"""

def main_AidesALaCreationsDeLaBaseDeDonnees():#
	Tprint('-* ZZmain()') 
	dico=Cdictionnaire()
	
	BD=CBaseDeDonnees()
	config = {
		'host': 'localhost',
		'database': 'dictionnaire',
		'user': 'dictionnaire',
		'password': 'dictionnaire',
	}		
	BD.Mysql_Connection(config)
	
	if True==False:
		########## calcule de id_mot_principal pour remplir le champ id_mot_principal
		## du type update `MotsGenre` set `id_mot_principal`=534 where `id`=537;
		#f=CFichierContenu("/tmp/aaaa.sql")
		
		f=open("/opt/CLASSES3/dictionnaires_additionnels/id_mot_principal.sql","a")

		NNM=BD.Mysql_Select("SELECT `id`, `mot`, `mot_principal`, `id_mot_principal`, `typeuh`, `genre`, `pluriel` FROM `MotsGenre`;")[1][1]
		for Id, mot, mot_principal, typeuh, genre, pluriel in NNM:
			
			Ids=[Id2 for Id2, mot2, mot_principal2, typeuh2, genre2, pluriel2 in NNM if typeuh==typeuh2 and mot_principal2==mot2 and mot_principal==mot2]
			if len(Ids)==1:	
				contenu='update `MotsGenre` set `id_mot_principal`='+str(Ids[0])+' where `id`='+str(Id)+";" 
				print(contenu,file=f)
				
				
				
	NNM=BD.Mysql_Select("SELECT `id`, `mot`, `mot_principal`, `id_mot_principal`, `typeuh`, `genre`, `pluriel` FROM `MotsGenre`;")[1][1]
	InfosSurMot=br_CDICO()
	
	for Id, mot, mot_principal, id_mot_principal, typeuh, genre, pluriel in NNM:
		if InfosSurMot[mot] == "":
			InfosSurMot[mot]=[Id, mot_principal, id_mot_principal, typeuh, genre, pluriel]
		else:
			InfosSurMot[mot]=None
			#print(mot+" dupliqu")

	print('InfosSurMot[mot]=[Id, mot_principal, id_mot_principal, typeuh, genre, pluriel] ou None si le mme mot est dupliqu (ex: adjectif==nom)')
	print('InfosSurMot["bonjour"]=',InfosSurMot["bonjour"])
	print('InfosSurMot["violents"]=None')
			 	
	if True==True:# RECHERCHE DE pluriels pour mettre des singuliers
		for n,(en,fr) in enumerate(dico._trans):
			if InfosSurMot[fr]!="" and InfosSurMot[fr]!=None and InfosSurMot[fr][5]=='p':				
				if en[-1]=="s" and fr[-1]=="s" and en not in ["times"]:
					print(n,en,fr,n,en[0:-1],fr[0:-1])
					dico._trans[n]=(en[0:-1],fr[0:-1])
		
	dico.Range()
	dico.EnregistreDictionnaire()

	exit()
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	print("le fichier FichierATraduire.txt est traduit en FichierTraduit.txt")
	
	print("On peut aussi simplement chercher un mot dans la base : dico.ChercheUnMot('heavy',True) ")
	#exit('utiliser la V15')
	
	#dico.DicoAdditionnel('dico_additionnel.txt')
	
	
	
	dico._tesseract=False #ne marche pas
	#print(dico.Traduit('Just as one can "descend" from general relativity to linearized theory by linearizing about flat spacetime (see below), so one can "bootstrap" one\'s ways back up from linearized theory to general relativity by imposing consistency between the linearized field equations and the equations of motion'))
	dico.TraduitUnFichier("FichierATraduire.txt")
	#print(dico.TraduitUnFichier("LIVRES/Zola-JAccuse-en.txt"))
	
	fich='FichierTraduit.txt'
	print('cration du fichier '+fich)
	f=open(fich,'w')
	print(dico._FichierTraduit,file=f)
	f.close()
	
	#print(dico.Traduit(' way '))
	
	#dico.ChercheUnMot('preserve',False)
	
	"""
	for nom in ['gravitation_MTW_35-28.texte.txt','gravitation_MTW_35-29.texte.txt','gravitation_MTW_35-30.texte.txt','gravitation_MTW_35-31.texte.txt','gravitation_MTW_35-32.texte.txt']:
		dico.TraduitUnFichier("/tmp/aa/"+nom)
		#print(dico.TraduitUnFichier("LIVRES/Zola-JAccuse-en.txt"))
		
		fich='/tmp/aa/'+nom+".fr"
		print('cration du fichier '+fich)
		f=open(fich,'w')
		print(dico._FichierTraduit,file=f)
		f.close()
	"""
	
	
	
	print( '################################')
	dico.ChercheUnMot('heavy',True)
	
	
	'''
	########## fichier ENG#FR
	f1=open("fichieratraduire",'r')
	f2=open(fich,'r')
	l1=l2=lignes=[]
	for line in f1:
		l1.append(line)
	for line in f2:
		l2.append(line)
	print(len(l1),len(l2))
	g=open('/tmp/cc','w')
	for i in range(829):
		tmp=l1[i]+'#'+l2[i]
		#lignes.append(l1[i]+'#'+l2[i])
		print(tmp,file=g)	
	'''	

	
	#print([i for i in dico.trans if 'Theorem' in i])
	exit()


if __name__=='__main__':
	main()
	

'''
a faire
by +ing
.po : cat Bureau/TraductionDeBlender/essai/particle_system_panel.po.po |grep -v '^#: ' |sed ':s;N;s/\n/ /;bs' |sed 's/msgid/\n\nmsgid/g' |grep msgstr |sed 's/msgid\ "\(.*\)"\ msgstr\ "\(.*\)"/\1#\2/' |grep -v "^#"
'''
