#!/usr/bin/python3
# -*- coding: utf-8 -*-
#from __future__ import print_function

#print(_FonctionDuProgramme)
_Version="3.1.0"
__version__="3.1.0"

"""
3.1.0	on met CPolynome au centre à la place Comonome 
"""
import sys
import re
_FonctionDuProgramme=re.sub(".*/","",sys.argv[0])
_FonctionDuProgramme+="\n\
MATHS-polynomes\
CPolynome\
\
"

dossier="/opt/CLASSES3"
import sys
if dossier not in sys.path:
    sys.path.append(dossier)
    
#print("version:"+_Version)
_FonctionDuProgramme+="\n\
Version:"+_Version+"\n"


import os

##################### debug
_debug_all=True # 
_debug_all=False

_debug_Titres=True #_debug_Titres=False

_debug=True #
_debug=False

if _debug_all==True:
	_debug_Titres=True
	_debug=True

_FichierLog='/tmp/'+re.sub(".*/","",sys.argv[0])+'.log'
_Log=open(_FichierLog,'w')

def Gprint(*args, **kwargs):
	pass
	"""if _debug_Titres==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
	"""	
def Dprint(*args, **kwargs):
	if _debug==True:
		print('==========================Dprint')
		print(sys.argv[0],*args, **kwargs)					
		print(sys.argv[0],*args,file=_Log)
		print('  =  =  =  =  =  =  =  =')
def Kprint(*args, **kwargs):
	pass
	
def Iprint(*args, **kwargs):
	pass
	"""
	print(*args, **kwargs)					
	print(*args,file=_Log)		
	"""	
# # # # # # # # # # # # # # # # # # # debug

class ZZbr_CDICO(dict):
	  def __missing__(self, key):
		  return ""
		  
class br_CDict(dict):
	def __init__(self,retour=""):
		self._retour=retour
	def __missing__(self, key):
		return self._retour
		
class CProjetDePo(object):
	def __init__(self,_rep=''):
		self._repertoire=_rep





from math import *
from CFonctions3 import *#EstUnArray,EstUnNombre
import os	

def signe(a):
	return sgn(a)
def sgn(a):	
	if EstUnNombre(a):
		if a>0:
			return 1
		elif a==0:
			return 0
		else:
			return -1		
	else:
		return None	
		

		  
class ZZCMonome(object):
	def __init__(self,mantisse,exposant=None,exposant_reel_autorise=False,\
	_variable="x",_AffMult=" "):
		"""__init__(mantisse,exposant,exposant_reel_autorise) """
		print('CMonome.__init__(mantisse,exposant,exposant_reel_autorise)')
		Dprint("98",type(mantisse),type(exposant))
		self._variable=_variable
		self._AffMult=_AffMult
	
		if SontDesNombres([mantisse,exposant]):
			Dprint("SontDesNombres")
			self.init(mantisse,exposant)
		else:
			return CPolynome(mantisse,exposant)	
	
	
	def init(self,mantisse,exposant):
		print("CMonome.init")
		if EstUnEntier(mantisse,strict=False):# or float(int(mantisse))==mantisse:
			mantisse=int(mantisse)
		elif EstUnReel(mantisse,strict=False):
			mantisse=float(mantisse)
			
		if EstUnEntier(exposant,strict=False):
			exposant=int(exposant)
		elif EstUnReel(exposant,strict=False) and exposant_reel_autorise==True:
			exposant=float(exposant)
		
		
		self._mantisse=mantisse
		self._exposant=exposant
		self._signe=signe(self._mantisse)
		#self._affichage=self.__str__()
		self._coeff=self._mantisse
		self._degre=self._exposant
		return [self._mantisse,self._exposant]
	
	
	
	
	def Z__init__(self,mantisse,exposant=None,exposant_reel_autorise=False):
		"""__init__(mantisse=chaine="(-2+3)x^(5+1)"|nombres=2),exposant=3|None """
		Dprint("98",type(mantisse),type(exposant))
		
		
		
		
		if EstUneChaine(mantisse):
			Dprint("EstUneChaine")
			Chaine=mantisse					
			mantisse,exposant=self.TexteVersNombres(Chaine)
			self.init(mantisse,exposant)
			
		if SontDesNombres([mantisse,exposant]):
			Dprint("SontDesNombres")
			self.init(mantisse,exposant)
		
	def Zinit(self,mantisse,exposant):
		print("CMonome.init")
		if EstUnEntier(mantisse,strict=False):# or float(int(mantisse))==mantisse:
			mantisse=int(mantisse)
		if EstUnReel(mantisse,strict=False):
			mantisse=float(mantisse)
			
		if EstUnEntier(exposant,strict=False):
			exposant=int(exposant)
		if EstUnReel(exposant,strict=False) and exposant_reel_autorise==True:
			exposant=float(exposant)
		
		
		self._mantisse=mantisse
		self._exposant=exposant
		self._signe=signe(self._mantisse)
		#self._affichage=self.__str__()
		self._coeff=self._mantisse
		self._degre=self._exposant
		return [self._mantisse,self._exposant]
		
	def ZTexteVersNombres(self,Chaine):#-2x^5 ; (3+5)x^(4+exp(0)*2**3)
		print("CMonome.TexteVersNombres")		
		
		#(-2)x^(-3)		
		a=re.match(r"^(?P<mantisse>\([+\-0-9\.]*\)).*"+self._variable+"\^(?P<exposant>\([0-9\.+\-]*\))$",Chaine)
		if not a:
			#(-2)x^-3
			a=re.match(r"^(?P<mantisse>\([+\-0-9\.]*\)).*"+self._variable+"\^(?P<exposant>[0-9\.+\-]*)$",Chaine)
		if not a:
			#-2x^(-3)
			a=re.match(r"^(?P<mantisse>[+\-0-9\.]*).*"+self._variable+"\^(?P<exposant>\([0-9\.+\-]*\))$",Chaine)
		if not a:
			#-2x^-3
			a=re.match(r"^(?P<mantisse>[+\-0-9\.]*).*"+self._variable+"\^(?P<exposant>[0-9\.+\-]*)$",Chaine)
		#(3*4+5)x^(2*9+6)
		if not a:
			a=re.match(r"^(?P<mantisse>\([*/+\-0-9\.]*\)).*"+self._variable+"\^(?P<exposant>\([0-9\.+\-*/]*\))$",Chaine)
		
		if a:
			mantisse=a.group("mantisse")
			#mantisse=re.sub(r"^\((.*)\)$","\g<1>",mantisse) enleve les parenthèses
			try:
				mantisse=float(mantisse)
			except:
				code = compile(mantisse, "<string>", "eval")
				mantisse=float(eval(code))
				#mantisse=float(eval(mantisse))
			
			exposant=a.group("exposant")
			#exposant=re.sub(r"^\((.*)\)$","\g<1>",exposant)	 enleve les parenthèses		
			try:
				exposant=int(exposant)
			except:
				code = compile(exposant, "<string>", "eval")
				exposant=int(eval(code))
				#exposant=int(eval(exposant))
			
			return [mantisse,exposant]
		else:
			return [Chaine,None]
			
		
	def __mul__(self,mon2):	
		print("CMonome.__mul__")
		return CPolynome([CMonome(self._mantisse)])*CPolynome([CMonome(mon2._mantisse)])
		
	def __add__(self,mon2):
		print("CMonome.__add__")
		if self._degre==mon2._exposant:
			return CPolynome ( CMonome(self._mantisse+mon2._mantisse,self._exposant))
		
		if self._degre!=mon2._degre:
			return CPolynome ( [CMonome(self._mantisse,self._exposant),CMonome(mon2._mantisse,mon2._exposant)])

	def __div__(self,mon2):
		print("CMonome.__div__")
		#if self._degre>=mon2._degre:
		return CPolynome(CMonome(self._mantisse/mon2._mantisse,self._exposant-mon2._exposant))
			
	def __str__(self):
		print("CMonome.__str__")
		return self.affiche()
		
	def affiche(self,affizero=False,EnleveSigneInitial=True):
		print("CMonome.affiche")
		if EnleveSigneInitial==True:
			aff={-1:"-",1:""}
		else:
			aff={-1:"-",1:"+"}
				
			
		variable=self._variable
		mult=self._AffMult
			
						
		if affizero==False and self._mantisse==0:
			self._affichage=""
		else:
			self._affichage=aff[signe(self._mantisse)]
			
			if self._mantisse!=1 or self._degre==0:
				self._affichage+=str(abs(self._mantisse))
				
			if self._exposant!=0:
				self._affichage+=mult+variable
			if self._exposant!=1 and self._exposant!=0:
				self._affichage+="^"+str(self._exposant)
		
		return self._affichage
		
		
		
		self._affichage=aff[signe(self._mantisse)]+mult+variable+self.exposant


	def deriv(self):
		print("CMonome.deriv")
		return CPolynome(self).deriv()
	
	def deriv_n(self,n):
		print("CMonome.deriv_n")
		return CPolynome(self).deriv_n(n)
		

class ZZbr_monomes(dict):
	  def __missing__(self, exposant):
		  return CMonome(0,exposant)
		  
class CPolynome(object):
	def __init__(self,Entree1=None,exposant=None,exposant_reel_autorise=False,	variable="x",AffMult=" "):
		"""CPolynome(5)===CPolynome(5,0)===5x^0\
		CPolynome([2,3,4])===2+3x+4x^2
		"""
		Gprint('CPolynome.__init__(Entree1,exposant,exposant_reel_autorise,	_variable,_AffMult)',type(Entree1))
		
		self._monomes=br_CDict(0)
		
		self._variable=variable
		self._AffMult=AffMult
		self._exposant_reel_autorise=exposant_reel_autorise
		
		
		
		
		#CPolynome(br_CDict(exposant=>mantisse) Entree1=br_CDict(exposant=>mantisse)
		if isinstance(Entree1,br_CDict):
			Iprint("		..........isinstance(Entree1,br_CDict):",type(Entree1))
			#!! non verifiés type de Entree1.keys and values
			for _exposant,_mantisse in Entree1.items():
				Kprint("		312",_mantisse,_exposant)
				_mantisse,_exposant=self.normalise(_mantisse,_exposant)
				self._monomes[_exposant]=_mantisse				
				Kprint("		320",(_mantisse,_exposant))
		
		
		
		
		#CPolynome(5,0) CPolynome(Entree1=nombre,exposant=nombre)
		elif SontDesNombres([Entree1,exposant]):
			Iprint("		..........SontDesNombres([Entree1,exposant]):")
			_exposant=exposant
			_mantisse=Entree1			
			"""_mantisse,_exposant=self.normalise(_mantisse,_exposant)
			self._monomes[_exposant]=_mantisse
			"""
			_mantisses=br_CDict(0)
			_mantisses[_exposant]=_mantisse
			self._monomes=CPolynome(_mantisses)._monomes
			
			Kprint("		330",(_mantisse,_exposant))
			



		
		#CPolynome(5)	CPolynome(Entree1=nombre,exposant=pas nombre)
		elif EstUnNombre(Entree1) and not EstUnNombre(exposant):#CPolynome(5)===5x^0	=> [CMonome([5,0])]
			Iprint("		..........EstUnNombre(Entree1) and not EstUnNombre(exposant):#CPolynome(5)===5x^0	=> [CMonome([5,0])]")
			_exposant=0
			_mantisse=Entree1
			"""	_mantisse,_exposant=self.normalise(_mantisse,_exposant)
			self._monomes[_exposant]=_mantisse
			"""
			_mantisses=br_CDict(0)
			_mantisses[_exposant]=_mantisse
			self._monomes=CPolynome(_mantisses)._monomes
		
		
		
		
		#CPolynome([2,3,4])===2+3x+4x^2	CPolynome(Entree1=[nombres au moins 1])
		#[deg0,deg1,deg2] #CPolynome([2,3,4])===2+3x+4x^2 => [CMonome([2,0]),CMonome([3,1]),CMonome([4,2])]
		elif isinstance(Entree1,list) and len(Entree1)>0 and SontDesNombres(Entree1):
			Iprint("		..........isinstance(Entree1,list) and len(Entree1)>0 and SontDesNombres(Entree1):")
			_mantisses=br_CDict(0)
			for i,ai in enumerate(Entree1):
				_exposant=i
				_mantisse=ai
				#_mantisse,_exposant=self.normalise(_mantisse,_exposant)
				#self._monomes[_exposant]=_mantisse
				_mantisses[_exposant]=_mantisse
			self._monomes=CPolynome(_mantisses)._monomes
			#self._coeffs=coeffs
			
			#self.initCoeffs()
			self._degre=self.degre()
		
		
		
		
		elif EstUneChaine(Entree1):			
			Iprint("		..........EstUneChaine")
			self._monomes=self.TexteVersPolynome(Entree1)._monomes
		
		
		
		
		#CPolynome(CPolynome)	CPolynome(Entree1=CPolynome)
		elif EstUn(Entree1,CPolynome,strict=True):
			Iprint("		..........EstUn(Entree1,CPolynome =entree1")			
			self._monomes=Entree1._monomes
			
			
			
			
		#CPolynome([CPolynomes au moins 1])	CPolynome(Entree1=[CPolynomes])
		elif isinstance(Entree1,list) and len(Entree1)>0 and SontDes(Entree1,CPolynome,strict=True):
			Iprint("		..........isinstance(Entree1,list) and len(Entree1)>0 and SontDes(Entree1,CPolynome,strict=True):")
			self._monomes=self.Somme(Entree1)._monomes
			
			
			
		else:			
			Iprint("		.......... else:")
			self._monomes=CPolynome(0)._monomes
		
		self.degre()
		
		Gprint("		407",self._monomes.items())
		
		
	def __eq__(self,obj):
		Gprint("	CPolynome.__eq__")
		try:
			if EstPolynomeZero(self-obj):
				return True
			else:
				return False	
		except:
			return False
		return False	
		
	def EstPolynomeZero(self,obj):
		Gprint("	CPolynome.EstZero")
		if EstUn(obj,CPolynome,strict=True):
			if len([k for k in self._monomes.keys() if not EstZero(self._monomes[k])])==0:
				return True
			else:
				return False		
		else:
			return False	
		return False	
			
	def Somme(self,Polynomes):
		Gprint("	CPolynome.somme")
		A=CPolynome(0)
		for Polynome in Polynomes:
			A=A+Polynome		
		return A
		
	def normalise(self,mantisse,exposant,_strict=False):
		Gprint("	CPolynome.normalise()")
		Gprint("			438",mantisse,exposant)
		if EstUnEntier(mantisse,strict=_strict) or float(int(mantisse))==mantisse:
			mantisse=int(mantisse)
		elif EstUnReel(mantisse,strict=_strict):
			mantisse=float(mantisse)
			
		if EstUnEntier(exposant,strict=_strict) or float(int(exposant))==exposant:
			exposant=int(exposant)
		elif EstUnReel(exposant,strict=_strict) and self._exposant_reel_autorise==True:
			exposant=float(exposant)
		
		#self._signe=signe(self._mantisse)
		
		Gprint("			450",mantisse,exposant)
		return [mantisse,exposant]	
		
		
			

		"""
		if isinstance(coeffs,list) and len(coeffs)==1 and EstUn(coeffs[0],CMonome):
			coeffs=coeffs[0]
		"""
		"""
		if 	isinstance(coeffs,CMonome):			
			self._monomes[coeffs._exposant]=CMonome(coeffs._mantisse,coeffs._exposant)
			self._coeffs=[[coeffs._mantisse,coeffs._exposant]]
		"""	
		"""	
		if isinstance(coeffs,list) and len(coeffs)>0 and SontDes(coeffs,CMonome):
			self._coeffs=[]
			for m in coeffs:
				self._monomes[m._exposant]+=m				
			self._degre=self.degre()
			for i in range(self._degre+1):
				Kprint(i,type(self._monomes[0]))
				self._coeffs.append([self._monomes[i]._mantisse,i])
			
		"""
		"""if EstUneChaine(coeff):
			Dprint("		EstUneChaine")
			a=re.match(r"(?P<avant>.*)(?P<mantisse>[+\-0-9\.]*).*"+self._variable+"\^(?P<exposant>[0-9\.+\-]*)$",coeff)
			a=re.match(r"^(?P<avant>.*)(?P<mantisse>[0-9+\-\.]+) "+_variable+"\^(?P<exposant>[0-9\.+\-]*)$",coeff)

			
			if a:
				mantisse=float(a.group("mantisse"))
				exposant=int(a.group("exposant"))
				Kprint(mantisse,exposant)
				coeff=mantisse
				degre=exposant
		self._variable
		"""
		
		
		
	def TexteVersPolynome(self,chaine):#
		Gprint("	CPolynome.TexteVersPolynome")
		P=CPolynome(0)
		Dprint(chaine,(r"[+\-0-9\.]*"+self._variable+"\^[\.+\-]*[0-9]+",chaine))

		_chaines=re.findall(r"[+\-]*[0-9\.]*"+self._variable+"\^[+\-]*[0-9\.]+",chaine)
		
		Kprint("		439",_chaines)
		for _chaine in _chaines:
			Kprint("		443",_chaine)
			P+=self.TexteVersMonome(_chaine)
			Kprint("		445",P)
			if len(list(P._monomes.keys()))!=1 and int(0) in list(P._monomes.keys()) and P._monomes[0]==0:
				del P._monomes[0]
				
		Kprint("		509",P._monomes)	
		return P	

		exit()
		#a=re.match(r"(?P<avant>.*)(?P<mantisse>[+\-0-9\.]*).*"+self._variable+"\^(?P<exposant>[0-9\.+\-]*)$",coeff)
		#a=re.match(r"^(?P<avant>.*)(?P<mantisse>[0-9+\-\.]+) "+_variable+"\^(?P<exposant>[0-9\.+\-]*)$",coeff)

		
		
		
		
		
		
		
		
			
	def ZZinitMonomes(self):
		pass
		
	
	def __str__(self):
		Gprint("	CPolynome.__str__")
		return self.affiche()
		
	def affiche(self,EnleveSigneInitial=True,decroissant=True):	
		Gprint("	CPolynome.affiche()")
		affich=""
		Kprint("		505",self._monomes.items())
		exposants=list(set(self._monomes.keys()))
		MinExposants=min(exposants)
		#print("		451",exposants)
		if decroissant==True:			
			for i in range(len(exposants)-1,0-1,-1):	
				_exposant=exposants[i]
				_mantisse=self._monomes[_exposant]
				affich+=self.AfficheMonome(_mantisse,_exposant,\
						EnleveSigneInitial=EnleveSigneInitial*(_exposant==self.degre()))
		if decroissant!=True:
			for i in range(0,len(exposants)):
				_exposant=exposants[i]
				_mantisse=self._monomes[_exposant]
				affich+=self.AfficheMonome(_mantisse,_exposant,\
						EnleveSigneInitial=EnleveSigneInitial*(_exposant==MinExposants))
		Kprint("		487 : affich : ",affich)
		
		return affich
	
	def AfficheMonome(self,mantisse=0,exposant=0,affizero=False,EnleveSigneInitial=True):
		Gprint("	CPolynome.AfficheMonome")
		if EnleveSigneInitial==True:
			aff={-1:"-",1:""}
		else:
			aff={-1:"-",1:"+"}
				
			
		variable=self._variable
		mult=self._AffMult
			
		_mantisse,_exposant=mantisse,exposant

						
		if affizero==False and _mantisse==0:
			_affichage=""
		else:
			_affichage=aff[signe(_mantisse)]
			
			if _mantisse!=1 or _exposant==0:
				_affichage+=str(abs(_mantisse))
				
			if _exposant!=0:
				_affichage+=mult+variable
			if _exposant!=1 and _exposant!=0:
				_affichage+="^"+str(_exposant)
		
		return _affichage
		

	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	def ExposantMax(self):
		Gprint("	CPolynome.ExposantMax")
		self._ExposantMax=max(self._monomes.keys())
		return self._ExposantMax
		
	def degre(self):
		Gprint("	CPolynome.degre")
		"""
		n=len(self._coeffs)
		i=n-1
		while self._coeffs[i]==0:
			i-=1
			if i==-n:
				return -1		
		self._degre=i		
		return self._degre
		"""
		#print(self._monomes)
		#print(self._monomes.keys())
		if not self.EstPolynomeZero(self):
			self._degre=max([exposant for exposant in self._monomes.keys() if not EstZero(self._monomes[exposant]) ])
		else:	
			self._degre=0
		return self._degre
		
		

	def __add__(self,mon2):
		Gprint("	CPolynome.__add__")
		#liste des exposants rangés,uniques(par set)
		#print(type(self._monomes),type(mon2._monomes))
		#print(len(self._monomes),len(mon2._monomes))
		#print(self._monomes,mon2._monomes)
		exposants=set(list(self._monomes.keys())+list(set(mon2._monomes.keys())))
		#print( [CMonome(self._monomes[exposant]._mantisse+mon2._monomes[exposant]._mantisse,exposant)._mantisse for exposant in exposants ])
		mantisses=br_CDict(0)
		for exposant in exposants:
			mantisses[exposant]=self._monomes[exposant]+mon2._monomes[exposant]
		return CPolynome (mantisses)
		
	def __pow__(self,entier):
		Gprint("	CPolynome.__pow__")
		if EstUnEntier(entier) and entier>=0:
			if entier==0:
				return CPolynome(1)
			elif entier==1:
				return self
			else:
				return self*(self**(entier-1))			
		else:
			return entier	
			
			
	def __mul__(self,B):
		Gprint("	CPolynome.__mul__")
		if EstUnNombre(B):
			B=CPolynome(B)
		Dprint("		205")	
		dA=self.degre()
		dB=B.degre()
		Dprint("		208")	
		monomes=br_CDict(0)

		for exposant in range(dA+dB+1):
			Dprint("		211 : degre ",exposant)
			_mantisse=0
			for k in range(exposant+1):
				Dprint("		k=*d-k",k, end=";")
				_mantisse+=self._monomes[k]*B._monomes[exposant-k]
			Dprint("		215 _mantisse="	,_mantisse)
			monomes[exposant]=_mantisse
		return CPolynome(monomes)
	
	def __sub__(self,B):
		return self+B*(-1)
	
	def __div__(self,obj):
		if EstUnNombre(obj):
			return self.__mul__(1/obj)
		elif EstUn(obj,CPolynome):
			div,reste=self.DivisionEntiere(obj)
			if EstPolynomeZero(reste):
				return div
			else:
				return CFonction(self).__div__(obj)#!! n exuste pas encore
		else:
			return CFonction(self).__div__(obj)#!! n existe pas encore
			
	
	def DivisionEntiere(self,div=None):
		if EstUn(div,CPolynome):
			A,dA=self,self._degre
			D,dD=div,div._degre
			if dA>dD:
				#t=A._monomes[dA]/D._monomes[dD]
				t=A._monomes[dA].__div__(D._monomes[dD])
				reste=A-self*t
				return t+CPolynome(reste.Division(div))
			elif dA==dD:
				t=A._monomes[dA]/D._monomes[dD]	
				return t,CPolynome[0]
			else:
				return CPolynome[0],A
		else:		
			return CFonction(self).__div__(obj)#!! n existe pas encore

	'''
	def __call__(self,x):
		p=0
		for ai in reversed(self._coeffs):
			p=ai+x*p
		return p
	'''
	def deriv(self):
		Kprint("		CPolynome.deriv")
		exposants=sorted(list(set(self._monomes.keys())))#!!vérifier le rangement croissant surtout si exposants float
		
		if 0 in exposants:
			del exposants[0]
		Kprint(exposants)
		for exposant in exposants:
			self._monomes[exposant-1]=exposant*self._monomes[exposant]
		del self._monomes[exposants[-1]]
		return self
	
	def deriv_n(self,n):
		Kprint("		CPolynome.deriv_n")
		p=self
		for i in range(n):			
			p=p.deriv()
		#!!??self._monomes=p._monomes
		return p	
	
	


	def TexteVersMonome(self,Chaine):#-2x^5 ; (3+5)x^(4+exp(0)*2**3)
		Kprint("	CPolynome.TexteVersMonome")		
		Kprint("724",Chaine)
		#(-2)x^(-3)		
		a=re.match(r"^(?P<mantisse>\([+\-0-9\.]*\)).*"+self._variable+"\^(?P<exposant>\([0-9\.+\-]*\))$",Chaine)
		if not a:
			#(-2)x^-3
			a=re.match(r"^(?P<mantisse>\([+\-0-9\.]*\)).*"+self._variable+"\^(?P<exposant>[0-9\.+\-]*)$",Chaine)
		if not a:
			#-2x^(-3)
			a=re.match(r"^(?P<mantisse>[+\-0-9\.]*).*"+self._variable+"\^(?P<exposant>\([0-9\.+\-]*\))$",Chaine)
		if not a:
			#-2x^-3
			Kprint('652 ',Chaine)
			a=re.match(r"^(?P<mantisse>[+\-0-9\.]*).*"+self._variable+"\^(?P<exposant>[0-9\.+\-]*)$",Chaine)
		#(3*4+5)x^(2*9+6)
		if not a:
			a=re.match(r"^(?P<mantisse>\([*/+\-0-9\.]*\)).*"+self._variable+"\^(?P<exposant>\([0-9\.+\-*/]*\))$",Chaine)
		
		if a:
			mantisse=a.group("mantisse")
			#mantisse=re.sub(r"^\((.*)\)$","\g<1>",mantisse) enleve les parenthèses
			try:
				mantisse=float(mantisse)
			except:
				code = compile(mantisse, "<string>", "eval")
				mantisse=float(eval(code))
				#mantisse=float(eval(mantisse))
			
			exposant=a.group("exposant")
			#exposant=re.sub(r"^\((.*)\)$","\g<1>",exposant)	 enleve les parenthèses		
			try:
				exposant=int(exposant)
			except:
				code = compile(exposant, "<string>", "eval")
				exposant=int(eval(code))
				#exposant=int(eval(exposant))
			self.normalise(mantisse,exposant)
			Kprint("		676",mantisse,exposant)
			return CPolynome(mantisse,exposant)
		else:
			return CPolynome(0)
			






























if __name__ == "__main__":

	print("		Le programme lancé est "+sys.argv[0])
	
	print(_FonctionDuProgramme)
	print("		version:"+_Version)
	
	"""
	A=CPolynome([1,2,3])
	#A.affiche(decroissant=False)

	B=CPolynome([10,1])
	#B.affiche()
	"""
	
	#print(A*B)
	
	"""
	#test1
	A=CPolynome(5,2)#.deriv_n(3)	
	print(A)
	
	#test2
	d=br_CDict()
	d[8]=3
	A=CPolynome(d)#.deriv_n(3)
	print(A)
	A.affiche()
	#test3
	d[2]=5
	A=CPolynome(d)#.deriv_n(3)
	print(A)
	A.affiche()	
	
	#test4
	A=A.deriv()
	print("test4",A)
	A.affiche()
	#test
	A=A+A
	print(A)
	A.affiche()
	#test
	

	A=CPolynome(A)
	print(A._monomes)
	A.affiche()
	exit()	
	"""
	"""
	#test
	A=A*A
	print(A)
	A.affiche()
	'''
	#test
	print("="*20)
	A=CPolynome(2,5)
	print("\n"*5)
	
	A.affiche()
	exit()
	print(c)
	print(A._monomes)
	print("\t="*20)
	A.affiche()
	"""
	A=CPolynome(3,5)
	
	A=CPolynome("3x^5")
	print("		836",A)
	print("		837",A._monomes)
	print("		838",A.deriv_n(3))
	print("		839",A._monomes)
	print("		840",A)
	
	
	
	
	
	
	d=br_CDict(0)
	d[0]=1
	d[1]=1
	A=CPolynome(d)
	print("854",A**3)
	
	A=CPolynome("(-2+3)x^(5+1)")
	print("856",A)
	
	A=CPolynome("(3.0+4.0)x^(2)")
	print(A)
	
	
	#A=CPolynome(CMonome("-8x^7")).Division(CPolynome(CMonome("-2x^4")))



	
		

try:
	_Log.close()
except:
	pass	



