#!/usr/bin/python3
# -*- coding: utf-8 -*-
#from __future__ import print_function
global _FonctionDuProgramme
_FonctionDuProgramme="Lire dex xml\n https://docs.python.org/3/library/xml.dom.minidom.html#module-xml.dom.minidom #VOIR CGpx.py pour une version recente"
_Version="1.1.2"
__version__="1.1.2"
"""
1.1.2 verification de l existence du fichier
"""
#print("version:"+_Version)
import re
import os
##################### debug
import sys



#import xml
#from xml.dom import minidom


#exit()


TYPES=["rien","ELEMENT_NODE","ATTRIBUTE_NODE","TEXT_NODE","CDATA_SECTION_NODE","ENTITY_NODE","PROCESSING_INSTRUCTION_NODE","COMMENT_NODE","DOCUMENT_NODE","DOCUMENT_TYPE_NODE","NOTATION_NODE"]
import csv



import defusedxml
from defusedxml import minidom

# apt-get install python3-defusedxml

#https://docs.python.org/fr/3/library/csv.html

dossier="/opt/CLASSES3"
import sys
if dossier not in sys.path:
    sys.path.append(dossier)
    
import re

_debug=True #
_debug=False

_debug_Titres=True # 
_debug_Titres=False


_debug_all=True # 
_debug_all=False

if _debug_all==True:
	_debug_Titres=True


_FichierLog='/tmp/'+re.sub(".*/","",sys.argv[0])+'.log'
_Log=open(_FichierLog,'w')

def Tprint(*args, **kwargs):
	if _debug_Titres==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
def Dprint(*args, **kwargs):
	if _debug==True:
		print("==",*args, **kwargs)					
		print(*args,file=_Log)
		print('--------------------------')
# # # # # # # # # # # # # # # # # # # debug
# ajout de doc + Tprint sed -e 's/^\(.*\)\(def\ \)\(.*\)$/\1\2\3\n\1\t"""-*\3"""\n\1\tTprint("\3")/' -i aa.py
class br_CDICO(dict):
	  def __missing__(self, key):
		  return ""


DicoFonctions=br_CDICO()
DicoClasses=br_CDICO()

#http://www.fil.univ-lille1.fr/~marvie/python/chapitre4.html


class CFichierXml(object):
	""" CLASSE CXml(object) : travail sur le fichier xml"""
	def __init__(self,fich="FichiersAnnexes/Markers_2020-09-17.gpx"):
		""" CXml.__init__(fich) """
		Tprint("CFichierXml.__init__()")
		self.init()
		self._NomFichier=fich
		
		try:
			f=open(fich,"r")
			f.close()
			try:
				self._doc = defusedxml.minidom.parse(fich)
				#self._doc = minidom.parse('/home/bruno/Bureau/BoulotEnCours/2019-ba-site/analyse du code/RAPPORT/1907559.xml')#/tmp/a.xml')
				self._root = self._doc.documentElement			
				
				self.Analyse()			
				
				
			except:
				print("la commande minidom.parse('"+fich+"') n'a pas fonctionné")
				print ("ou la commande minidom.parse('"+fich+"').documentElement n'a pas fonctionné")
				#exit()	
			
		except:
			print("ERREUR : impossible d'ouvrir le fichier "+fich)
			#exit()
		

		
	def init(self):
		""" CXml.init() """
		Tprint("CFichierXml.init()")
		self._NomFichier = None
		self._doc = None
		self._root = None
		#self._SousBlocs = None
		#self._Items = None
		self._bloc=None#CBloc
		self._TexteXml=""
			
	def toprettyxml(self):
		Tprint("CFichierXml.toprettyxml()")
		print(self._root.toprettyxml())
		
	def Enregistre(self,Element="root",fich="/tmp/aaa.xml"):
		Tprint("CFichierXml.Enregistre("+Element+","+fich+")")
		if Element=="root":
			Element=self._root
		Element.toprettyxml(fich)

	def Analyse(self):
		Tprint("CFichierXml.Analyse()")
		#print('root',self._root)
		self._bloc=CBloc(self._root,parent=None)
		self.TexteXml()
		Dprint("CXml128")
		
		
	def TexteXml(self):
		Tprint("CFichierXml.TexteXml()")
		self._TexteXml=self._bloc.TexteXml()
		return self._TexteXml
	
	def __str__(self):
		Tprint("CFichierXml.__str__()")
		return self._bloc.__str__()
		
	def ChercheTag(self,AChercher):
		Tprint("CFichierXml.ChercheTag('"+AChercher+"')")
		return self._bloc.ChercheTag(AChercher)

	def ToCsv(self,blocs,fichier='/tmp/CXml.csv',*Clefs):
		"""CFichierXml.ToCsv(blocs,fichier='/tmp/CXml.csv',*Clefs) : nécessite des [CBloc,CBloc...] de même construction \
		qu'on trouve en particulier avec CFichierXml.ChercheTag('wpt')
		"""
		Champs=["id"]
		print(type(Clefs))
		if len(Clefs)!=0:
			Champs=Champs+list(Clefs)[0]
		print(Champs)
		lignes=br_CDICO()
		
			
		#Cles=["wpt_lat","wpt_lon","wpt_name_","wpt_extensions_color_"]
		for no,bloc in enumerate(blocs):
			lignes[no]=CXmlToDict(bloc)
			for cle in list(lignes[no]):
				if cle not in Champs:
					Champs.append(cle)
					
		#print(Cles)
		#https://docs.python.org/fr/3/library/csv.html
		with open(fichier, 'w', newline='') as csvfile:
			fieldnames = Champs
			writer = csv.DictWriter(csvfile, fieldnames=fieldnames,delimiter="#")
			writer.writeheader()

			#print(lignes)			
			for no,ligne in lignes.items():
				ID=dict()
				ID["id"]=str(no)
				print(ligne)
				print(ID)
				ID.update(ligne)
				print("line",ID)
				writer.writerow(ID)
			"""	
			writer.writerow({'first_name': 'Baked', 'last_name': 'Beans'})
			writer.writerow({'first_name': 'Lovely', 'last_name': 'Spam'})
			writer.writerow({'first_name': 'Wonderful', 'last_name': 'Spam'})
			"""
		#return res	
		
	def wptToCsv(self,blocs,fichier='/tmp/CXml.csv'):
		Cles=["wpt_lat","wpt_lon","wpt_name_","wpt_extensions_color_"]
		self.ToCsv(blocs,fichier,Cles)
		pass
		
	def trkptToCsv(self,blocs,fichier='/tmp/CXml.csv'):
		Cles=["trkpt_time_","trkpt_lat","trkpt_lon","trkpt_ele_","trkpt_hdop_","trkpt_extensions_speed_"]
		Cles=[]
		self.ToCsv(blocs,fichier,Cles)
		pass
		
		
def CXmlToDict(bloc,pref=""):
	"""CXmlToDict(bloc,pref)"""
	di=br_CDICO()
	if bloc._type!='TEXT_NODE':
		pass#print(pref+"_"+c._NomBloc)
	else:	
		Dprint(pref+"="+bloc._texte)
		if pref in di:
			Dprint("CXml342","la clé "+pref+" existe déjà")
			exit()
		di[pref]=bloc._texte
		
	for item in bloc._items:
		Dprint(bloc._NomBloc+"_"+item+"="+bloc._items[item])
		if bloc._NomBloc+"_"+item in di:
			Dprint("CXml349","la clé "+bloc._NomBloc+"_"+item+" existe déjà")
			exit()			
		di[bloc._NomBloc+"_"+item]=bloc._items[item]
	for SousBloc in bloc._SousBlocs:
		di.update(CXmlToDict(SousBloc,pref=pref+bloc._NomBloc+"_"))
	return di


	


class CBloc(object):
	""" CLASSE Bloc(object) : travail sur les DOM des xml"""
	def __init__(self,NoeudXml,parent=None):
		Tprint("CBloc.__init__()")
		self.init()
		
		self._NoeudXml=NoeudXml
		self._type=TYPES[self._NoeudXml.nodeType]
		if self._type!="ELEMENT_NODE" and self._type!="TEXT_NODE":
			print("Attention, ce type numéro "+self._NoeudXml.nodeType+" n'est pas codé.")
			print("Cela correspond à "+self._NoeudXml.nodeType+".")
			exit()
		self._NomBloc=self.nom()
		Dprint("CXml154",self._NomBloc)
		self._texte=self.texte()
		Dprint("CXml158",self._texte)
		self._items=self.items()
		Dprint("CXml160",self._items)
		self._SousBlocs=self.SousBlocs()
		self._parent=parent
		
		
	
	def init(self):
		Tprint("CBloc.init()")
		self._NoeudXml=None#defusedxml.minidom.parse(fich).documentElement
		self._type=""#"ELEMENT_NODE" // "TEXT_NODE"
		#self.TYPES=["rien","ELEMENT_NODE","ATTRIBUTE_NODE","TEXT_NODE","CDATA_SECTION_NODE","ENTITY_NODE","PROCESSING_INSTRUCTION_NODE","COMMENT_NODE","DOCUMENT_NODE","DOCUMENT_TYPE_NODE","NOTATION_NODE"]
		self._NomBloc=""#gpx
		self._items=br_CDICO()#dict("version":"1.1","creator":"OsmAnd~ 3.6.3"...)
		self._SousBlocs=[]#[CBloc(),CBloc()...]
		self._Parent=None#CBloc()		
		self._texte=None
	
	def nom(self):
		Tprint("CBloc.nom()")
		Tprint("")
		self._NomBloc=self._NoeudXml.nodeName
		return self._NomBloc		
		
	def items(self):
		Tprint("CBloc.items()")
		#<wpt lat="49.8085917" lon="0.4869397">	
		self._items=br_CDICO()
		if self._type=="ELEMENT_NODE":
			try:
				if self._NoeudXml.hasAttributes():
					_items=self._NoeudXml.attributes.items()#[('lon', '0.4869397'), ('lat', '49.8085917')]		
				for u,v in _items:
					self._items[u]=v		
			except:
				Dprint("CXml189 except")
		return self._items
		
	def SousBlocs(self):
		Tprint("CBloc.SousBlocs()")
		#TextesAExclure=["'\n'",""]
		#certains éléments sont : <DOM Text node "'\n '"> type : "TEXT_NODE" enlevés 
		#<DOM Elements: metadata at 0x7f8743d60af8 type : "ELEMENT_NODE"
		self._SousBlocs=[]
		Dprint("CXml201",self._NoeudXml.hasChildNodes())
		try:
			if self._NoeudXml.hasChildNodes():
				Dprint("CXml204 : nb d'enfants=",len(self._NoeudXml.childNodes))
				self._SousBlocs=[]
				#self._SousBlocs=xml.dom.minicompat.NodeList()
				for no,enf in enumerate(self._NoeudXml.childNodes):
					Dprint("CXml208",no,enf.nodeName)
					#if TYPES[enf.nodeType] != "TEXT_NODE" or texte==True:
					if TYPES[enf.nodeType] != "TEXT_NODE" or ( TYPES[enf.nodeType] == "TEXT_NODE" and "\n" not in enf.data):#re.sub("'","",re.sub(" ","",re.sub("\r","",re.sub("\n","",str(enf.data))))) != "ezqeqz"):
						"""
						if TYPES[enf.nodeType] == "TEXT_NODE":
							print("zz",enf.data,re.sub(" ","",enf.data))
						"""	
						self._SousBlocs.append(CBloc(enf,self))

				#self._enfants=self._noeud.childNodes
		except:
			Dprint("CXml219  except")
			#self._SousBlocs=None
		self.TexteXml()
		return self._SousBlocs

	def texte(self):
		Tprint("CBloc.texte()")
		if self._type=="TEXT_NODE":
			#print(self._NoeudXml.data)
			self._texte=str(self._NoeudXml.data)
		try:
			self._texte=str(self._NoeudXml.data)
		except:
			Dprint("CXml229 except")
		return self._texte		
		
		
	def TexteXml(self):
		Tprint("CBloc.TexteXml()")
		self._TexteXml=""		
		#self._NoeudXml=None#defusedxml.minidom.parse(fich).documentElement
		#print("pp",self._type)
		if self._type!="TEXT_NODE":
			self._TexteXml+="<"+self._NomBloc#<gpx
			for item in self._items:#=br_CDICO()#dict("version":"1.1","creator":"OsmAnd~ 3.6.3"...)
				self._TexteXml+=' '+item+'='+'"'+self._items[item]+'"'
			self._TexteXml+=">\n"
			for sb in self._SousBlocs:
				self._TexteXml+=sb._TexteXml	
			self._TexteXml+="</"+self._NomBloc+">\n"
			
		else:
			self._TexteXml+=self._texte+"\n"
		Dprint("CXml249",self._TexteXml	)
		return self._TexteXml	
		
	def AffichageComplet(self,niveau=0,pref="",prefAdd="\t"):		
		#self._NoeudXml=None#defusedxml.minidom.parse(fich).documentElement
		#print("pp",self._type)
		if self._type!="TEXT_NODE":
			print(pref+"_NomBloc",self._NomBloc)#gpx
		else:
			print(pref+"_texte",self._texte)
		
		print(pref+"items",self._items)#=br_CDICO()#dict("version":"1.1","creator":"OsmAnd~ 3.6.3"...)
		if niveau==0:
			print(pref+"_SousBlocs",[sb._NomBloc for sb in self._SousBlocs])
		else:
			for sb in self._SousBlocs:
				sb.AffichageComplet(niveau-1,pref=pref+prefAdd,prefAdd=prefAdd)
			 
		if self._Parent!=None:
			print(pref+"nom du parent",self._Parent._NomBloc)
			
	def __print__(self):
		self.AffichageComplet()
		
	def __str__(self):
		Tprint("CBloc.__str__()")
		return self._TexteXml
		
	def toprettyxml(self):
		Tprint("CBloc.toprettyxml()")
		return self._NoeudXml.toprettyxml()
		
		
	def ChercheTag(self,AChercher="root"):
		""" CXml.ChercheTag(AChercher="motachercher",Element="root"|Unelement,NonVide=True|False (renvoie les résultats vides ) """
		Tprint("CBloc.ChercheTag("+AChercher+")")
		res=self._NoeudXml.getElementsByTagName(AChercher)
		resultats=[CBloc(r) for r in res]
		return resultats	
	

		
DicoClasses['CFichierXml']=CFichierXml.__doc__

global main



	
def MAIN():	
	Dprint("CXmlLe programme lancé est "+sys.argv[0])
	
	global _FonctionDuProgramme

	_FonctionDuProgramme+="\nintroduction du xml : \n\ta=CFichierXml('/media/mac689Go/GPXs/casteknau ganet_2020-08-07_.gpx')\n"
	a=CFichierXml('/media/mac689Go/GPXs/casteknau ganet_2020-08-07_.gpx')
	
	_FonctionDuProgramme+="affichage des données xml ( sauf <?xml>) :\n\t print(a._TexteXml) ou plus simplement  print(a) \n"
	#print(a._TexteXml) # reecrit le fichier gpx
	#print(a) # # reecrit le fichier gpx

	_FonctionDuProgramme+="recherche des tag <gpt>...</gpt>  : \n"
	_FonctionDuProgramme+="\tfor b in CBloc(a._root).ChercheTag('wpt'):\n\t\tprint(b) \n"
	_FonctionDuProgramme+="OU\tfor b in a._bloc.ChercheTag('wpt'):\n\t\tprint(b) \n"
	_FonctionDuProgramme+="OU\tfor b in a.ChercheTag('wpt'):\n\t\tprint(b)\n"

	_FonctionDuProgramme+="\n\na.trkptToCsv(a.ChercheTag('trkpt'),fichier='machin.csv')"


			
	"""	
	for b in a._root.getElementsByTagName('wpt'):
		print(b)
		c=CBloc(b)
		print(c._TexteXml)
	"""	
	"""	
	for b in CBloc(a._root).ChercheTag('wpt'):
		print(b)
	
	"""	
	"""	
	a._bloc.AffichageComplet(-1)	
	"""
	print(_FonctionDuProgramme)
	





	a=CFichierXml('/media/mac689Go/GPXs/casteknau ganet_2020-08-07_.gpx')
	
	WPTs=a.ChercheTag('wpt')
	print(WPTs)
	TRKs=a.ChercheTag('trkpt')
	print(TRKs)	
	
	
	
	for wpt in a.ChercheTag('trkpt'):
		print(wpt)
	a.trkptToCsv(a.ChercheTag('trkpt'),fichier='/tmp/CXml1.csv')
	
	
	nb=1000
	GPXs=["/media/mac689Go/GPXs/20121231-183946.gpx","/media/mac689Go/GPXs/20130101-010300-2.gpx","/media/mac689Go/GPXs/20130101-010300.gpx","/media/mac689Go/GPXs/20130101-010331-2.gpx","/media/mac689Go/GPXs/20130101-010331.gpx","/media/mac689Go/GPXs/20130101-010935.gpx","/media/mac689Go/GPXs/20130101-010957.gpx","/media/mac689Go/GPXs/20130101-181240-rouen.gpx","/media/mac689Go/GPXs/20130102-200251.gpx","/media/mac689Go/GPXs/20130102-200408-2.gpx","/media/mac689Go/GPXs/20130102-200408.gpx","/media/mac689Go/GPXs/20160801-131618-pissy poville.gpx","/media/mac689Go/GPXs/20160801-160528-pissy poville.gpx","/media/mac689Go/GPXs/20160824-133717.gpx","/media/mac689Go/GPXs/20160824-161336.gpx","/media/mac689Go/GPXs/20161108-010957.gpx","/media/mac689Go/GPXs/2018-08-02_23-15_Thu.gpx","/media/mac689Go/GPXs/2018-08-04_13-54_Sat.gpx","/media/mac689Go/GPXs/2018-08-04_15-25_Sat.gpx","/media/mac689Go/GPXs/2018-08-04_16-11_Sat.gpx","/media/mac689Go/GPXs/2018-08-04_18-47_Sat.gpx","/media/mac689Go/GPXs/2018-08-05_17-19_Sun.gpx","/media/mac689Go/GPXs/2018-08-07_14-49_Tue.gpx","/media/mac689Go/GPXs/20180908-164226.gpx","/media/mac689Go/GPXs/20180908-164254-2.gpx","/media/mac689Go/GPXs/20180908-164254.gpx","/media/mac689Go/GPXs/20180910-172653.gpx","/media/mac689Go/GPXs/20180910-172723-2.gpx","/media/mac689Go/GPXs/20180910-172723.gpx","/media/mac689Go/GPXs/20180911-171115.gpx","/media/mac689Go/GPXs/20180917-170446-2.gpx","/media/mac689Go/GPXs/20180917-170446.gpx","/media/mac689Go/GPXs/20180928-151607.gpx","/media/mac689Go/GPXs/20180929-131204.gpx","/media/mac689Go/GPXs/20181231-183946.gpx","/media/mac689Go/GPXs/20190118-142713.gpx","/media/mac689Go/GPXs/20190121-173916.gpx","/media/mac689Go/GPXs/20190204-162613.gpx","/media/mac689Go/GPXs/20190204-181444.gpx","/media/mac689Go/GPXs/20190227-133644.gpx","/media/mac689Go/GPXs/20190301-222611.gpx","/media/mac689Go/GPXs/20190301-223921.gpx","/media/mac689Go/GPXs/20190301-225209.gpx","/media/mac689Go/GPXs/20190301-225452.gpx","/media/mac689Go/GPXs/20190302-161010.gpx","/media/mac689Go/GPXs/20190302-165450.gpx","/media/mac689Go/GPXs/20190306-161248.gpx","/media/mac689Go/GPXs/20190313-161957.gpx","/media/mac689Go/GPXs/20190315-164446.gpx","/media/mac689Go/GPXs/20190315-171256.gpx","/media/mac689Go/GPXs/20190315-172407.gpx","/media/mac689Go/GPXs/20190315-174843(0).gpx","/media/mac689Go/GPXs/20190315-174843.gpx","/media/mac689Go/GPXs/20190320-134302.gpx","/media/mac689Go/GPXs/20190320-163003.gpx","/media/mac689Go/GPXs/20190323-195021.gpx","/media/mac689Go/GPXs/20190327-111522.gpx","/media/mac689Go/GPXs/20190327-112805.gpx","/media/mac689Go/GPXs/20190329-134716.gpx","/media/mac689Go/GPXs/20190329-134903.gpx","/media/mac689Go/GPXs/20190329-135017.gpx","/media/mac689Go/GPXs/20190329-155951.gpx","/media/mac689Go/GPXs/20190403-135101.gpx","/media/mac689Go/GPXs/20190403-151538.gpx","/media/mac689Go/GPXs/20190403-151811.gpx","/media/mac689Go/GPXs/20190403-162916.gpx","/media/mac689Go/GPXs/20190403-163028.gpx","/media/mac689Go/GPXs/20190405-152415.gpx","/media/mac689Go/GPXs/20190405-201321.gpx","/media/mac689Go/GPXs/20190405-201425.gpx","/media/mac689Go/GPXs/20190405-233553.gpx","/media/mac689Go/GPXs/20190406-174446.gpx","/media/mac689Go/GPXs/20190407-191734.gpx","/media/mac689Go/GPXs/20190408-153313.gpx","/media/mac689Go/GPXs/20190410-174542.gpx","/media/mac689Go/GPXs/20190411-134427.gpx","/media/mac689Go/GPXs/20190411-153409.gpx","/media/mac689Go/GPXs/20190423-150137.gpx","/media/mac689Go/GPXs/20190423-152219.gpx","/media/mac689Go/GPXs/20190425-172533.gpx","/media/mac689Go/GPXs/20190425-191910.gpx","/media/mac689Go/GPXs/20190426-165918.gpx","/media/mac689Go/GPXs/20190429-161334.gpx","/media/mac689Go/GPXs/20190429-161739.gpx","/media/mac689Go/GPXs/20190430-162758.gpx","/media/mac689Go/GPXs/20190430-165109.gpx","/media/mac689Go/GPXs/20190430-183513.gpx","/media/mac689Go/GPXs/20190513-194138.gpx","/media/mac689Go/GPXs/20190515-134342.gpx","/media/mac689Go/GPXs/20190515-134510.gpx","/media/mac689Go/GPXs/20190527-165850(0).gpx","/media/mac689Go/GPXs/20190527-165850(1).gpx","/media/mac689Go/GPXs/20190527-165850(2).gpx","/media/mac689Go/GPXs/20190527-165850.gpx","/media/mac689Go/GPXs/20190921-183914.gpx","/media/mac689Go/GPXs/20190921-235839.gpx","/media/mac689Go/GPXs/20200613-150536.gpx","/media/mac689Go/GPXs/20200613-151044.gpx","/media/mac689Go/GPXs/2020-07-14_19-00_Tue.gpx","/media/mac689Go/GPXs/2020-07-16_16-38_Thu.gpx","/media/mac689Go/GPXs/2020-07-16_17-47_Thu.gpx","/media/mac689Go/GPXs/2020-07-24_15-55_Fri.gpx","/media/mac689Go/GPXs/2020-07-24_16-09_Fri.gpx","/media/mac689Go/GPXs/2020-07-24_20-42_Fri.gpx","/media/mac689Go/GPXs/2020-08-06_11-47_Thu.gpx","/media/mac689Go/GPXs/2020-08-08_08-49_Sat.gpx","/media/mac689Go/GPXs/2020-08-09_08-20_Sun.gpx","/media/mac689Go/GPXs/2020-08-09_09-07_Sun.gpx","/media/mac689Go/GPXs/2020-08-09_12-28_Sun.gpx","/media/mac689Go/GPXs/2020-08-09_15-18_Sun.gpx","/media/mac689Go/GPXs/2020-08-14_17-53_Fri_2.gpx","/media/mac689Go/GPXs/2020-08-14_17-53_Fri.gpx","/media/mac689Go/GPXs/2020-08-21_15-01_Fri.gpx","/media/mac689Go/GPXs/2020-08-21_19-36_Fri.gpx","/media/mac689Go/GPXs/2020-08-22_11-56_Sat.gpx","/media/mac689Go/GPXs/2020-08-22_15-56_Sat.gpx","/media/mac689Go/GPXs/20200925favourites.gpx","/media/mac689Go/GPXs/a.gpx","/media/mac689Go/GPXs/a prendre en vacances.gpx","/media/mac689Go/GPXs/AvecPoum LeCher 2020-09-26_19-36_Sat.gpx","/media/mac689Go/GPXs/AvecPoum LeCher 2020-09-26_19-55_Sat.gpx","/media/mac689Go/GPXs/casteknau ganet_2020-08-07_.gpx","/media/mac689Go/GPXs/castelnau gané_2020-08-07_.gpx","/media/mac689Go/GPXs/castelnau montratier figeac.gpx","/media/mac689Go/GPXs/Chartres 2020-10-24_14-44_Sat.gpx","/media/mac689Go/GPXs/Chartres 2020-10-25_15-13_Sun.gpx","/media/mac689Go/GPXs/Chartres 2020-10-25_16-55_Sun.gpx","/media/mac689Go/GPXs/Dieppe 2020-12-17_16-09_Thu.gpx","/media/mac689Go/GPXs/divers.gpx","/media/mac689Go/GPXs/f1.gpx","/media/mac689Go/GPXs/favourites-2.gpx","/media/mac689Go/GPXs/favourites.gpx","/media/mac689Go/GPXs/fécamp-2020-06-11_18-56_Thu.gpx","/media/mac689Go/GPXs/figeac rouen.gpx","/media/mac689Go/GPXs/LaRayasse-2013-01-02_12-47-53.gpx","/media/mac689Go/GPXs/LaRayasse-2019-12-28_15-37_Sat.gpx","/media/mac689Go/GPXs/LaRayasse-2019-12-29_09-00_Sun.gpx","/media/mac689Go/GPXs/LaRayasse-StRomain2019-12-29_10-34_Sun.gpx","/media/mac689Go/GPXs/maman2020-07-10_16-55_Fri.gpx","/media/mac689Go/GPXs/Maman-Elena.gpx","/media/mac689Go/GPXs/Markers_2018-07-18.gpx","/media/mac689Go/GPXs/Markers_2018-08-07_2.gpx","/media/mac689Go/GPXs/Markers_2018-08-07.gpx","/media/mac689Go/GPXs/MSA-Rouen-2019-10-13_16-54-33.gpx","/media/mac689Go/GPXs/MSA-rouen-2019-10-25_18-05-14.gpx","/media/mac689Go/GPXs/oléron castelnau montratier.gpx","/media/mac689Go/GPXs/photos avec sylvain 2020-01-10_14-43-31.gpx","/media/mac689Go/GPXs/Point de cheminement de la trace.gpx","/media/mac689Go/GPXs/rouen 2013-01-01_08-53_Tue.gpx","/media/mac689Go/GPXs/Rouen-2013-01-05_15-47-33.gpx","/media/mac689Go/GPXs/Rouen-2019-09-11_16-20-03.gpx","/media/mac689Go/GPXs/rouen-2019-09-19_14-27-23.gpx","/media/mac689Go/GPXs/Rouen-2019-09-19_14-37-48.gpx","/media/mac689Go/GPXs/Rouen-2019-09-20_15-06-09.gpx","/media/mac689Go/GPXs/Rouen-2019-09-20_17-11-48.gpx","/media/mac689Go/GPXs/Rouen-2019-09-30_16-02-24.gpx","/media/mac689Go/GPXs/Rouen-2019-10-02_18-36-37.gpx","/media/mac689Go/GPXs/Rouen-2019-10-04_15-39-15.gpx","/media/mac689Go/GPXs/Rouen-2019-10-04_16-04-21.gpx","/media/mac689Go/GPXs/Rouen-2019-10-05_17-42-19.gpx","/media/mac689Go/GPXs/Rouen-2019-10-05_17-54-49.gpx","/media/mac689Go/GPXs/Rouen-2019-10-07_17-57-21.gpx","/media/mac689Go/GPXs/Rouen-2019-10-08_16-10-23.gpx","/media/mac689Go/GPXs/Rouen-2019-10-08_16-11-39.gpx","/media/mac689Go/GPXs/Rouen-2019-10-09_17-23-04.gpx","/media/mac689Go/GPXs/Rouen-2019-10-15_19-42-30.gpx","/media/mac689Go/GPXs/Rouen-2019-10-17_16-16-39.gpx","/media/mac689Go/GPXs/Rouen-2019-10-17_16-22-53.gpx","/media/mac689Go/GPXs/rouen-2020-07-04_18-22_Sat.gpx","/media/mac689Go/GPXs/rouen-2020-07-05_16-59_Sun.gpx","/media/mac689Go/GPXs/Rouen 2020-12-20_08-49_Sun.gpx","/media/mac689Go/GPXs/Rouen-ClermontFerrand-2019-11-09_14-07-06.gpx","/media/mac689Go/GPXs/Rouen-LesGrandesDalles 2021-01-02_16-34_Sat.gpx","/media/mac689Go/GPXs/Rouen-MSA 2020-12-16_17-46_Wed par la gare.gpx","/media/mac689Go/GPXs/rouen oléron.gpx","/media/mac689Go/GPXs/rouen-poum-2020-02-17_16-11-32.gpx","/media/mac689Go/GPXs/rouen-saint-romain-de-colbosc-2019-12-29_19-08_Sun.gpx","/media/mac689Go/GPXs/rouen-vélo-2020-07-02_20-03_uThu.gpx","/media/mac689Go/GPXs/rouen-vélo-2020-07-03_18-20_Fri.gpx","/media/mac689Go/GPXs/rouen-vélo-2020-07-10_17-45_Fri.gpx","/media/mac689Go/GPXs/StRomainDeColbosc-2019-09-22_00-08-19.gpx","/media/mac689Go/GPXs/suisse normande nord.gpx","/media/mac689Go/GPXs/suisse normande sud.gpx","/media/mac689Go/GPXs/trouville.gpx","/media/mac689Go/GPXs/VacancesRabodanges-2020--02--22_15-42-38.gpx","/media/mac689Go/GPXs/VacancesRabodanges-2020-02-23_14-03_Sun_2.gpx","/media/mac689Go/GPXs/VacancesRabodanges-2020-02-23_14-03_Sun.gpx","/media/mac689Go/GPXs/VacancesRabodanges-2020-02-23_15-21-15.gpx","/media/mac689Go/GPXs/VacancesRabodanges-2020-02-23_15-39-01.gpx","/media/mac689Go/GPXs/VacancesRabodanges-2020-02-23_15-56-04.gpx","/media/mac689Go/GPXs/VacancesRabodanges-2020-02-23_16-29_Sun.gpx","/media/mac689Go/GPXs/VacancesRabodanges-2020-02-24_14-26_Mon.gpx","/media/mac689Go/GPXs/VacancesRabodanges-falaise-2020-02-23_16-25-25.gpx","/media/mac689Go/GPXs/velo et vole 2020-07-07_19-06_Tue.gpx","","/media/mac689Go/GPXs/villerville.gpx"]
	#GPXs=['/media/mac689Go/GPXs/casteknau ganet_2020-08-07_.gpx']
	for gpx in GPXs:
		print('= = = = =',gpx)
		try:
			a=CFichierXml(gpx)
			TRKPTs=a.ChercheTag('trkpt')
			a.wptToCsv(TRKPTs,fichier='/tmp/CSVs/'+str(nb)+'.csv')			
		except:
			pass
		nb=nb+1	

	"""
	def ToDict(c,pref=""):
		di=br_CDICO()
		if c._type!='TEXT_NODE':
			pass#print(pref+"_"+c._NomBloc)
		else:	
			Dprint(pref+"="+c._texte)
			if pref in di:
				Dprint("CXml342","la clé "+pref+" existe déjà")
				exit()
			di[pref]=c._texte
			
		for item in c._items:
			Dprint(c._NomBloc+"_"+item+"="+c._items[item])
			if c._NomBloc+"_"+item in di:
				Dprint("CXml349","la clé "+c._NomBloc+"_"+item+" existe déjà")
				exit()			
			di[c._NomBloc+"_"+item]=c._items[item]
		for SousBloc in c._SousBlocs:
			di.update(ToDict(SousBloc,pref=pref+c._NomBloc+"_"))
		return di	
	d=br_CDICO()
	d=ToDict(b[0])		
	print(d)
	"""
	#a=CFichierXml('FichiersAnnexes/dimanxhe oleron2020-07-26_15-59_Sun.gpx')
	
	#a=CFichierXml('FichiersAnnexes/a.gpx')
	#a=CFichierXml('/media/mac689Go/TOUSLESGPX.gpx')
	
	
	
	
	'''
	for f in ["20121231-183946.gpx","20130101-010300.gpx","20130101-010331.gpx","20130101-010935.gpx","20130101-010957.gpx","20130102-200251.gpx","20130102-200408.gpx","20160824-133717.gpx","20160824-161336.gpx","20180908-164226.gpx","20180908-164254.gpx","20180910-172653.gpx","20180910-172723.gpx","20180911-171115.gpx","20180917-170446.gpx","20180928-151607.gpx","20180929-131204.gpx","20190118-142713.gpx","20190121-173916.gpx","20190204-162613.gpx","20190204-181444.gpx","20190227-133644.gpx","20190301-222611.gpx","20190301-223921.gpx","20190301-225209.gpx","20190301-225452.gpx","20190302-161010.gpx","20190302-165450.gpx","20190306-161248.gpx","20190313-161957.gpx","20190315-164446.gpx","20190315-171256.gpx","20190315-172407.gpx","20190315-174843(0).gpx","20190315-174843.gpx","20190320-134302.gpx","20190320-163003.gpx","20190323-195021.gpx","20190327-111522.gpx","20190327-112805.gpx","20190329-134716.gpx","20190329-134903.gpx","20190329-135017.gpx","20190329-155951.gpx","20190330-165326.gpx.zip","20190403-135101.gpx","20190403-151538.gpx","20190403-151811.gpx","20190403-162916.gpx","20190403-163028.gpx","20190405-152415.gpx","20190405-201321.gpx","20190405-201425.gpx","20190405-233553.gpx","20190406-174446.gpx","20190407-191734.gpx","20190408-153313.gpx","20190410-174542.gpx","20190411-134427.gpx","20190411-153409.gpx","20190423-150137.gpx","20190423-152219.gpx","20190425-172533.gpx","20190425-191910.gpx","20190426-165918.gpx","20190426-172106.gpx","20190429-161334.gpx","20190429-161739.gpx","20190430-162758.gpx","20190430-183513.gpx","20190513-194138.gpx","20190515-134342.gpx","20190515-134510.gpx","20190527-165850(2).gpx","20190710-152227.gpx","2020-07-14_19-00_Tue.gpx","2020-07-16_16-38_Thu.gpx","2020-07-16_17-47_Thu.gpx","2020-07-24_15-55_Fri.gpx","2020-07-24_16-09_Fri.gpx","2020-07-24_20-42_Fri.gpx","2020-07-25_10-33_Sat.gpx","2020-07-25_15-36_Sat.gpx","2020-07-25_17-22_Sat.gpx","2020-07-26_16-06_Sun.gpx","2020-08-06_11-47_Thu.gpx","2020-08-08_08-49_Sat.gpx","2020-08-09_08-20_Sun.gpx","2020-08-09_09-07_Sun.gpx","2020-08-09_12-28_Sun.gpx","2020-08-09_15-18_Sun.gpx","2020-08-14_17-53_Fri_2.gpx","2020-08-21_15-01_Fri.gpx","2020-08-21_19-36_Fri.gpx","2020-08-22_11-56_Sat.gpx","2020-08-22_15-56_Sat.gpx","ca1.gpx","ca2.gpx","casteknau ganet_2020-08-07_.gpx","castelnau gané_2020-08-07_.gpx","castelnau montratier figeac.gpx","castelnau par bergerac_2020-07-31_.gpx","castelnau par limoges_2020-07-31_.gpx","dimanxhe oleron2020-07-26_15-59_Sun.gpx","f1.gpx","fa1.gpx","favourites.gpx","figeac rouen.gpx","go1.gpx","go2.gpx","Maman-Elena.gpx","Markers_2020-09-17.gpx","oléron castelnau montratier.gpx","rouen oléron.gpx","ven hut_2020-07-26_.gpx"]:
		a=CFichierXml('/media/mac689Go/GPXs/'+f)
	'''

	
	
	#a.trkptToCsv(a.ChercheTag('trkpt'))
	
	#print(a.toprettyxml())



	#print(a._root.toxml())
	#print(a._root.getElementsByTagName('wpt'))
	
	#print(a.Analyse())
		
	#print(a._root.attributes.items())
	
	#b=CBloc(a._root)
	#print(b._NomBloc)
	#print(b._items)
	#b._SousBlocs=a._root.childNodes
	
	#for c in b._SousBlocs:
	#	print(c.nodeType)
	#print("root",a._root.nodeType)		
	#b=b._SousBlocs[1]
	
	#print('sb',b.toprettyxml())
	#print(a._bloc.AffichageComplet(-1))
	
	#b=b._SousBlocs[1]
	#b.AffichageComplet(-1)
	
	'''
	#print("uu",a._root.childNodes[3].childNodes[3].childNodes[1].childNodes[0].data)
	print("uu",a._root.childNodes[3].childNodes[0])
	print('zz')
	print("uu",a._root.childNodes[3].childNodes[0].data)
	print('zz')
	x=re.sub("'","",re.sub(" ","",re.sub("\r","",re.sub("\n","",a._root.childNodes[3].childNodes[0].data))))
	print("xx","r"+x+"r")
	print('zz')
	'''
	
	
	
	
	
	#(b.AffichageComplet(-1))
	"""
	print(_FonctionDuProgramme)
	print("version:"+_Version)

	print('import CFonctions')
	for a in DicoFonctions:
		print('from CFonctions import '+a)
		print("  "+DicoFonctions[a])
	for a in DicoClasses:
		print('from CFonctions import '+a)
		print("  "+DicoClasses[a])
	exit()
	print('import CFichiersRepertoires')
	print('from CFichiersRepertoires import CFichiersRepertoires,CFichiers')
	print('fich=CFichiers(nomfich)')
	print('  fich._SEP')
	print('  fich._fich , fich.Valide() , fich.RepNom() ,	fich.FichNom()')
	print('rep=CFichiers(nomrep)')
	print('  rep._SEP , rep.Contenu() ')
	print('  rep._rep , rep.Valide() , rep.RepNom() ,	rep.FichNom()')
	"""
	sys.exit()





	
import CFichierContenu
from CFichierContenu import CExtensions,CFichierContenu
def CSVGPX():
	ligne3="latitude#longitude#date#heure\n"
	for nofichier in range(1000,1200):
		nom_fichier="/tmp/CSVs/"+str(nofichier)+".csv"
		try:
			CFC=CFichierContenu(nom_fichier)
			Lignes=CFC.Lignes()
			numeros=[]
			for no,nom in enumerate(Lignes[0].split('#')):		
				if "trkpt_lat" in nom or "trkpt_lon" in nom or "time" in nom:
					#print(no,nom)
					numeros.append(no)
			if len(numeros)==3:
				for ligne in Lignes[1:]:					
					infos=ligne.split('#')
					ligne2=""
					for no in numeros:
						ligne2+=infos[no]+"#"
					ligne2=re.sub("^(.*#.*#.*)T(.*)Z#$","\g<1> \g<2>",ligne2)
					ligne3+=ligne2+"\n"
		except:
			print("le fichier "+nom_fichier+" n 'existe pas")	
	print(ligne3)



if __name__ == "__main__":
	MAIN()
