#!/usr/bin/python3
# -*- coding: utf-8 -*-
#from __future__ import print_function
_FonctionDuProgramme="Classe accédant à une base de données"
_importe="re,os,sys,mysql,datetime,mysql.connector-V2.1.6-1,sqlite3"
#print(_FonctionDuProgramme)
_Version="1.6.1"



dossier="/opt/CLASSES3"
import sys
if dossier not in sys.path:
    sys.path.append(dossier)
#print("version:"+_Version)
_FonctionDuProgramme+="\n\
Version:"+_Version+"\n"
from CFonctions3 import *

'''
1.6.0 https://dev.mysql.com/doc/connector-python/en/connector-python-example-ddl.html
1.5.3 utilisation sqlite3 en cours
1.5.2
self._cnx=None si pb
ajout cd CSqBaseDeDonnees
#1.5.1
self._Tables
self._ChampsDUneTable[table]=champs
#1.5 Mysql_Select_Multiple plutot que Mysql_Select
#1.4 stmt
#1.3 correction bugs listes
'''

'''
après un select : self._NomsColonnes,self._resultats

'''

#print("version:"+_Version)
import re
import os
##################### debug
import sys

_affiche_Titres=True # 
_affiche_Titres=False

_debug_Log=True #
_debug_Log=False

_debug_all=True # 
_debug_all=False

if _debug_all==True:
	_affiche_Titres=True
	_debug_Log=True


_FichierLog='/tmp/'+re.sub(".*/","",sys.argv[0])+'.log'
_Log=open(_FichierLog,'w')

def Tprint(*args, **kwargs):
	if _affiche_Titres==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
#def Dprint(ligne):
def Dprint(*args, **kwargs):	
	if _debug_all==True:
		print(*args, **kwargs)
		print('--------------------------')
# # # # # # # # # # # # # # # # # # # debug


import mysql,datetime
import mysql.connector


class br_CDICO(dict):
	def __missing__(self, key):
		return ""		
		

class CBaseDeDonnees(object):
	""" CLASSE CBaseDeDonnees(utilisateur='utilisateur',mdp='motdepasse',hote="127.0.0.1",base='Base') : un fichier """
	def __init__(self,config=None):
		Tprint('-** CBaseDeDonnees.__init__()')
		
		if config!=None:
			#print(config)
			self.Mysql_Connection(config)		
		
		self._Tables=[]
		
	def Mysql_Connection(self,config):#V160
		""" connection à la base de données"""				
		try:				
			self._cnx = mysql.connector.connect(**config)
			if self._cnx.is_connected():
				self._cursor = self._cnx.cursor()
				print('Connecté à la base mysql avec config')
				return True
		except:
			print('!!!!!!!!!!!!!!!!!!!!!!!!!!!! pb de Mysql_Connection avec config!!!!!!!!!!!!!!!!!!!')
			self._cnx=None
			self._cursor=None
			return False
	
	def Update(self,dico):
		Tprint("CBaseDeDonnees.Update")	
		#quoi={"champ1":"valeur1","inn":5}
		#dico={"quoi":quoi,"table":"fichiers",,"where":{"id":IdFichier}}
	
		
		
		try:
			sql="UPDATE "+dico["table"]+" SET "
			valeurs=[]
			for champ,valeur in dico["quoi"].items():
				#temp+=champ+"='"+valeur+"',"
				sql+=champ+" = %s ,"
				valeurs.append(valeur)
			sql=sql[0:-1]	
			if "where" in dico.keys():
				sql+="WHERE "
				for champ,valeur in dico["where"].items():
					sql+=champ+" = %s AND"
					valeurs.append(valeur)
				sql=sql[0:-4]
			print(sql)
			valeurs=(5,33,)
			print(tuple(valeurs))
			
			self._cursor.execute(sql,tuple(valeurs))
			#return sortie
			
		except mysql.Error as e:
			print(e)
			exit(159)
			return None
	
	def Select(self,dico):
		Tprint("CBaseDeDonnees.Select")
		try:
			temp="SELECT "+dico["quoi"]+" FROM "+dico["table"]
			if dico["where"]!=None:
				temp+=" where "+dico["where"]
			print(temp)
			self._cursor.execute(temp)
			self._resultats=self._cursor.fetchall()
			
			self._NomsColonnes=self._cursor.column_names
			return [self._NomsColonnes,self._resultats]
			
		except mysql.Error as e:
			print(e)
			exit(159)
			return None

	def ListeTables(self):#['RUNES', 'Zarmes0', 'Zarmes1', 'Zarmes2', 'armes', 'armures', 'boucliers', 'boucliers0', 'boucliersV2', 'races']
		Tprint('-** CBaseDeDonnees.ListeTables()')
		tables=[]
		sql='show TABLES'
		self._cursor.execute(sql)		
		resultats=self._cursor.fetchall()#[('Zpoints',), ('points',)]
		self._Tables=[i[0] for i in resultats]
		
		return self._Tables
		
			
	def ListeChamps(self,table="table"):
		Tprint('-** CBaseDeDonnees.ListeChamps(table="table")')
		dico={"quoi":"column_name","table":"information_schema.columns","where":"table_name='"+table+"'"}
		z=self.Select(dico)#[('column_name',), [('id',), ('fichier',),
		champs=[i[0] for i in z[1]]#['id', 'fichier'
	
		return champs	
	
			
	#BD.Insere("points",{"id":120,"fichier":"/ll","id_du_fichier":321})		
	def Insere(self,table=None,dico=None):
		#BD._Insere("points",{"id":None,"fichier":"/ll","id_du_fichier":12})
		
		sql='INSERT INTO '+table+' ('
		valeurstemp='('
		valeurs=[]
		for clef,valeur in dico.items():
			sql+=clef+','			
			valeurs.append(valeur)			
		
		sql=sql[:-1]	
		valeurstemp+=('%s'+',')*(len(dico)-1)+'%s'
		valeurstemp+=')'
		sql+=')'+' VALUES '+ valeurstemp 
		valeurs=tuple(valeurs)
		
		#print("sql = ",sql)
		#print("valeurs = ",valeurs)
		self._cursor.execute(sql,valeurs)
		"""
		aaa=("INSERT INTO points (id,fichier,id_du_fichier,trkpt_lat,trkpt_lon,trkpt_ele_,trkpt_time_) VALUES (%s,%s,%s,%s,%s,%s,%s)")
		bbb=(no,'/tmp/bb/20130101-181240.gpx','10838','49.44571','1.09493','38.2','2016-08-02 19:03:23')
		BD._cursor.execute(aaa,bbb)	
		"""			
		
		self._cnx.commit()
		"""
		self._cursor.close()
		self._cnx.close()
		"""		
		
			
	def ZMysql_Update(self,texte=None):
		""" Mysql_Query(self,texte=None,typeuh="SELECT") """
		Tprint('-** CBaseDeDonnees.Mysql_Update() (>= 1.2)')
		return self.Mysql_Query(texte,typeuh="UPDATE")
		
	def ZMysql_Query15(self,texte=None,typeuh=None):
		""" Mysql_Query15(self,texte=None,typeuh=None)\n questionne la base de données (>= 1.2 <1.6)"""
		Tprint('-** CBaseDeDonnees.Mysql_Query() (>= 1.2 <1.6)')
		Dprint(texte)
		
		if typeuh !=None :
			typeuh=typeuh.upper()
			
		if typeuh=="SELECT":
			try:
				conn=self._cnx#self.Mysql_Connection()				
				self._cursor.execute(texte)
				self._resultats=self._cursor.fetchall()
				
				self._NomsColonnes=self._cursor.column_names
				return [True,[self._NomsColonnes,self._resultats]]
				
			except Error as e:
				print(e)
				exit(132)
				return None
			"""
			finally:			
				cursor.close()
				conn.close()
			"""	
		if typeuh=="INSERE":
			try:
				conn=self._cnx
				cursor = conn.cursor()
				cursor.execute(texte)
				#print("INSEREE MAIS INSERTION NON VERIFIE")
				return [True,"INSEREE MAIS INSERTION NON VERIFIE"]
			except Error as e:
				print(e)
				exit(133)
				return None	

		if typeuh=="UPDATE":
			try:
				conn=self._cnx
				cursor = conn.cursor()
				cursor.execute(texte)
				Dprint("update")
				conn.commit()
				return [True,"update"]
			except Error as e:
				print(e)
				exit(134)
				return None	
				
		if typeuh=="SHOW":
			try:
				conn=self._cnx
				cursor = conn.cursor()
				cursor.execute(texte)
				self._resultats=cursor.fetchall()
				Dprint("show")
				conn.commit()
				return [True,self._resultats]
			except Error as e:
				print(e)
				exit(135)
				return None	
					
		#BD._cnx.commit()			
	
		
	def zzzMysql_Query(self,texte=None,typeuh="SELECT"):
		""" Mysql_Query1(self,texte=None,typeuh="SELECT")\n questionne la base de données (<= 1.1.0 )"""
		Tprint('-** CBaseDeDonnees.Mysql_Query() (<= 1.1.0 )')
		Dprint(texte)
		
		
		if typeuh=="SELECT":
				
			'''
			
			self._resultats=None
			if texte!=None:
				Dprint(texte)
				
				"""
				self._resultats = self._cnx.cursor()			
				self._resultats.execute(texte)
				"""
				try:
					cursor = self._cnx.cursor()			
					cursor.execute(texte)
					self._resultats = cursor.fetchall()

				except Error as e:
					print(e)
			 
				finally:
					cursor.close()
					conn.close()	
					return self._resultats
			'''
			
			try:
				#conn = mysql.connector.connect(user='BA_user',password='oCmX8ZiEQw4lkTkf',host="127.0.0.1",database='BA')
				#conn = mysql.connector.connect(user=self._utilisateur,password=self._mdp,host=self._hote,database=self._base)
				conn=self._cnx#self.Mysql_Connection()
				cursor = conn.cursor()
				#cursor.execute("SELECT * FROM boucliers")
				cursor.execute(texte)
				self._resultats=cursor.fetchall()
				self._NomsColonnes=cursor.column_names
				#print('Total Row(s):', cursor.rowcount)
				'''for res in self._resultats:
					print(res)
				'''	
				"""	un par un 
				while row is not None:
					print(row)
					row = cursor.fetchone()
				"""						
				return [self._NomsColonnes,self._resultats]
				
			except Error as e:
				print(e)
				exit(132)
				return None
			"""
			finally:			
				cursor.close()
				conn.close()
			"""	
		if typeuh=="INSERE":
			try:
				conn=self._cnx
				cursor = conn.cursor()
				cursor.execute(texte)
				Dprint("INSEREE MAIS INSERTION NON VERIFIE")
				return "INSEREE MAIS INSERTION NON VERIFIE"
			except Error as e:
				print(e)
				exit(133)
				return None	
					
		BD._cnx.commit()			
	
	def ZMysql_Insere_Multiple(self,table="table",DONNEES=[[],[]],typeuh="TabloTablo"): #V1.4
		""" insérer une données sous forme de [ champ 1,champ2 , champ3 .. ] """
		Tprint('-** CBaseDeDonnees.Mysql_Insere_Multiple()')
		typeuh=typeuh.upper()
		tchamps=self.Mysql_ListeChamps(table)		
					
		ENTETE='INSERT INTO `'+table+'`'		
		#INSERT INTO names (name, info, age) VALUES (%s, %s, %s)
		MILIEU=' ('		
		for t in tchamps:
			MILIEU+='`'+t+'`,'
		MILIEU=MILIEU[0:-1]+') VALUES (' +  ("%s ," * len(tchamps))[0:-1] +")"
		
		
		VALEURS=()
		if typeuh=="TABLOTABLO":
			for i in range(len(DONNEES)):
				DONNEES[i]=tuple(DONNEES[i])
			VALEURS=tuple(DONNEES)
		if typeuh=="CSV;":
			Dprint("DONNEES[0:2]",(DONNEES[0:2]))
			
			for i in range(len(DONNEES)):
				Dprint("DONNEES[i]",DONNEES[i])
				Dprint(tuple(DONNEES[i].split(';')))
				DONNEES[i]=tuple(DONNEES[i].split(';'))
			
			VALEURS=tuple(DONNEES)
			
		
		Dprint(ENTETE+MILIEU)
		Dprint(VALEURS)
		Dprint("-------- ENTETE+MILIEU -----\n"+ENTETE+MILIEU)
		Dprint("-------- ------------,VALEURS -----\n",VALEURS)
		Dprint('==')
		
		self.Mysql_QueryMultiple(ENTETE+MILIEU,VALEURS)
	
	
	
	def ZZZMysql_Insere_MultipleV_1_1_0(self,table="table",DONNEES=[[],[]],typeuh="TabloTablo"): #V1.1.0
		""" insérer une données sous forme de [ champ2 , champ3 .. ] le champ 1 étant NuLL par défaut """
		Tprint('-** CBaseDeDonnees.Mysql_Insere_Multiple()')
		typeuh=typeuh.upper()
		tchamps=self.Mysql_ListeChamps(table)		
					
		ENTETE='INSERT INTO `'+table+'`'		
		#INSERT INTO names (name, info, age) VALUES (%s, %s, %s)
		MILIEU=' ('		
		for t in tchamps[1:]:
			MILIEU+='`'+t+'`,'
		MILIEU=MILIEU[0:-1]+') VALUES (' +  ("%s ," * len(tchamps[1:]))[0:-1] +")"
		
		
		VALEURS=()
		if typeuh=="TABLOTABLO":
			for i in range(len(DONNEES)):
				DONNEES[i]=tuple(DONNEES[i])
			VALEURS=tuple(DONNEES)
		if typeuh=="CSV;":
			print("DONNEES[0:2]",(DONNEES[0:2]))
			
			for i in range(len(DONNEES[0:2])):
				print("DONNEES[i]",DONNEES[i])
				print(tuple(DONNEES[i].split(';')))
				DONNEES[i]=tuple(DONNEES[i].split(';'))
			
			VALEURS=tuple(DONNEES[0:2])
			
		
		Dprint(ENTETE+MILIEU)
		Dprint(VALEURS)
		print("-------- ENTETE+MILIEU -----\n"+ENTETE+MILIEU)
		print("-------- ------------,VALEURS -----\n",VALEURS)
		print('==')
		self.Mysql_QueryMultiple(ENTETE+MILIEU,VALEURS)
	
		
					
	def ZMysql_QueryMultiple(self,INS,DON):#INS="INSERT INTO names (name, info, age) VALUES (%s, %s, %s)" # DON=(('Geert', info, 30), ('Jan', info, 31))
		""" insère multiples données"""
		Tprint('-** CBaseDeDonnees.Mysql_QueryMultiple()')
		cursor = self._cnx.cursor()
		cursor.executemany(INS,DON)
		self._cnx.commit()
		"""
		names = (('dddddddd',5,8),('dddddddd',5,8))
		stmt_insert = "INSERT INTO tex (document,a,b) VALUES (%s, %s, %s)"
		cursor.executemany(stmt_insert, names)
		"""
		
		
					

		
		
	def ZMysql_Insere0(self,table="table",DONNEES=[]):# V1.0.1
		""" insérer une données sous forme de [ champ2 , champ3 .. ] le champ 1 étant NuLL par défaut """
		Tprint('-** CBaseDeDonnees.Mysql_Insere()')
		tchamps=self.Mysql_ListeChamps(table)
		
		ENTETE='INSERT INTO `'+table+'`'
		
		MILIEU=' ('		
		for t in tchamps:
			MILIEU+='`'+t+'`,'
		MILIEU=MILIEU[0:-1]+') VALUES '
		
		VALEURS='(NULL'
		for d in DONNEES:
			VALEURS+=", '"+str(d)+"'"
		VALEURS+=')'
		
		texte=ENTETE+MILIEU+VALEURS
		
		#exit()	
		self.Mysql_Query(texte,typeuh="INSERE")
		
		#INSERT INTO `tex` (`id`, `document`, `a`, `b`) VALUES (NULL, 'dsqdqs', '2', '3');
		
		
	"""def Selectionne(self,table='table',texte=""):
		pass
		#query = ("SELECT first_name, last_name, hire_date FROM employees "    "WHERE hire_date BETWEEN %s AND %s")
	"""


		
	def ZMysql_VideTable(self,table='table'):
		""" vide les données d'une table  ( >= V1.1.1 ) """
		Tprint('-** CBaseDeDonnees.Mysql_VideTable()')
		texte="TRUNCATE `"+table+"` ;"
		
		try:
			conn=self._cnx
			cursor = conn.cursor()
			res=cursor.execute(texte)
			Dprint("TRUNCATE effectué mais NON VERIFIE")
			return "TRUNCATE effectué mais NON VERIFIE"
		except Error as e:
			print(e)
			exit(1110)
			return None				
		self._cnx.commit()
		self._Tables=self.Mysql_ListeTables()
		return res
		

		
		
			
import sqlite3
class CSqBaseDeDonnees(object):
	""" CLASSE CFichiers(str(fich)) : un fichier """
	def __init__(self,fichier='/tmp/a.db'):		
		Tprint('-** CSqBaseDeDonnees.__init__()')
		
		self._ChampsDUneTable=br_CDICO()		
		self._Tables=[]
		self._cnx = self._cursor = None
		
		self.Initialise_Sqlite3_Base(fichier)
		

	def Initialise_Sqlite3_Base(self,fichier):
		self._fichier=fichier		
		self.Sqlite3_Connection()
		#print(type(self._cnx))
		
	"""
	import sqlite3
	conn = sqlite3.connect('/tmp/aa/example.db')
	c = conn.cursor()

	# Create table
	c.execute('show TABLES')

	conn.commit()

	exit()
	"""
		
		
	def Sqlite3_Connection(self):#V1.1.1 1.5.2
		""" connection à la base de données"""
		Tprint('-** CSqBaseDeDonnees.Sqlite3_Connection()')
		
		try:
			#self._cnx = mysql.connector.connect(**config)
			print(self._fichier)
			self._cnx = sqlite3.connect(self._fichier)
			self._cursor = self._cnx.cursor()
			return self._cnx

		except:
			print('!!!!!!!!!!!!!!!!!!!!!!!!!!!! pb de sqlite3_Connection !!!!!!!!!!!!!!!!!!!')
			self._cnx=None
			pass		
		return self._cnx		
		
	def Connection(self):#1.5.3
		return self.Sqlite3_Connection()
		

	
	def Sqlite3_Select(self,texte):
		""" Sqlite3_Select(self,texte=None,typeuh="SELECT") """
		Tprint('-** CSqBaseDeDonnees.Sqlite3_Select() (>= 1.2)')
		return self.Sqlite3_Query(texte,typeuh="SELECT")		

	def Select(self,texte):
		""" Sqlite3_Select(self,texte=None,typeuh="SELECT") """
		Tprint('-** CSqBaseDeDonnees.Sqlite3_Select() (>= 1.2)')
		return self.Sqlite3_Select(texte)					
		
		
		
	def Sqlite3_Insere(self,texte=None):
		""" Sqlite3_Query(self,texte=None,typeuh="SELECT") """
		Tprint('-** CSqBaseDeDonnees.Sqlite3_Insere() (>= 1.2)')
		return self.Sqlite3_Query(texte,typeuh="INSERE")
			
	def Sqlite3_Update(self,texte=None):
		""" Sqlite3_Query(self,texte=None,typeuh="SELECT") """
		Tprint('-** CSqBaseDeDonnees.Sqlite3_Update() (>= 1.2)')
		return self.Sqlite3_Query(texte,typeuh="UPDATE")
				
	
	def Sqlite3_Insere_Multiple(self,table="table",DONNEES=[[],[]],typeuh="TabloTablo"): #V1.4
		""" insérer une données sous forme de [ champ 1,champ2 , champ3 .. ] """
		Tprint('-** CSqBaseDeDonnees.Sqlite3_Insere_Multiple()')
		typeuh=typeuh.upper()
		tchamps=self.Sqlite3_ListeChamps(table)		
					
		ENTETE='INSERT INTO `'+table+'`'		
		#INSERT INTO names (name, info, age) VALUES (%s, %s, %s)
		MILIEU=' ('		
		for t in tchamps:
			MILIEU+='`'+t+'`,'
		MILIEU=MILIEU[0:-1]+') VALUES (' +  ("%s ," * len(tchamps))[0:-1] +")"
		
		
		VALEURS=()
		if typeuh=="TABLOTABLO":
			for i in range(len(DONNEES)):
				DONNEES[i]=tuple(DONNEES[i])
			VALEURS=tuple(DONNEES)
		if typeuh=="CSV;":
			Dprint("DONNEES[0:2]",(DONNEES[0:2]))
			
			for i in range(len(DONNEES)):
				Dprint("DONNEES[i]",DONNEES[i])
				Dprint(tuple(DONNEES[i].split(';')))
				DONNEES[i]=tuple(DONNEES[i].split(';'))
			
			VALEURS=tuple(DONNEES)
			
		
		Dprint(ENTETE+MILIEU)
		Dprint(VALEURS)
		Dprint("-------- ENTETE+MILIEU -----\n"+ENTETE+MILIEU)
		Dprint("-------- ------------,VALEURS -----\n",VALEURS)
		Dprint('==')
		
		self.Sqlite3_QueryMultiple(ENTETE+MILIEU,VALEURS)
	
		
					
	def Sqlite3_QueryMultiple(self,INS,DON):#INS="INSERT INTO names (name, info, age) VALUES (%s, %s, %s)" # DON=(('Geert', info, 30), ('Jan', info, 31))
		""" Sqlite3_QueryMultiple : insère multiples données"""
		Tprint('-** CBaseDeDonnees.Sqlite3_QueryMultiple()')
		cursor = self._cnx.cursor()
		cursor.executemany(INS,DON)
		self._cnx.commit()
		"""
		names = (('dddddddd',5,8),('dddddddd',5,8))
		stmt_insert = "INSERT INTO tex (document,a,b) VALUES (%s, %s, %s)"
		cursor.executemany(stmt_insert, names)
		"""
		
	
	def Sqlite3_VideTable(self,table='table'):
		""" vide les données d'une table  ( >= V1.1.1 ) """
		Tprint('-** CSqBaseDeDonnees.Sqlite3_VideTable()')
		texte="TRUNCATE `"+table+"` ;"
		
		try:
			conn=self._cnx
			cursor = conn.cursor()
			res=cursor.execute(texte)
			Dprint("TRUNCATE effectué mais NON VERIFIE")
			return "TRUNCATE effectué mais NON VERIFIE"
		except Error as e:
			print(e)
			exit(1110)
			return None				
		self._cnx.commit()
		self._Tables=self.Sqlite3_ListeTables()
		return res
		
	def Sqlite3_ListeChamps(self,table='table'):
		Tprint('-** CSqBaseDeDonnees.Sqlite3_ListeChamps()')
		texte="SELECT * FROM  `"+table+"` ;"		
		names=[]
		champs=self.Sqlite3_Query(texte,"select")[1][0]

		self._ChampsDUneTable[table]=champs
		return champs
		
	def Sqlite3_ListeTables(self):#['RUNES', 'Zarmes0', 'Zarmes1', 'Zarmes2', 'armes', 'armures', 'boucliers', 'boucliers0', 'boucliersV2', 'races']
		Tprint('-** CSqBaseDeDonnees.Sqlite3_ListeTables()')
		"""
		tables=[]
		texte='show TABLES;'
		#texte="SELECT name FROM sqlite_master WHERE type ='table' AND name NOT LIKE 'sqlite_%';"
		resultats=self.Sqlite3_Query(texte,"show")[1]
		tables=[]
		for (resultat) in resultats:
			ligne=(list(resultat))
			tables+=ligne
			#print(ligne)
		self._Tables=tables
		"""
		self._Tables=[None]
		return self._Tables
		
	def ListeTables(self):
		Tprint('-** CSqBaseDeDonnees.ListeTables()')
		return self.Sqlite3_ListeTables()
		
		
	
	def Sqlite3_Query(self,texte=None,typeuh=None):
		""" Mysql_Query2(self,texte=None,typeuh=None)\n questionne la base de données (>= 1.2 )"""
		Tprint('-** CBaseDeDonnees.Sqlite3_Query() (>= 5.6.1 )')
		Dprint(texte)
		
		if typeuh!=None :
			typeuh=typeuh.upper()
			
		if typeuh==None:
			typeuh="NONE"
			
		if typeuh.upper()=="SELECT":#1.5.3
			"""
			try:
				conn=self._cnx#self.Mysql_Connection()
				cursor = conn.cursor()
				cursor.execute(texte)
				self._resultats=cursor.fetchall()
				
				self._NomsColonnes=cursor.column_names
				return [True,[self._NomsColonnes,self._resultats]]
				
			except Error as e:
				print(e)
				exit(132)
				return None
			"""
			try:
				self._cursor.execute(texte)
				self._resultats=self._cursor.fetchall()
				return [True,self._resultats]
			except Error as e:
				print(e)
				exit(667)
				return None
				
				
			"""
			finally:			
				cursor.close()
				conn.close()
			"""			
			
		if typeuh.upper()=="INSERE":
			try:
				conn=self._cnx
				cursor = conn.cursor()
				cursor.execute(texte)
				Dprint("INSEREE MAIS INSERTION NON VERIFIE")
				return [True,"INSEREE MAIS INSERTION NON VERIFIE"]
			except Error as e:
				print(e)
				exit(133)
				return None	

		if typeuh.upper()=="UPDATE":
			try:
				conn=self._cnx
				cursor = conn.cursor()
				cursor.execute(texte)
				Dprint("update")
				conn.commit()
				return [True,"update"]
			except Error as e:
				print(e)
				exit(134)
				return None	
				
		if typeuh.upper()=="SHOW":
			try:
				print("show")
				conn=self._cnx
				cursor = conn.cursor()
				cursor.execute("show tables;")
				self._resultats=cursor.fetchall()				
				conn.commit()
				return [True,self._resultats]
			except Error as e:
				print(e)
				exit(135)
				return None
				
		if typeuh=="NONE":
			try:
				print("none")
				conn=self._cnx
				cursor = conn.cursor()
				print(texte)
				cursor.execute(texte)
				conn.commit()
				return None
			except:# Error as e:
				#print(e)
				exit(728)
				return None
			


global main


	
def main():
	Dprint("Le programme lancé est "+sys.argv[0])
	
	print(_FonctionDuProgramme)
	print("version:"+_Version)

	config = {
		'host': 'localhost',
		'database': 'GPXs',
		'user': 'GPXs',
		'password': '2fdm2GPzrA1uWpQY',
	}
	
	BD=CBaseDeDonnees(config)
	
	"""
	BD.ListeChamps("points")
	BD.ListeTables()
	"""
		
	BD.Insere("aapoints",{"id":None,"fichier":"ll","id_du_fichier":321})

	
	
	#V1.6
	print('NNM=BD.Mysql_Select("SELECT `NomLong`,`NomCourt`,`md5` FROM `BLENDERS` WHERE `NomLong` LIKE \'%/media/homeuhW%\' LIMIT 0,2;")')
	print('NNM=BD.Mysql_Insere("...;")')
	print('NNM=BD.Mysql_Update("...;")')


	
	
	
	
if __name__ == "__main__":
	main()
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	

"""
texte="INSERT INTO tex (document,a,b) VALUES ('dddddddd',5,8)"
print(texte)
conn=BD._cnx#self.Mysql_Connection()
cursor = conn.cursor()
print('frr')
cursor.execute(texte)
"""
	
	
	
	
"""
#print (cursor)
cursor2 = cnx.cursor()
for (rid) in cursor:
	#print (rid)
	#print list(rid)
	cnx2 = mysql.connector.connect(user='windpy', password='d',host='127.0.0.1',database='wind09python')
	temp2=" select * from wind_patients_journalier where no_patient = "+str((list(rid))[0])+"  order by date,heure ";
	cursor2 = cnx2.cursor()
	cursor2.execute(temp2)
	for a in cursor2:
		b=list(a)
		#print(str(b[2]))
		date=str(b[2]).split('-')
		jour=int(date[2])
		mois=int(date[1])
		an=date[0]
		#print(b[1])
		#print(b[1],jour,mois,an,str(b[5]))#.split("'")[1])
		print('bpy.ops.mesh.primitive_cube_add(view_align=False, enter_editmode=False, location=('+str(multx*(jour+mois*31))+', '+str(multy*(b[1]))+', 0 ), rotation=(0, 0, 0), layers=(True, False, False, False, False, False, False, False, False, False, False, False, False, False, False, False, False, False, False, False))')

	cursor2.close()	
	#temp2=" select * from wind_patients_journalier where no_patient = 30  order by date,heure "
	#print (temp2)	
	'''cursor2.execute(temp2)
	for a in cursor2:
		print(a)
	'''

	#print("{}, {} was hired on {:%d %b %Y}".format(last_name, first_name, hire_date))
	#print("{}, {} was hired on {:%d}".format(rid))

#  

cursor.close()
cnx.close()
print(temp2)

#http://dev.mysql.com/doc/connector-python/en/myconnpy_example_connecting.html

'''



query = ("SELECT first_name, last_name, hire_date FROM employees "
         "WHERE hire_date BETWEEN %s AND %s")

temp="select * from `wind_patients` order by `no_centre`,`no_dans_le_centre`";
cursor.execute(temp)


temp2=" select * from `wind_patients_journalier` where `no_patient` = ".$row[0]."  order by `date`,`heure` ";  

hire_start = datetime.date(1999, 1, 1)
hire_end = datetime.date(1999, 12, 31)
cursor.execute(query, (hire_start, hire_end))
for (first_name, last_name, hire_date) in cursor:
	print("{}, {} was hired on {:%d %b %Y}".format(last_name, first_name, hire_date))
cursor.close()
cnx.close()
'''

#http://dev.mysql.com/doc/connector-python/en/myconnpy_example_connecting.html
"""








